function [err] = check_nobanks(mc,rk,w,R,h,k,wstar,Rk,q,infl, ...
    piw,ucz,I,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muz,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,Gamma,omegabar, ...
    Fomegabar,mu,gam,we,n,bigtheta,Gam_muG,psiL,sw,lambdafs,lambdaws,taud)

%these are checks on equations that are also in the cee model
[err] = check_nobanks1(mc,rk,w,R,h,k,wstar,Rk,q,infl, ...
    piw,ucz,I,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muz,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,lambdafs,lambdaws,taud);

%these are checks that reflect the presence of the equations pertaining to the entrepreneurs

%rate of return on capital
err(11)=Rk-infl/upsil*((1-tauk)*rk+(1-delta)*q)/q  -tauk*delta + 1;
%resource constraint:
G=Gamma-omegabar*(1-Fomegabar);
d=mu*G*(1+Rk)*q*k/(muz*infl);
err(17)=d+c+I+bigtheta*((1-gam)/gam)*(n-we)-yz+g; 
%zero profit condition on banks
err(22)=Gam_muG-((1+R)/(1+Rk))*(1-n/(q*k));
%law of motion of net worth
err(23)=n-(gam/(infl*muz))*(Rk-R-mu*G*(1+Rk))*k*q-we-gam*(1+R)*n/(infl*muz);
if sw == 0;%in this case, the zero profit condition on intermediate firms does not hold in steady state
    err(21)=0;
end
err(24)=((1-xiw*(pitildw*muz/piw)^(1/(1-lambdaw)))/(1-xiw))^(1-lambdaw*(1+sigmaL))*w*Fw/psiL-Kw;