function decomp_forecast(Xdat,F,H,Q,R,initxi,initV,l_z,l_psi,rho,A,B1,date,alf,taum,taub,taus,tausb,mm, ...
    trendm3,trendm1,tauvar,is,J,fdiff,nT,LL,parstoch,taushock,user)
   
T =size(Xdat,2);

date1 = [date(1:nT); [(date(nT)+0.25):0.25:(date(nT)+0.25*LL)]'];

if user == 1
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat(:,1:nT), F, H, Q, R, initxi, initV);
elseif user ==0
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat(:,1:nT),F,H,Q,R,initxi,initV,alf(tauvar'));
end

l_xxx = size(taum,1);

if length(tauvar) < l_xxx
    if is == 1
        HH    =   [taum,taub,taus,tausb];
    else
        HH    =   [taum,taub,taus];
    end
else
    HH = H;
end

givenames
[vbname,signal_on,III,IIII]=findnum(taushock,parstoch,l_psi,shockss);


zinit=xsmooth(1:l_z,end);
zinitm1 = xsmooth(l_z+1:2*l_z,end-1);
psiinit=xsmooth(2*l_z+1:end,end);

psi(:,1) = rho*psiinit;
z(:,1) = A*zinit + B1*psi(:,1);
z1(:,1) = A*zinit;
z2(:,1) = B1*rho*psiinit;
Xt(:,1) = taum*z+taub*zinit+taus*psi;
X1t(:,1) = taum*z1 + taub*zinit ;
X2t(:,1) = taum*z2 + taus*psi;

for ii = 2:LL
    psi(:,ii)=rho*psi(:,ii-1);
    z(:,ii) = A*z(:,ii-1)+B1*psi(:,ii);
    z1(:,ii)=A*z1(:,ii-1);
    z2(:,ii)=A*z2(:,ii-1) + B1*psi(:,ii);
    
    Xt(:,ii) =taum*z(:,ii)  +taub*z(:,ii-1)+taus*psi(:,ii);
    X1t(:,ii)=taum*z1(:,ii) + taub*z1(:,ii-1);
    X2t(:,ii)=taum*z2(:,ii) + taub*z2(:,ii-1) + taus*psi(:,ii);
end

if max(max(Xt-X1t-X2t))>1e-14
    error('fatal (decomp_forecast) there is a mistake in the decomposition')
end

for jj=1:length(III) %do it shock by shock
    psiinit_ = zeros(size(psiinit));
    psiinit_(III(jj):III(jj)+1,1) = psiinit(III(jj):III(jj)+1,1);
    if max(signal_on==taushock(jj))==1
        psiinit_(III(jj):III(jj)+1+parstoch(taushock(jj)),1) = psiinit(III(jj):III(jj)+1+parstoch(taushock(jj)),1);
    end
    z3(:,1) = B1*rho*psiinit_;
    psi_(:,1) = rho*psiinit_;
    X3t(:,1) = taum*z3 + taus*psi_;
    
    for ii = 2:LL
        psi_(:,ii)=rho*psi_(:,ii-1);
        z3(:,ii)=A*z3(:,ii-1) + B1*psi_(:,ii);

        X3t(:,ii)=taum*z3(:,ii) + taub*z3(:,ii-1) + taus*psi_(:,ii);
    end
    X4t(:,:,jj) = X3t;
    clear X3t z3 psi_
end

for kk = 1:size(taum,1)
    for ii = 1:LL
        for jj = 1:length(III)
           X5t(ii,jj,kk) = X4t(kk,ii,jj);
        end
    end
end

jk=1;
for kk = 1:size(taum,1)
    ab = X5t(:,:,kk);
    if max(sum(ab,2) - (X2t(kk,:))') > 1e-14
        error('fatal (decomp_forecast) there is a mistake in the decomposition')
    end
    if max(tauvar==kk)==1
        X6t(:,:,jk) = ab;
        jk=jk+1;
    end
end

[nameshocks,nameXXX] = getnames(fdiff);
nameXXX = nameXXX(tauvar,:);

Xt  = J*Xt;
X1t = J*X1t;
X2t = J*X2t;
%figure, orient landscape
for ii =1:size(Xdat,1)
        %Xshow = [X1t(ii,:)',X2t(ii,:)'];
        X_vbj = X6t(:,:,ii);
        %if ii==2;   X_vbj = [X_vbj(:,[9 14]) sum(X_vbj(:,[1 2 3 4 5 6 7 8 10 11 12 13 15]),2)];  end
        %if ii==5;   X_vbj = [X_vbj(:,[9 11 14]) sum(X_vbj(:,[1 2 3 4 5 6 7 8 10 12 13 15]),2)];  end
        
        Xshow = [X1t(ii,:)',X_vbj]; 
        
        barp  = zeros(size(Xshow));
        barn  = zeros(size(Xshow));

        for jkl = 1:size(Xshow,1);  
        xshow    = Xshow(jkl,:);
        indexn    = find(xshow<0);
        indexp    = find(xshow>=0);
        xshowp = xshow(indexp);
        xshown = xshow(indexn);  
        barp(jkl,indexp) = xshowp;
        barn(jkl,indexn) = xshown;
        end
        
    %subplot(4,4,ii)   
    figure('name',nameXXX(ii,:)), orient landscape
    hold on
    bar(date1(nT+1:end),barp,'stacked')
    %colormap gray
    bar(date1(nT+1:end),barn,'stacked')
    %colormap gray
    %colormap([0 1 0; 1 1 0])
    plot(date1(nT+1:end),Xt(ii,:),'r-',date1(nT:T),Xdat(ii,nT:T),'k-*', 'LineWidth', 2)
    
    hold off
    grid on
    axis tight
    %title(nameXXX(ii,:))
    %legend('Endogenous Persistence','Shock Persistence','Location','SouthEast')
    title({['{\fontsize{10} \bf Figure: } ' nameXXX(ii,:) ' Decomposing Unconditional Forecast (red line) in Contribution']; ' from Endogenous and Shock Persistence. Starred Line is Actual (demeaned) Data)'});
    legend(char('Endogenous Persistence',shockss(taushock,:)),'Location','SouthEast')
end
%hout=suptitle('\fontsize{10} \bf Figure: Decomposing Unconditional Forecast (red line) in Contribution from Endogenous and Shock Persistence. Starred Line is Actual (demeaned) Data)');
