function [] = eurotable(phi,beta,psiL,sigmaL,v,sigmaq,theta,Hdoupr,b,xiw,lambdaw,muzstar,Sdoupr,sigmaa,xip,psik,psil,delta,alpha, ...
            lambdaf,gamma,mu,Fomegabar,omegabar,sigma,xi,xb,tau,tauc,tauk,taul,x,k,y,i,c,g,rk,n,we,Rk,vl,pi,m,mb,w,l, ...
            her,Re,R,Ra,RT,Rm,Rb,dm,chii,chorse,bigtheta,upsil,m3,m1,currdep,vn,name,entr,params)

if entr == 1 || entr==2 || entr==-3 || entr==-4
    [G,Gamma,Gammap,Gammadp,Gammas,Gammaps,Gp,Gdp,Gs,Gps,lambda] = const(omegabar,sigma,mu,1);
    rob1 = omegabar*(Gammap-mu*Gp)/(Gamma-mu*G);
    rob2 = (1-Gamma)*(1+Rk)/(1+Re)*(Gammadp*omegabar/Gammap - lambda*omegabar*(Gammadp-mu*Gdp)/Gammap);
    elasticity_leverage = (1/(k/n-1))*1/(1+lambda*rob1/rob2);
    
    rob3 = rob1*(1+Rk)/(1+Re) * (sigma*(-Gammas+lambda*(Gammas-mu*Gs)) - (1-Gamma)*(Gammaps*sigma/Gammap - lambda*(Gammaps-mu*Gps)*sigma/Gammap) ); 
    elasticity_sigma = ( (Gammas - mu*Gs)*sigma/(Gamma-mu*G) + rob3 / rob2 ) / (1+ lambda*rob1/ rob2);
    
    rob4 = mu*( G/(Gamma-mu*G) + (Gammap-mu*Gp)/(Gamma-mu*G)*omegabar*lambda*(1+Rk)/(1+Re)*( (1-Gamma)*Gp/Gammap+G) * 1/rob2);
    elasticity_mu = rob4 / (1+ lambda*rob1/ rob2);
    
    Z=omegabar*(1+Rk)*k/(k-n);  
    Za=1+Re+(mu*G*(1+Rk)*k/(k-n));
else
    Gamma=0; Gammap=0; Gammadp=0; Gammas=0; Gammaps=0; G=0; Gp=0; Gdp=0; Gs=0; Gps=0; lambda=0;
    Z=1;
end

fid = fopen(name,'w');
fprintf(fid,' \\documentclass{article} \n');
fprintf(fid,' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \n');
fprintf(fid,' \\usepackage{amsfonts} \n');
fprintf(fid,' \\usepackage{amsmath} \n');

fprintf(fid,' \\setcounter{MaxMatrixCols}{10} \n');
fprintf(fid,' %%TCIDATA{OutputFilter=LATEX.DLL} \n');
fprintf(fid,' %%TCIDATA{Version=4.10.0.2345} \n');
fprintf(fid,' %%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \n');
fprintf(fid,' %%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \n');
fprintf(fid,' %%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \n');
fprintf(fid,' %%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\Standard LaTeX Article">} \n');
fprintf(fid,' %%TCIDATA{CSTFile=40 LaTeX article.cst} \n');

fprintf(fid,' \\newtheorem{theorem}{Theorem} \n');
fprintf(fid,' \\newtheorem{acknowledgement}[theorem]{Acknowledgement} \n');
fprintf(fid,' \\newtheorem{algorithm}[theorem]{Algorithm} \n');
fprintf(fid,' \\newtheorem{axiom}[theorem]{Axiom} \n');
fprintf(fid,' \\newtheorem{case}[theorem]{Case} \n');
fprintf(fid,' \\newtheorem{claim}[theorem]{Claim} \n');
fprintf(fid,' \\newtheorem{conclusion}[theorem]{Conclusion} \n');
fprintf(fid,' \\newtheorem{condition}[theorem]{Condition} \n');
fprintf(fid,' \\newtheorem{conjecture}[theorem]{Conjecture} \n');
fprintf(fid,' \\newtheorem{corollary}[theorem]{Corollary} \n');
fprintf(fid,' \\newtheorem{criterion}[theorem]{Criterion} \n');
fprintf(fid,' \\newtheorem{definition}[theorem]{Definition} \n');
fprintf(fid,' \\newtheorem{example}[theorem]{Example} \n');
fprintf(fid,' \\newtheorem{exercise}[theorem]{Exercise} \n');
fprintf(fid,' \\newtheorem{lemma}[theorem]{Lemma} \n');
fprintf(fid,' \\newtheorem{notation}[theorem]{Notation} \n');
fprintf(fid,' \\newtheorem{problem}[theorem]{Problem} \n');
fprintf(fid,' \\newtheorem{proposition}[theorem]{Proposition} \n');
fprintf(fid,' \\newtheorem{remark}[theorem]{Remark} \n');
fprintf(fid,' \\newtheorem{solution}[theorem]{Solution} \n');
fprintf(fid,' \\newtheorem{summary}[theorem]{Summary} \n');
fprintf(fid,' \\newenvironment{proof}[1][Proof]{\\noindent\\textbf{#1.} }{\\ \\rule{0.5em}{0.5em}} \n');
fprintf(fid,' \\input{tcilatex} \n');


fprintf(fid,' \\begin{document} \n');
fprintf(fid,' \\begin{equation*} \n');


fprintf(fid,' \\begin{tabular}{|c|l|c|c|} \\hline \n');
fprintf(fid,' \\multicolumn{4}{|c|}{Table 1: Model Parameters, EA and US (Time unit of Model: quarterly)} \\\\ \\hline \n');
fprintf(fid,' \\  &  & Euro Area & US \\\\  \n');
fprintf(fid,' \\multicolumn{4}{|c|}{Panel A: Household Sector} \\\\ \\hline \n');


%Household
fprintf(fid,' $\\beta $ & Discount rate & \\multicolumn{1}{|l|}{%6.4g} &  \\\\ \\hline \n',beta);
fprintf(fid,' $\\psi _{L}$  & Weight on Disutility of Labor & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',psiL);
fprintf(fid,' $\\sigma _{L}$ & Curvature on Disutility of Labor & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',sigmaL);
if entr==1 || entr==2 || entr==0
fprintf(fid,' $\\upsilon $ & Weight on Utility of Money & \\multicolumn{1}{|l|}{%6.4g} \\\\ \\hline \n',v);
fprintf(fid,' $\\sigma _{q}$ & Curvature on Utility of money & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',sigmaq);
fprintf(fid,' $\\theta $ & Power on Currency in Utility  & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',theta);
fprintf(fid,' $\\chi $ & Power on Saving Deposits in Utility & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',chii);
end
fprintf(fid,' $b$ & Habit persistence parameter& \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',b);
fprintf(fid,' $\\xi _{w}$ & Fraction of households that cannot reoptimize wage within a quarter& \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',xiw);
fprintf(fid,' $\\lambda _{w}$ & Steady state markup, suppliers of labor & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',lambdaw);

%Goods-Producing Sector
fprintf(fid,' \\multicolumn{4}{|c|}{Panel B: Goods Producing Sector} \\\\ \\hline \n');
fprintf(fid,' $\\mu _{z}$ & Growth Rate of the economy (APR) & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',100*(muzstar^4-1));
fprintf(fid,' $S^{\\prime \\prime }$ & Curvature on Investment Adjustment Cost & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',Sdoupr);
fprintf(fid,' $\\sigma _{a}$ & Curvature on capital utilization cost function & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',sigmaa);
fprintf(fid,' $\\xi _{p}$ & Fraction of intermediate good firms that cannot reoptimize price within a quarter & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',xip);
fprintf(fid,' $\\psi _{k}$ & Fraction of capital rental costs that must be financed & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',psik);
fprintf(fid,' $\\psi _{l}$ & Fraction of wage bill that must be financed & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',psil);
fprintf(fid,' $\\delta $ & Depreciation rate on capital. & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',delta);
fprintf(fid,' $\\alpha $ & Power on capital in production function & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',alpha);
fprintf(fid,' $\\lambda _{f}$ & Steady state markup, intermediate good firms & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',lambdaf);
fprintf(fid,' $\\Phi $ & Fixed cost, intermediate goods & \\multicolumn{1}{|l|}{%5.3f} \\\\ \\hline \n',phi);

if entr == 1 || entr==2 || entr==-3 ||entr==-4
    %Entrepreneurs
    fprintf(fid,' \\multicolumn{4}{|c|}{Panel C: Entrepreneurs} \\\\ \\hline \n');
    fprintf(fid,' $\\gamma $ & Percent of Entrepreneurs Who Survive From One Quarter to the Next & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',gamma*100);
    fprintf(fid,' $\\mu $ & Fraction of Realized Profits Lost in Bankruptcy & \\multicolumn{1}{|l|}{%5.3f} \\\\ \\hline \n',mu);
    fprintf(fid,' $F(\\bar{\\omega})$ & Percent of Businesses that go into Bankruptcy in a Quarter & \\multicolumn{1}{|l|}{%5.2f} \\\\ \\hline \n',100*Fomegabar); 
    fprintf(fid,' $Var(log$($\\omega ))$ & Variance of (Normally distributed) log of idiosyncratic productivity parameter & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',sigma^2);
end

if entr == 1 || entr==2 || entr == 0
    %Banking Sector
    fprintf(fid,' \\multicolumn{4}{|c|}{Panel D: Banking Sector} \\\\ \\hline \n');
    fprintf(fid,' $\\xi $ & Power on Excess Reserves in Deposit Services Technology & \\multicolumn{1}{|l|}{%6.4f} \\\\ \\hline \n',xi);
    fprintf(fid,' $x^{b}$  & Constant In Front of Deposit Services Technology & \\multicolumn{1}{|l|}{%6.4f} \\\\ \\hline \n',xb);
end

%Policy
fprintf(fid,' \\multicolumn{4}{|c|}{Panel E: Policy} \\\\ \\hline \n');
if entr == 1 || entr ==2 || entr == 0
    fprintf(fid,' $\\tau $ & Bank Reserve Requirement & \\multicolumn{1}{|l|}{%5.3f} \\\\ \\hline \n',tau);
end
fprintf(fid,' $\\tau ^{c}$ & Tax Rate on Consumption & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',tauc);
fprintf(fid,' $\\tau ^{k}$ & Tax Rate on Capital Income & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',tauk);
fprintf(fid,' $\\tau ^{l}$ & Tax Rate on Labor Income & \\multicolumn{1}{|l|}{%4.2f} \\\\ \\hline \n',taul);
if entr==1 || entr==2 || entr==0
fprintf(fid,' $x$ & Growth Rate of Monetary Base (APR)& \\multicolumn{1}{|l|}{%5.3f} \\\\ \\hline \n',100*((1+x)^4-1));
end

fprintf(fid,' \\end{tabular}%% \n');
fprintf(fid,' \\end{equation*}%% \n');


fprintf(fid,' \\pagebreak \n'); 
fprintf(fid,' \\begin{equation*} \n');
fprintf(fid,' \\begin{tabular}{|c|l|l|l|l|} \\hline \n');
fprintf(fid,' \\multicolumn{5}{|c|}{Table 2: Steady State Properties, Model versus Data, EA and US} \\\\ \\hline \n');
fprintf(fid,' Variable & Model, EA & Data, EA 1998:1-2003:4& Model, US & Data, US 1998:1-2003:4 \\\\ \\hline \n');
fprintf(fid,' \\multicolumn{1}{|l|}{$\\frac{k}{y}$} & %5.2f & 12.5$^{1}$&  & 10.7$^{2}$ \\\\ \\hline \n',k/y);
fprintf(fid,' \\multicolumn{1}{|l|}{$\\frac{i}{y}$} & %5.2f & 0.20$^{3}$ & & 0.25$^{4}$ \\\\ \\hline \n',i/y);
fprintf(fid,' \\multicolumn{1}{|l|}{$\\frac{c}{y}$} & %5.2f & 0.57 & & 0.56 \\\\ \\hline \n',c/y);
fprintf(fid,' \\multicolumn{1}{|l|}{$\\frac{g}{y}$} & %5.2f & 0.23 & & 0.20 \\\\ \\hline \n',g/y);
fprintf(fid,' \\multicolumn{1}{|l|}{$r^{k}$} & %5.3f &  & & \\\\ \\hline \n',rk);
if entr == 1 || entr==2 || entr==-3 || entr==-4
    fprintf(fid,' \\multicolumn{1}{|l|}{ $\\frac{N}{K-N} $ (''Equity to Debt'') } & %5.2f & 1.08-2.19$^{5} $ &  &>4.7$^{6} $ \\\\ \\hline \n',n/(k-n) );
    fprintf(fid,' \\multicolumn{1}{|l|}{Transfers to Entrepreneurs (as \\%% of Goods Output)} & %5.2f\\%% &  & & \\\\ \\hline \n',100*(we/(c+i+g)));
    fraction=(mu*G*(1+Rk)*k/(muzstar*pi))/(c+i+g);
    entcon=bigtheta*(1-gamma)*(n-we)/gamma;
    fprintf(fid,' \\multicolumn{1}{|l|}{Banks Monitoring Costs (as \\%% of Output Goods)} & %5.2f\\%% &  & & \\\\ \\hline \n',100*fraction);
    fprintf(fid,' \\multicolumn{1}{|l|}{Output Goods (in \\%%) Lost in Entrepreneurs Turnover} & %5.2f\\%% &  &  &\\\\ \\hline \n',100*entcon/(c+i+g));
end 
if entr==1 || entr==2 || entr==0
fprintf(fid,' \\multicolumn{1}{|l|}{Percent of Aggregate Labor and Capital in Banking} & \n'); 
fprintf(fid,' %5.2f\\%% &  & & 5.9\\%%$^{7}$ \\\\ \\hline \n',(1-vl)*100);
end
fprintf(fid,' \\multicolumn{1}{|l|}{Inflation (APR)} & %5.2f\\%% & 1.84\\%%$^{8}$ & &2.32\\%%$^{9}$ \\\\ \\hline \n',(pi^4-1)*100);
if entr ==-3 || entr==-4
    fprintf(fid,' \\multicolumn{1}{|l|}{Long-term Assets} & %5.2f\\%% & 4.86\\%% & & 5.99\\%%   \\\\ \\hline \n',((1+Re)^4-1)*100);
    fprintf(fid,' \\multicolumn{1}{|l|}{Rate of Return on Capital, $R^{k}$} & %5.2f\\%% & 8.23\\%% & & \\%%   \\\\ \\hline \n',((1+Rk)^4-1)*100);
    fprintf(fid,' \\multicolumn{1}{|l|}{Cost of External Finance, $Z$} & %5.2f\\%% & {4.3-6.3} & & 7.1-8.1 \\\\ \\hline \n',(Z^4-1)*100);
    fprintf(fid,' \\multicolumn{1}{|l|}{Short-term Risk-free Rate, $R^{e}$} & %5.2f\\%% & 3.60 & & 5.12 \\\\ \\hline \n',((1+Re)^4-1)*100);
end

fprintf(fid,' \\end{tabular}%% \n');
fprintf(fid,' \\end{equation*}%% \n');

fprintf(fid,' {\\small Note: }$^{1}${\\small Capital stock includes also government capital, as disaggregated data are not available. Source: Euro Area Wide Model (EAWM), G.Fagan, J.Henry and R.Mestre (2001)}\n');
fprintf(fid,' $^{2}${\\small Capital stock includes private non-residential fixed assets, private residential, stock of consumer durables and stock of private inventories. Source: BEA.}\n');
fprintf(fid,' $^{3}${\\small Investment includes also government investment and does not include durable consumption, as disaggregated data are not available. Source: EAWM.}\n');
fprintf(fid,' $^{4}${\\small Investment includes residential, non-residential, equipment, plants, business durables, change in inventories and durable consumption. Source: BEA.}\n');
fprintf(fid,' $^{5}${\\small The equity to debt ratio for corporations in the euro area is 1.08 in 1995, 2.19 in 1999 and afterwards moves down reaching 1.22 in 2002. Taking into account the unusual movements in asset prices in the second half of the 1990s, the steady-state equity to debt ratio is probably closer to the lower end of the range reported in the Table. Debt includes loans, debt securities issued and pension fund reserves of non-financial corporations. Equity includes quoted and non-quoted shares. Source: Euro area Flow of Funds.} \n');
fprintf(fid,' $^{6}${\\small E.McGrattan and E.Prescott (2004) estimates the equity to debt ratio for the corporate sector over the period 1960-2001. Over the period 1960-1995 the ratio is quite stable and averaged at 4.7. In 1995 it started exhibiting an extraordinary rise. In 2001, the last year included in their sample, the ratio is 60. The unprecedented sharp rise that occurred in the second half of the 1990s makes the calibration of such ratio for the purpose of our analysis very difficult. For comparison, Masulis (1988) reports an equity to debt ratio for US corporations in the range of 1.3-2 for the period 1937-1984.} \n');
fprintf(fid,' $^{7}${\\small Based on analysis of data on the finance, insurance and real estate sectors over the period 1987-2002.}\n');
fprintf(fid,' $^{8}${\\small Average inflation (annualised), measured using GDP deflator}.} \n');
fprintf(fid,' $^{9}${\\small Average inflation (annualised), measured using GDP Price Index over the period 1987-2003.} \n');

fprintf(fid,' \\pagebreak  \n');

if entr == 1 || entr==2
    fprintf(fid,' \\begin{equation*} \n');
    fprintf(fid,' \\begin{tabular}{|c|c|c|c|c|c|c|c|} \n');
    fprintf(fid,' \\hline \n');
    fprintf(fid,' \\multicolumn{8}{|c|}{Table : Consolidated Banking Sector Balance Sheet, Model versus Data} \\\\ \\hline \n');
    fprintf(fid,' Variable & Model &Euro area&US 1995-2001& Variable & Model &Euro area&US 1995-2001\\\\ \\hline \n');
    TA=(mb/(pi*muzstar))*(1-m) + psil*w*l + psik*rk*k/(muzstar*upsil) + (k-n)/(pi*muzstar);
    Assets=(mb/(pi*muzstar))*(1-m) + psil*w*l + psik*rk*k/(muzstar*upsil);
    Reserves=(1-m)*(mb/(pi*muzstar))/Assets;
    RReserves=tau*(1-m + psil*pi*muzstar*w*l/mb + psik*pi*rk*k/(upsil*mb))*(mb/(pi*muzstar)) / Assets;
    EReserves=((1-m)*(mb/(pi*muzstar))/Assets) - RReserves;
    WkKloans= (psik*rk*k/(muzstar*upsil)) / Assets;
    WkLloans= (psil*w*l) / Assets;
    Wkloans=WkKloans+WkLloans;
    Entloans=((k-n)/(muzstar*pi))/TA;
    DDh=(mb/(pi*muzstar))*(1-m)/Assets;
    DDf=(psil*w*l+psik*rk*k/(muzstar*upsil))/Assets;
    DD=DDh+DDf;
    fprintf(fid,' \\multicolumn{1}{|l|}{Assets (Fraction of Annual GNP)} & \\multicolumn{1}{|l|}{%5.3f} &  \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{Liabilities (Fraction of Annual GNP)} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.604} \\\\ \\hline \n',TA/(4*(c+i+g)),TA/(4*(c+i+g)));
    fprintf(fid,' \\multicolumn{1}{|l|}{Total Reserves} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.081} & \\multicolumn{1}{|l|}{Total Demand Deposits} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{1.0} \\\\ \\hline \n',Reserves,DD);
    fprintf(fid,' \\multicolumn{1}{|l|}{$\\circ $  Required Reserves} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.052} & \\multicolumn{1}{|l|}{$\\circ $  Firm Demand Deposits} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.523} \\\\ \\hline \n',RReserves,DDf);
    fprintf(fid,' \\multicolumn{1}{|l|}{$\\circ $  Excess Reserves} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.029} & \\multicolumn{1}{|l|}{$\\circ $  Household Demand Deposits} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.477} \\\\ \\hline \n',EReserves,DDh);
    fprintf(fid,' \\multicolumn{1}{|l|}{Working Capital Loans} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.919} & \\multicolumn{1}{|l|}{}& \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{}\\\\ \\hline \n',Wkloans);
    fprintf(fid,' \\multicolumn{1}{|l|}{$\\circ $  Capital Rental Expenses} & \\multicolumn{1}{|l|}{%5.3f} & \n',WkKloans); 
    fprintf(fid,' \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} &  \n');
    fprintf(fid,' \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} \\\\  \n');
    %fprintf(fid,' \\hline \n',WkKloans);
    fprintf(fid,' \\multicolumn{1}{|l|}{$\\circ $  Wage Bill Expenses} & \\multicolumn{1}{|l|}{%5.3f} &  \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{} \\\\ \\hline \n',WkLloans);
    fprintf(fid,' \\multicolumn{1}{|l|}{Entrepreneurial Loans} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.828} & \\multicolumn{1}{|l|}{Time Deposits} & \\multicolumn{1}{|l|}{%5.3f} & \\multicolumn{1}{|l|}{} & \\multicolumn{1}{|l|}{0.828} \\\\ \\hline \n',Entloans,Entloans);
    fprintf(fid,' \\end{tabular}%% \n');
    
    fprintf(fid,' \\end{equation*}%% \n');
    fprintf(fid, '\\bigskip \n');
    
    fprintf(fid, '{\\small Notes on Table :  \n');
    fprintf(fid, 'The first line shows the ratio of these to annual goods output. With the exception of the bottom row of \n');
    fprintf(fid, 'numbers, remaining entries in the table are expressed as a fraction of bank reserves plus working capital loans. \n');
    fprintf(fid, 'The bottom row of numbers is expressed as a fraction of total assets. \n\n');
    
    fprintf(fid, 'Data for the US: working-capital loans are defined as total demand deposits minus total reserves. This number \n');
    fprintf(fid, 'is the same order of magnitude as the sum of short-term bank loans with maturity 24 months or less (taken from \n');
    fprintf(fid, 'the Fed''s ''Banking and Monetary Statistics'') and commerical paper (Table \n');
    fprintf(fid, 'L101 in Flow of Funds) \n');
    fprintf(fid, 'Long-term entrepreneurial loans are defined as the total liabilities of \n');
    fprintf(fid, 'the non-financial business sector (non-farm non-financial corporate business \n');
    fprintf(fid, 'plus non-farm non-corporate business plus farm business) net of municipal \n');
    fprintf(fid, 'securities, trade payables, taxes payables, ''miscellaneous liabilites'' and the \n');
    fprintf(fid, 'working capital loans.} \n');
    fprintf(fid, '{\\small Source: With exception of required and excess reserves, the source \n');
    fprintf(fid, 'is the Federal Reserves'' Flow of Funds'' data. Required and excess reserves \n');
    fprintf(fid, 'are obtained from Federal Reserve Bank of St. Louis.} \n\n');
    fprintf(fid,  ' \\pagebreak  \n');
end

%housefirm=(1-m+x)/((psil*w*l+psik*rk*k/(muzstar*upsil))/mb );
if entr==0 || entr==1 || entr==2
begin = params(71);
if begin ==1
    velocitymb=4*y*pi*muzstar/mb;
    velocitycredit= 4*y/( (psil*w*l+psik*rk*k/(muzstar*upsil))+(k-n)/(muzstar*pi));
elseif begin ==0
    velocitymb=4*y/mb;
    velocitycredit= 4*y/( (psil*w*l+psik*rk*k/(muzstar*upsil))+(k-n) );
end
end

fprintf(fid, '\\begin{equation*}  \n');
fprintf(fid, '\\begin{tabular}{|c|c|c|c|c|c|c|c|c|c|}  \n');
fprintf(fid, '\\hline  \n');
fprintf(fid, '\\multicolumn{10}{|c|}{Table 3: Money and Interest Rates. Model versus Data, EA and US}  \\\\ \\hline  \n');
fprintf(fid, 'Money & Model, EA & Data, EA & Model, US & Data, US & Interest Rates (APR) & Model, EA &   \n');
fprintf(fid, 'Data, EA & Model, US & Data, US \\\\ \\hline  \n');
if entr ==1 || entr==2 || entr==0
    velocitym1=4*y/m1;
    velocitym3=4*y/m3;

    fprintf(fid, '\\multicolumn{1}{|l|}{M1 Velocity} & \\multicolumn{1}{|l|}{%5.2f} &  \\multicolumn{1}{|l|}{3.31} & & 6.92& \\multicolumn{1}{|l|}{Demand Deposits, $R^{a}$} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{0.76} &  & \\\\ \\hline  \n',velocitym1,((1+Ra)^4-1)*100);
    fprintf(fid, '\\multicolumn{1}{|l|}{Broad Money Velocity} &  \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{1.32} &  & 1.51 & \\multicolumn{1}{|l|}{Saving Deposits, $R^{m}$} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{2.66} & &  \\\\ \\hline  \n',velocitym3,((1+Rm)^4-1)*100);
    fprintf(fid, '\\multicolumn{1}{|l|}{Base Velocity} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{14.83} &  & 23.14 & \\multicolumn{1}{|l|}{Long-term Assets} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{4.86} &  & 5.99 \\\\ \\hline  \n',velocitymb,((1+Re)^4-1)*100);
    fprintf(fid, '\\multicolumn{1}{|l|}{Currency/Base} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{0.69} &  & 0.75& \\multicolumn{1}{|l|}{Rate of Return on Capital, $R^{k}$}& \\multicolumn{1}{|l|}{%5.2f}& \\multicolumn{1}{|l|}{8.32} &  &  \\\\ \\hline  \n',m,((1+Rk)^4-1)*100);
    fprintf(fid, '\\multicolumn{1}{|l|}{Currency/Total Deposits} &  \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{0.06} &  & 0.05 & \\multicolumn{1}{|l|}{Cost of External Finance, $Z$} & \\multicolumn{1}{|l|}{%5.2f} &  \\multicolumn{1}{|l|}{4.3-6.3} &  & 7.1-8.1 \\\\ \\hline  \n',currdep,(Z^4-1)*100);
    fprintf(fid, '\\multicolumn{1}{|l|}{(Broad Money-M1)/Base} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{6.76} &  & 12.16 & \\multicolumn{1}{|l|}{Gross Rate on Work. Capit. Loans} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{} &   & 7.07 \\\\ \\hline  \n',dm,100*((1+R+Ra)^4-1) );
    fprintf(fid, '\\multicolumn{1}{|l|}{Credit Velocity} & \\multicolumn{1}{|l|}{%5.2f }& \\multicolumn{1}{|l|}{} &  & 3.25& \\multicolumn{1}{|l|}{Time Deposits, $R^{e}$} & \\multicolumn{1}{|l|}{%5.2f} & \\multicolumn{1}{|l|}{3.60} &  & 5.12 \\\\ \\hline  \n',velocitycredit,100*((1+Re)^4-1));
end

fprintf(fid, '\\end{tabular}%%  \n');
fprintf(fid, '\\end{equation*}  \n');

fprintf(fid, '{\\small Notes to Table : }  \n\n');

fprintf(fid, '{\\small Data for the Euro area: the sample is 1998:4-2003:4 } \n\n');
fprintf(fid, '{\\small (1) ''Broad Money'' is M3. \n');
fprintf(fid, '{\\small (2) The interest rate on ''Demand Deposits'' is the overnight rate. (3) The interest rate on ''Saving Deposits'' is the own rate on (M3-M1). \n');
fprintf(fid, '(4) The interest rate on ''Longer-term Assets'' is the rate on 10-years Government Bonds.}  \n');
fprintf(fid, '{\\small (5) The ''Rate of Return on Capital'' is the Net Return on Net Capital Stock. Source: European Commission.}  \n');
fprintf(fid, '{\\small (6) Cost of ''External Finance'': We consider 3 different measures. First, we construct a weighted average of the spread between short-term bank lending rates to enterprises and the risk-free rate of corresponding maturity, the spread between long-term bank lending rates and the risk-free rate of corresponding maturity, the spread between yields on corporate bonds and the risk-free rate of corresponding maturity. We use outstanding amounts as weights. The spread is 67 b.p. Second, we consider an alternative measure for the spread suggested by De Fiore and Uhlig (2005), which amounts to 267 b.p. Third, we consider the spread between BAA and AAA, which amounts at 135 b.p. Adding these spreads to our measure of the risk-free rate gives the range displayed in the table.}  \n');
%fprintf(fid, '{\\small (5) The interest rate on working capital loans is .....}  \n');
fprintf(fid, '{\\small (7) The Rate on ''Time Deposits'' is the 3-month Euribor.}  \n\n');

fprintf(fid, '{\\small Data for the US: the left column refers to 1959-2003; the right column to 1987:1-2003:4.} \n\n');
fprintf(fid, '{\\small (1) ''Broad Money'' is M2.}  \n');
fprintf(fid, '{\\small (2) The interest rate on ''Longer-term Assets'' is the rate on 10-years Government Bonds.}  \n');
%fprintf(fid, '{\\small (3) The ''Rate of Return on Capital'' is the rate of profit on stockholders equity for the manufacturing sector (1980.1-2001.4). Source: \n');
%fprintf(fid, 'Bureau of the Census (2002), Table I. }  \n');
fprintf(fid, '{\\small (3) Rate of Return on Capital: based on Mulligan''s (2002) estimate of the real return over the period 1987-1999 to which we added average inflation.}  \n');
fprintf(fid, '{\\small (4) Cost of ''External Finance'': Bernanke, Gertler and Gilchrist (1999) suggest a spread of 200 b.p. over the risk-free rate. Levin, Natalucci and Zakrajsek (2004) find a spread of 227 b.p. for the median firm in their sample over 1997-2003. De Fiore and Uhlig (2005) find a spread of 298 b.p. Adding these spreads to our measure of the risk-free rate gives the range displayed in the table. }  \n');
fprintf(fid, '{\\small (5) The rate on ''Working Capital Loans'' is the rate on commercial and industrial loans.\n');
fprintf(fid, 'Source: Survey of terms of business lending. Federal Reserve Board of Governors.}  \n');
fprintf(fid, '{\\small (6) The Rate on ''Time Deposits'' is the Federal Funds Rate.}  \n');

fprintf(fid,' \\end{document} \n');
fclose(fid);


