%Exercise A: swap shocks 

clear all

load d:\banking\exerciseA\inputs A taus taum taub  %(based on parameterseuro and estimated ea elasticities; ea policy rule)
load d:\banking\exerciseA\inputs1 rho % (based on: (1) estimated US stochastic parameters; (2) without switching-off M transformation
load d:\banking\exerciseA\inputs3 B1 % (based on: (1) estimated US stochastic parameters; (2) EA A
load d:\banking\swaprules\inputs2 psi z % psi z ((based on parameterseuro, estimated ea elasticities, ea policy rule, ea shocks); without switching out M transformation
load d:\banking\exerciseA\innovation_us err %contains err for US without switching-off M transformation

% err(9:10,:)=err(9:10,:)*(1-0.55)/(1-0.4851); %adjustment of chii shock in accordance with M transformation
% err(15:16,:)=err(15:16,:)*(1-0.9762)/(1-0.978); %%adjustment of gamma shock in accordance with M transformation

err_us=err;
clear err
load d:\banking\swaprules\innovations_ea err %err is the one estimated for the euro area model without switching out M transformation

err_ea=err;
clear err

%err_us(1:2,:) = err_us(1:2,:).*(0.0288/0.2375); %the estimated lambdaf shock has to be transformed multiplying it by the inverse of the coefficient in front of lambdaf in the Phillips curve: i.e. the inverse of (1-beta*xip)*(1-xip)/(xip*(1+beta*iota2)). This gives us the true lambdaf. Then it has to be multiplied by (1-beta*xip)*(1-xip)/(xip*(1+beta*iota2)) evaluated at the EA estimate

psi0=psi;
z0=z;
clear psi z

date= [1983.25:0.25:2006.00]';

a=56; %56=1997:1; 60=1998:1;  48=1995:1

%err_ea([19:20],a:end)=0; %You activate this if you want to see what happens,
%had the ECB not deviated from its rule under US shocks.

err_us([3:4,19:20],:) = err_ea([3:4,19:20],:);

err=err_us;
psi(:,a-1) = psi0(:,a-1);
z(:,a-1) = z0(:,a-1);

for ii = a:92
    psi(:,ii)=rho*psi(:,ii-1)+err(:,ii);
    z(:,ii)=A*z(:,ii-1)+B1*psi(:,ii);
    Xt(:,ii)=taum*z(:,ii)+taub*z(:,ii-1)+taus*psi(:,ii);
end

XXt = Xt ;

plot_data_mean= 0; %if = 1, the plots of the observable variables contained in XXt make use of the mean of the actual data rather than of the estimated mean of XXt itself
idat=0; %set =1 when prepare_short below works with the actual data. In that case, we want to do some smoothing on consumption before computing the marginal utility of consumption. Otherwise mu will go negative
% if plot_data_mean==1  %remove estimated mean and add mean of the data
%         XXt = XXt - mean((XXt)')'*ones(1,T) + mean((XXX)')'*ones(1,T);
% end
trendm1=zeros(92,1); %set trend to zero to avoid adding up the trend n times in the analysis of shocks below, where n is the number of shocks
trendm3=zeros(92,1); 
T =92;
fdiff =1;
alpha =0.36;
b =0.56;
beta =0.999;
mm=[];
addpath d:\banking\euroarea_code
[laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1,dinvest,dout,infl,dwage,dcons,Spread1,money1,money3, ...
        output,invest,cons,wage,price,hours,capacity,btott,dbtott,Rm_series,Re_series,Pe_series,govc,dgovc,idef,didef, ...
        oilp,doilp,Spread2] ...
    = prepare_short(XXt,mm,trendm3,trendm1,T,fdiff,alpha,b,beta,idat);

XXXt = [net;infl;hours;dbtott;dout;dwage;dinvest;dmoney1;dmoney3;dcons;Pe_series;Spread1;Rm_series;Re_series;capacity;dgovc;didef;doilp;Spread2];

[mean(infl(a:end)); mean(dout(a:end)); mean(Re_series(a:end))]

%mean of fitted ea inflation from 1999:1 to 2003:4 (times 400) is 0.076; %mean of undetrended data is 1.97
%mean of fitted ea output growth from 1999:1 to 2003:4 (times 400) is -0.428; mean of undemeaned  data is 1.41
%mean of fitted ea Re from 1999:1 to 2003:4 (times 400) is 0.1; mean of undetrended  data is 3.45

[std(infl(a:end)); std(dout(a:end)); std(Re_series(a:end))]
%std of fitted ea 400*inflation from 1999:1 to 2003:4  is 0.40; std of undetrended data is 0.89
%std of fitted ea 400*output growth from 1999:1 to 2003:4  is 1.83; std of undemeaned  data is 1.78
%std of fitted ea 400*Re from 1999:1 to 2003:4  is 0.76; std of undemeaned data is 0.89
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%results
infl_counter = infl;
dout_counter = dout;
Re_counter =Re_series;
clear infl dout Re_series

%load benchmark
load d:\banking\swaprules\benchmark infl dout Re_series %infl and dout in benchmark ea estimates

Re_string=400*0.00932932932933*(ones(size(dout(1,:)))');

figure
subplot(2,1,1)
plot(date(a:end),dout(a:end),'k',date(a:end),dout_counter(a:end),'r.-')
title('GDP Growth, Benchmark Estimation (solid) and Counterfactual under US Shocks(dotted)')
axis tight
subplot(2,1,2)
plot(date(a:end),infl(a:end),'k',date(a:end),infl_counter(a:end),'r.-')
title('Inflation, Benchmark Estimation (solid) and Counterfactual under US Shocks (dotted)')
axis tight
figure
plot(date(a:end),400*Re_series(a:end)+Re_string(a:end)','k',date(a:end),400*Re_counter(a:end)+Re_string(a:end)','r.-')
title('Interest rate (Re), Benchmark Estimation (solid) and Counterfactual under US Shocks (dotted)')
axis tight
