function forecastkalman1_uncertainty_start(outfolder,user)

conditional = 3; 

load([outfolder '\confidencebands'], 'Xdat', 'H', 'F', 'Q', 'RR', 'B1', 'initV', 'nT','LL', 'alf', 'initxi', 'tauvar', 'plot_levels', 'XXX', 'mm', ...
'trendm3', 'trendm1', 'fdiff', 'alpha', 'b', 'beta', 'is', 'taum', 'taub', 'taus', 'tausb', 'l_z', 'l_psi', 'D', 'taushock', 'outfolder', 'parstoch', 'date', ...
'pi', 'Re', 'Ra', 'muzstar', 'upsil', 'ecb_projection', 'start_plot', 'meanxxx', 'demean', 'R', 'entr', 'V_eps'); 

T = size(Xdat,2);

% l_xxx = size(taum,1);
% if length(tauvar) < l_xxx
%     if is == 1
%         HH    =   [taum,taub,taus,tausb];
%     else
%         HH    =   [taum,taub,taus];
%     end
% else
%     HH = H;
% end
% 
% appendnomM  = 1; %=1 appends nominal M1 growth, nominal M3 growth, nominal oil price growth, nominal net-worth growth, nominal credit
% if appendnomM == 1
%     nstates = size(HH,2);
%     addon = zeros(4,nstates);
%     addon(1,:) = HH(2,:) + HH(8,:); % nominal M1 growth
%     addon(2,:) = HH(2,:) + HH(9,:); % nominal M3 growth
%     addon(3,:) = HH(2,:) + HH(1,:); % nominal net-worth growth
%     addon(4,:) = HH(2,:) + HH(18,:); % nominal oil growth
%     addon(5,:) = HH(2,:) + HH(4,:);  %nominal credit growth
%     HH = [HH; addon];
%     alf = [alf;0;0;0;0;0];
% end

if conditional == 0 || conditional ==1 || conditional == 2
    T_end = nT; %T;
elseif conditional == 3 || conditional || 4
    T_end = T;
end

if user == 1
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat, F, H, Q, R, initxi, initV);
else
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat,F,H,Q,R,initxi,initV,alf(tauvar'));
end

s_s = [2*l_z+1:2*l_z+l_psi];
for ii = 2:T_end
    err(:,ii) = xsmooth(s_s,ii)-F(s_s,s_s)*xsmooth(s_s,ii-1);
end
err(:,1) = xsmooth(s_s,1);

ix=1;
for ii = 1:length(taushock)
    d(ix)=1;
    if parstoch(taushock(ii)) == 0
        ix=ix+2;
    else
        d(ix+2)=1;
        ix=ix+2+parstoch(taushock(ii));
    end
end
I=find(d==1);

err = err(I,:);

%draw random numbers
N_draws = 20000; %20000;
 
chol_V  = (chol(V_eps))'; %lower triangular

Diff_tot_uncert = zeros(N_draws,12);

wait_bar   = waitbar(0,'Computing Density Forecast...');
set(wait_bar,'Name','Density Forecast');

for jj = 1:N_draws

random_innovations = randn(length(I),1,length(nT+1:T));
random_innovations = reshape(random_innovations,length(I),length(nT+1:T));
random_innovations([9 10 12 13 15],:)=0; %random_innovations([1 2 3 4 5 6 7 8 11 14 15 16 17],:)=0; %
random_innovations  = chol_V*random_innovations;

f_name=1; %=1 do first step of scenario; =2, do second step
[Yhat,Ydata,VYhat] = forecastkalman1_uncertainty(Xdat,H,F,Q,RR,B1,initV,nT,LL,alf,initxi,tauvar,plot_levels,meanxxx,mm, ...
         trendm3,trendm1,fdiff,alpha,b,beta,is,taum,taub,taus,tausb,l_z,l_psi,D,taushock,outfolder,parstoch, ...
         date,f_name,xsmooth,Vsmooth,err,random_innovations,conditional);
      
[YYXX_1] = forecastkalman1_uncertainty_plot(Xdat,Yhat,VYhat,date,LL,nT,tauvar,fdiff,pi,Re,Ra,muzstar,upsil,ecb_projection,start_plot,meanxxx,demean,alf,R,entr);

f_name=2;
[Yhat,Ydata,VYhat] = forecastkalman1_uncertainty(Xdat,H,F,Q,RR,B1,initV,nT,LL,alf,initxi,tauvar,plot_levels,meanxxx,mm, ...
         trendm3,trendm1,fdiff,alpha,b,beta,is,taum,taub,taus,tausb,l_z,l_psi,D,taushock,outfolder,parstoch, ...
         date,f_name,xsmooth,Vsmooth,err,random_innovations,conditional);
      
[YYXX_2] = forecastkalman1_uncertainty_plot(Xdat,Yhat,VYhat,date,LL,nT,tauvar,fdiff,pi,Re,Ra,muzstar,upsil,ecb_projection,start_plot,meanxxx,demean,alf,R,entr);

% YYXX_1_level(:,1) = ones(size(YYXX_1,1)) ; %normalise 2006Q4 =1
% YYXX_2_level(:,1) = ones(size(YYXX_1,1)) ;

% for kk = 2:size(YYXX,2)+1
%     YYXX_1_level(:,kk) = YYXX_1_level(:,kk-1)*(1+YYXX_1(:,kk-1)/100);
%     YYXX_2_level(:,kk) = YYXX_2_level(:,kk-1)*(1+YYXX_2(:,kk-1)/100);
% end
% 
% for kk = 5:size(YYXX_1_level,2)
%     YYXX_1_yoy(:,kk-4) = YYXX_1_level(:,kk)

Diff_tot = YYXX_2 - YYXX_1;

Average_diff = [mean(Diff_tot(:,1:4),2) mean(Diff_tot(:,5:8),2) mean(Diff_tot(:,9:12),2) mean(Diff_tot(:,13:16),2)];
Diff_tot_uncert(jj,:) = [Average_diff(1,:) Average_diff(2,:) Average_diff(3,:)]; %infl, dy, di (yoy)

waitbar(jj/N_draws,wait_bar,sprintf('%f % of simulations already done',jj/N_draws));
end

%order each variable in each period in ascending order, divide it up in quintiles and consider the central ones
quintiles = [round(0.05*N_draws) ...
    round(0.10*N_draws)...
    round(0.15*N_draws)...
    round(0.20*N_draws)...
    round(0.25*N_draws)...
    round(0.30*N_draws)...
    round(0.35*N_draws)...
    round(0.40*N_draws)...
    round(0.45*N_draws)...
    round(0.50*N_draws)...
    round(0.55*N_draws)...
    round(0.60*N_draws)...
    round(0.65*N_draws)...
    round(0.70*N_draws)...
    round(0.75*N_draws)...
    round(0.80*N_draws)...
    round(0.85*N_draws)...
    round(0.90*N_draws)...
    round(0.95*N_draws)];

tmp = sort(Diff_tot_uncert);
MedianForecast = tmp(round(N_draws*0.5),:);
DenForecast = tmp(quintiles,:); %19 is the length of quintiles
ForecastMean = mean(tmp);

save j:\banking\euroarea_code_130508\results_ea\density_con_forecast_noshocks17192123 MedianForecast DenForecast ForecastMean


datte = [2007 2008 2009 2010];
tt1=[1:length(datte)]; 
ttx=[length(datte):-1:1];

ForecastMean_dp = ForecastMean(1:length(datte));
ForecastMean_dy = ForecastMean(length(datte)+1:2*length(datte));
ForecastMean_di = ForecastMean(2*length(datte)+1:3*length(datte));

MedianForecast_dp = MedianForecast(1:length(datte));
MedianForecast_dy = MedianForecast(length(datte)+1:2*length(datte));
MedianForecast_di = MedianForecast(2*length(datte)+1:3*length(datte));

DenForecast_dp = DenForecast(:,1:length(datte));
DenForecast_dy = DenForecast(:,length(datte)+1:2*length(datte));
DenForecast_di = DenForecast(:,2*length(datte)+1:3*length(datte));

figure
%subplot(1,3,1)

[AX,H1,H2] = plotyy(datte',ForecastMean_dp(tt1)',datte',ForecastMean_dp(tt1)','plot');
set(AX(1),'YColor',[0 0 0])
set(AX(2),'YColor',[0 0 0])
set(AX(1),'Ylim',[min(DenForecast_dp(1,ttx)) max(DenForecast_dp(19,ttx))])
set(AX(2),'Ylim',[min(DenForecast_dp(1,ttx)) max(DenForecast_dp(19,ttx))])
set(AX(1),'YTick',[min(DenForecast_dp(1,ttx)):1: max(DenForecast_dp(19,ttx))])
set(AX(2),'YTick',[min(DenForecast_dp(1,ttx)):1: max(DenForecast_dp(19,ttx))])
set(AX(1),'TickDir','out')
set(AX(2),'TickDir','out')


% grpyat=[datte(tt1)'  DenForecast_dp(1,tt1)'; datte(ttx)' DenForecast_dp(19,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 1 1],'edgecolor',[0 1 1]);
% 
% grpyat=[datte(tt1)'  DenForecast_dp(2,tt1)'; datte(ttx)' DenForecast_dp(18,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 0.9 1],'edgecolor',[0 0.9 1]);
%     
% grpyat=[datte(tt1)'  DenForecast_dp(3,tt1)'; datte(ttx)' DenForecast_dp(17,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 0.8 1],'edgecolor',[0 0.8 1]);
% 
grpyat=[datte(tt1)'  DenForecast_dp(4,tt1)'; datte(ttx)' DenForecast_dp(16,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.7 1],'edgecolor',[0 0.7 1]);

grpyat=[datte(tt1)'  DenForecast_dp(5,tt1)'; datte(ttx)' DenForecast_dp(15,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.6 1],'edgecolor',[0 0.6 1]);

grpyat=[datte(tt1)'  DenForecast_dp(6,tt1)'; datte(ttx)' DenForecast_dp(14,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.5 1],'edgecolor',[0 0.5 1]);

grpyat=[datte(tt1)'  DenForecast_dp(7,tt1)'; datte(ttx)' DenForecast_dp(13,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.4 1],'edgecolor',[0 0.4 1]);

grpyat=[datte(tt1)'  DenForecast_dp(8,tt1)'; datte(ttx)' DenForecast_dp(12,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.3 1],'edgecolor',[0 0.3 1]);

grpyat=[datte(tt1)'  DenForecast_dp(9,tt1)'; datte(ttx)' DenForecast_dp(11,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0 1],'edgecolor',[0 0 1]);
hold

title('GDP Deflator Inflation')

set(H1,'linewidth',2,'Color',[0,1,1])
set(H2,'linewidth',2,'Color',[0,1,1])

%plot(datte',repmat(2,size(datte(tt1)',1),size(datte(tt1)',2)),'k-')
line(datte(tt1),zeros(size(datte(tt1))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

hold off

%plot GDP
%subplot(1,3,2)
figure

[AX,H1,H2] = plotyy(datte',ForecastMean_dy(tt1)',datte',ForecastMean_dy(tt1)','plot');
set(AX(1),'YColor',[0 0 0])
set(AX(2),'YColor',[0 0 0])
set(AX(1),'Ylim',[min(DenForecast_dy(1,ttx)) max(DenForecast_dy(19,ttx))])
set(AX(2),'Ylim',[min(DenForecast_dy(1,ttx)) max(DenForecast_dy(19,ttx))])
set(AX(1),'YTick',[min(DenForecast_dy(1,ttx)):1: max(DenForecast_dy(19,ttx))])
set(AX(2),'YTick',[min(DenForecast_dy(1,ttx)):1: max(DenForecast_dy(19,ttx))])
set(AX(1),'TickDir','out')
set(AX(2),'TickDir','out')

% grpyat=[datte(tt1)'  DenForecast_dy(1,tt1)'; datte(ttx)' DenForecast_dy(19,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 1 0],'edgecolor',[0 1 0]);
% 
% grpyat=[datte(tt1)'  DenForecast_dy(2,tt1)'; datte(ttx)' DenForecast_dy(18,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 0.9 0.6],'edgecolor',[0 0.9 0.4]);
%     
% grpyat=[datte(tt1)'  DenForecast_dy(3,tt1)'; datte(ttx)' DenForecast_dy(17,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[0 0.8 0.5],'edgecolor',[0 0.8 0.5]);
% 
grpyat=[datte(tt1)'  DenForecast_dy(4,tt1)'; datte(ttx)' DenForecast_dy(16,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.7 0.5],'edgecolor',[0 0.7 0.5]);

grpyat=[datte(tt1)'  DenForecast_dy(5,tt1)'; datte(ttx)' DenForecast_dy(15,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.6 0.5],'edgecolor',[0 0.6 0.5]);

grpyat=[datte(tt1)'  DenForecast_dy(6,tt1)'; datte(ttx)' DenForecast_dy(14,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.5 0.4],'edgecolor',[0 0.5 0.4]);

grpyat=[datte(tt1)'  DenForecast_dy(7,tt1)'; datte(ttx)' DenForecast_dy(13,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.4 0.3],'edgecolor',[0 0.4 0.3]);

grpyat=[datte(tt1)'  DenForecast_dy(8,tt1)'; datte(ttx)' DenForecast_dy(12,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.3 0.2],'edgecolor',[0 0.3 0.2]);

grpyat=[datte(tt1)'  DenForecast_dy(9,tt1)'; datte(ttx)' DenForecast_dy(11,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[0 0.2 0.1],'edgecolor',[0 0.2 0.1]);
hold

title('GDP Growth ')

set(H1,'linewidth',2,'Color',[0,1,0])
set(H2,'linewidth',2,'Color',[0,1,0])

line(datte(tt1),zeros(size(datte(tt1))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

hold off


%plot Investment
figure
%subplot(1,3,3)

%[AX,H1,H2] = plotyy(datte(tt1)',ForecastMean_di(tt1)',datte(tt1)',ForecastMean_di(tt1)','plot');
[AX,H1,H2] = plotyy(datte(tt1)',MedianForecast_di(tt1)',datte(tt1)',MedianForecast_di(tt1)','plot');
set(AX(1),'YColor',[0 0 0])
set(AX(2),'YColor',[0 0 0])
set(AX(1),'Ylim',[min(DenForecast_di(1,ttx)) max(DenForecast_di(19,ttx))])
set(AX(2),'Ylim',[min(DenForecast_di(1,ttx)) max(DenForecast_di(19,ttx))])
set(AX(1),'YTick',[min(DenForecast_di(1,ttx)):1: max(DenForecast_di(19,ttx))])
set(AX(2),'YTick',[min(DenForecast_di(1,ttx)):1: max(DenForecast_di(19,ttx))])
set(AX(1),'TickDir','out')
set(AX(2),'TickDir','out')

% grpyat=[datte(tt1)'  DenForecast_di(1,tt1)'; datte(ttx)' DenForecast_di(19,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[1 1 0],'edgecolor',[1 1 0]);
% 
% grpyat=[datte(tt1)'  DenForecast_di(2,tt1)'; datte(ttx)' DenForecast_di(18,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[1 0.9 0],'edgecolor',[1 0.9 0]);
%     
% grpyat=[datte(tt1)'  DenForecast_di(3,tt1)'; datte(ttx)' DenForecast_di(17,ttx)'];
% patch(grpyat(:,1),grpyat(:,2),[1 0.8 0],'edgecolor',[1 0.8 0]);
% 
grpyat=[datte(tt1)'  DenForecast_di(4,tt1)'; datte(ttx)' DenForecast_di(16,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0.7 0],'edgecolor',[1 0.7 0]);

grpyat=[datte(tt1)'  DenForecast_di(5,tt1)'; datte(ttx)' DenForecast_di(15,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0.6 0],'edgecolor',[1 0.6 0]);

grpyat=[datte(tt1)'  DenForecast_di(6,tt1)'; datte(ttx)' DenForecast_di(14,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0.5 0],'edgecolor',[1 0.5 0]);

grpyat=[datte(tt1)'  DenForecast_di(7,tt1)'; datte(ttx)' DenForecast_di(13,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0.4 0],'edgecolor',[1 0.4 0]);

grpyat=[datte(tt1)'  DenForecast_di(8,tt1)'; datte(ttx)' DenForecast_di(12,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0.3 0],'edgecolor',[1 0.3 0]);

grpyat=[datte(tt1)'  DenForecast_di(9,tt1)'; datte(ttx)' DenForecast_di(11,ttx)'];
patch(grpyat(:,1),grpyat(:,2),[1 0 0],'edgecolor',[1 0 0]);
hold

title('Investment growth')

set(H1,'linewidth',2,'Color',[1,0.7,0])

line(datte(tt1),zeros(size(datte(tt1))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

hold off


