if timing ==0
    error('fatal (main) timing=0. Look up at the manuscript')
end

if (iota1+iota2) > 1 || (iotaw1+iotaw2) > 1
    error('fatal (loadparameters) iota1+iota2 and/or iotaw1+iotaw2 >1')
end

if abs(muup-1) > .1e-10
    error('fatal (loadparameters) muup must be unity')
end

%load up parameter values 
params       = [entr pref lambdaw sigmaL theta v beta xiw Hdoupr sigmaq b psiL m chii duration1 zetac, ...
           iotaw1 iotaw2 iotamu Fomegabar sigma mu gamma we bigtheta sigmaa Sdoupr etai muup zeta, ...
           muzstar upsil lambdaf alpha psik psil delta epsil xip iota1 iota2 ksi xb chorse, ...
           rhobank vl vk etag tauk taul tauc taud taut tau x aptil aytil amtil actil rhotil timing nn xp phi ...
           pibar zetai tauo pitarget adptil adytil begin country money rpl util costreal static xiE  ...
           calvohours par1 par2 par3 par4 par5 par6 par7 par8 par9 par10 do_qavrg shock_trans]; %NOTE: shock_trans is a vector. it must be always the last entry of params

%load up the parameters that specify for each shock the number of periods extending between the signal and the realisation of the shock 
parstoch(1)=p_lambdaf; 
parstoch(2)=p_pitarget;
parstoch(3)=p_psil;
parstoch(4)=p_psik;
parstoch(5)=p_ksi;
parstoch(6)=p_xb;
parstoch(7)=p_muup;
parstoch(8)=p_theta;
parstoch(9)=p_chii;
parstoch(10)=p_taul;
parstoch(11)=p_tauk;
parstoch(12)=p_zeta;
parstoch(13)=p_g;
parstoch(14)=p_v;
parstoch(15)=p_taud;
parstoch(16)=p_muzstar;
parstoch(17)=p_gamma;
parstoch(18)=p_epsil;
parstoch(19)=p_xp;
parstoch(20)=p_tauc;
parstoch(21)=p_sigma;
parstoch(22)=p_zetac;
parstoch(23)=p_zetai;
parstoch(24)=p_tauo;
parstoch(25)=p_term;

%load up the AR(1) coefficients  
parstoch1(1)=rho1_lambdaf; 
parstoch1(2)=rho1_pitarget;
parstoch1(3)=rho1_psil;
parstoch1(4)=rho1_psik;
parstoch1(5)=rho1_ksi;
parstoch1(6)=rho1_xb;
parstoch1(7)=rho1_muup;
parstoch1(8)=rho1_theta;
parstoch1(9)=rho1_chii;
parstoch1(10)=rho1_taul;
parstoch1(11)=rho1_tauk;
parstoch1(12)=rho1_zeta;
parstoch1(13)=rho1_g;
parstoch1(14)=rho1_v;
parstoch1(15)=rho1_taud;
parstoch1(16)=rho1_muzstar;
parstoch1(17)=rho1_gamma;
parstoch1(18)=rho1_epsil;
parstoch1(19)=rho1_xp;
parstoch1(20)=rho1_tauc;
parstoch1(21)=rho1_sigma;
parstoch1(22)=rho1_zetac;
parstoch1(23)=rho1_zetai;
parstoch1(24)=rho1_tauo;
parstoch1(25)=rho1_term;

%load up the AR(2) coefficients  
parstoch2(1)=rho2_lambdaf; 
parstoch2(2)=rho2_pitarget;
parstoch2(3)=rho2_psil;
parstoch2(4)=rho2_psik;
parstoch2(5)=rho2_ksi;
parstoch2(6)=rho2_xb;
parstoch2(7)=rho2_muup;
parstoch2(8)=rho2_theta;
parstoch2(9)=rho2_chii;
parstoch2(10)=rho2_taul;
parstoch2(11)=rho2_tauk;
parstoch2(12)=rho2_zeta;
parstoch2(13)=rho2_g;
parstoch2(14)=rho2_v;
parstoch2(15)=rho2_taud;
parstoch2(16)=rho2_muzstar;
parstoch2(17)=rho2_gamma;
parstoch2(18)=rho2_epsil;
parstoch2(19)=rho2_xp;
parstoch2(20)=rho2_tauc;
parstoch2(21)=rho2_sigma;
parstoch2(22)=rho2_zetac;
parstoch2(23)=rho2_zetai;
parstoch2(24)=rho2_tauo;
parstoch2(25)=rho2_term;

parstoch1_name = strvcat('rho1_lambdaf','rho1_pitarget','rho1_psil','rho1_psik','rho1_ksi','rho1_xb','rho1_muup','rho1_theta','rho1_chii','rho1_taul', ...
    'rho1_tauk','rho1_zeta','rho1_g','rho1_v','rho1_taud','rho1_muzstar','rho1_gamma','rho1_epsil','rho1_xp','rho1_tauc','rho1_sigma','rho1_zetac', 'rho1_zetai', 'rho1_tauo', 'rho1_term');
parstoch2_name = strvcat('rho2_lambdaf','rho2_pitarget','rho2_psil','rho2_psik','rho2_ksi','rho2_xb','rho2_muup','rho2_theta','rho2_chii','rho2_taul','rho2_tauk', ...
    'rho2_zeta','rho2_g','rho2_v','rho2_taud','rho2_muzstar','rho2_gamma','rho2_epsil','rho2_xp','rho2_tauc','rho2_sigma','rho2_zetac','rho2_zetai','rho2_tauo', 'rho2_term');

%Construct the rho's
parstoch1=parstoch1(taushock);
parstoch2=parstoch2(taushock);
X=[parstoch1 parstoch2];
[rho,D] = maprho(taushock,X,parstoch);

%load standard deviation of shocks and their name
stdshocks1=[std1_lambdaf; std1_pitarget; std1_psil; std1_psik; std1_ksi; std1_xb; std1_muup; std1_theta; std1_chii; std1_taul; std1_tauk; std1_zeta; std1_g; std1_v; std1_taud; std1_muzstar; std1_gamma; std1_epsil; std1_xp; std1_tauc; std1_sigma; std1_zetac; std1_zetai; std1_tauo; std1_term];
stdshocks1_name = strvcat('std1_lambdaf','std1_pitarget','std1_psil','std1_psik','std1_ksi','std1_xb','std1_muup','std1_theta','std1_chii','std1_taul','std1_tauk','std1_zeta','std1_g','std1_v','std1_taud','std1_muzstar','std1_gamma','std1_epsil','std1_xp','std1_tauc','std1_sigma','std1_zetac','std1_zetai','std1_tauo', 'std1_term');

%load standard deviation of signals and their name
stdshocks2=[std2_lambdaf; std2_pitarget; std2_psil; std2_psik; std2_ksi; std2_xb; std2_muup; std2_theta; std2_chii; std2_taul; std2_tauk; std2_zeta; std2_g; std2_v; std2_taud; std2_muzstar; std2_gamma; std2_epsil; std2_xp; std2_tauc; std2_sigma; std2_zetac; std2_zetai; std2_tauo; std2_term];
stdshocks2_name = strvcat('std2_lambdaf','std2_pitarget','std2_psil','std2_psik','std2_ksi','std2_xb','std2_muup','std2_theta','std2_chii','std2_taul','std2_tauk','std2_zeta','std2_g','std2_v','std2_taud','std2_muzstar','std2_gamma','std2_epsil','std2_xp','std2_tauc','std2_sigma','std2_zetac','std2_zetai','std2_tauo', 'std2_term');

%load the stdd of the economic shocks into Recon and their name
ix=0;
name1=[];
name2=[];
name3=[];
for ii = 1:length(taushock)
    ix=ix+1;
    Recon(ix) = stdshocks1(taushock(ii));
    name1 = [name1; stdshocks1_name(taushock(ii),:)];
    name2 = [name2; stdshocks2_name(taushock(ii),:)];
    
    name3 = [name3; stdshocks1_name(taushock(ii),:)];
    
    if parstoch(taushock(ii)) > 0
        Recon(ix+1:ix+parstoch(taushock(ii)))= ...
            ones(1,parstoch(taushock(ii)))*stdshocks2(taushock(ii));
        ix=ix+parstoch(taushock(ii));
    end
    name3 = [name3; stdshocks2_name(taushock(ii),:)];
end

%load priors on AR(1) coefficient
p_rho_1 = [prior_rho1_lambdaf; prior_rho1_pitarget; prior_rho1_psil; prior_rho1_psik; prior_rho1_ksi; prior_rho1_xb; prior_rho1_muup; prior_rho1_theta; prior_rho1_chii; prior_rho1_taul; prior_rho1_tauk; prior_rho1_zeta; prior_rho1_g; prior_rho1_v; prior_rho1_taud; prior_rho1_muzstar; prior_rho1_gamma; prior_rho1_epsil; prior_rho1_xp; prior_rho1_tauc; prior_rho1_sigma; prior_rho1_zetac; prior_rho1_zetai; prior_rho1_tauo; prior_rho1_term];
%load priors on AR(2) coefficient
p_rho_2 = [prior_rho2_lambdaf; prior_rho2_pitarget; prior_rho2_psil; prior_rho2_psik; prior_rho2_ksi; prior_rho2_xb; prior_rho2_muup; prior_rho2_theta; prior_rho2_chii; prior_rho2_taul; prior_rho2_tauk; prior_rho2_zeta; prior_rho2_g; prior_rho2_v; prior_rho2_taud; prior_rho2_muzstar; prior_rho2_gamma; prior_rho2_epsil; prior_rho2_xp; prior_rho2_tauc; prior_rho2_sigma; prior_rho2_zetac; prior_rho2_zetai; prior_rho2_tauo; prior_rho2_term];

%load priors on stdd of structural shocks
p_s_1 = [prior_std1_lambdaf; prior_std1_pitarget; prior_std1_psil; prior_std1_psik; prior_std1_ksi; prior_std1_xb; prior_std1_muup; prior_std1_theta; prior_std1_chii; prior_std1_taul; prior_std1_tauk; prior_std1_zeta; prior_std1_g; prior_std1_v; prior_std1_taud; prior_std1_muzstar; prior_std1_gamma; prior_std1_epsil; prior_std1_xp; prior_std1_tauc; prior_std1_sigma; prior_std1_zetac; prior_std1_zetai; prior_std1_tauo; prior_std1_term];
%load priors on variance of signals
p_s_2 = [prior_std2_lambdaf; prior_std2_pitarget; prior_std2_psil; prior_std2_psik; prior_std2_ksi; prior_std2_xb; prior_std2_muup; prior_std2_theta; prior_std2_chii; prior_std2_taul; prior_std2_tauk; prior_std2_zeta; prior_std2_g; prior_std2_v; prior_std2_taud; prior_std2_muzstar; prior_std2_gamma; prior_std2_epsil; prior_std2_xp; prior_std2_tauc; prior_std2_sigma; prior_std2_zetac; prior_std2_zetai; prior_std2_tauo; prior_std2_term];

%load priors on standard deviation of measurement errors
p_me = [prior_1; prior_2; prior_3; prior_4; prior_5; prior_6; prior_7; prior_8; prior_9; prior_10; prior_11; prior_12; prior_13; prior_14; prior_15; prior_16; prior_17; prior_18; prior_19;prior_20];
 
%stack the priors in the following order: priors on AR(1) coefficient; on AR(2); on stdd of structural shocks and signals; on stdd of measurement error
ix=0;
for ii = 1:length(taushock)
    if max(taushock3==taushock(ii))==1
        ix=ix+1;
        p_s(ix,:) = p_s_1(taushock(ii),:);

        if parstoch(taushock(ii)) > 0
            ix=ix+1;
            p_s(ix,:) = p_s_2(taushock(ii),:);
        end
    end
end

prior = [p_rho_1(taushock1,:); p_rho_2(taushock(taushock2==1),:); p_s; p_me(tauvar(tauvar2==1),:)];
