function  logf = lognormpdf(x,mu,sigma)

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % PURPOSE:     Computing the log height of the N(mu,sigma^2) density
 %
 % INPUT:       x          (scalar)        Point where the density is evaluated  
 %              mu         (scalar)        Mean
 %              sigma      (scalar)        Standard deviation
 %      
 % OUTPUT:      logf       (scalar)        Log height of the N(mu,sigma^2) distribution
 %
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

logf = -log(sigma) -0.5*log(2*pi) -0.5*((x-mu)./sigma).^2;
 

