function [alphas,alpha_2, alpha_1,alpha_0,betas,beta_0,beta_1,taumat,M,sss,tt2,G,Gp,Gs] = ...
    makealphabeta(lambdaz,g,her,ksi,pi,i,omegabar,Rk,n,ev,mb,uzc, ...
    Ra,c,w,Re,m3,k,params,q,s,u,dm,vn,RT,Rm,icheck,Taylor,forward, ...
    parstoch,etai,taushock,irun,btot,phi,y,R,rk,l,kbar)

%this program log-linearizes the CMR model and various special cases (entr
%= 1, 0, -1, -2). It does this by analytically derived derivative formulas
%and is able to do the same calculations numerically for checking purposes
%(this happens if ickeck=1). 

%the basic structure of the program is as follows. First, it works with a
%system in which z(t) is the list of endogenous, date t determined,
%variables in CMR. Also, it works with a vector of 25 shocks. Second, the
%large system is reduced to remove redundant variables (both elements of z(t) 
%as well as reduntant elements of the shock vector) and equations. The
%reduced system is the one for which the derivative check is performed.
%Unfortunately, there is a slight numbering complication arising from 
%misunderstanding long ago. Initially, equations 1-11 correspond to 
%1-11 in the manuscript. But then, 13-end correspond to 12-end in the
%manuscript. After the full system is put together, this is corrected
%during the system reduction process.

% Constructing the alphas
% z_t   =   [pi_t, s_t, rk_t, i_t, u_t, omegabar_t, Rk_t, n_t+1, q_t, vl_t, vk_t, ev_t, mb_t, R_t, uzc_t, lambdaz_t, m_t, Ra_t, c_t, w_t, l_t, kbar_t+1, Re_t+1, x_t dm(t+1) Rm(t+1) m3(t) mb(t)]
% since vl_t = vk_t, the 11th line of the system will be eliminated. The 10th column of each alpha will be replaced by the sum of the 10th and 11th; the 11th column is dropped;

cdir = cd;
 
if irun ==0  || irun ==7 
    syms Hdoupr Sdoupr xip xiw rhotil aptil aytil actil amtil sigmaa iota1 iota2 iotaw1 iotaw2 iotamu adptil adytil xiE par1 par2 par3 par4 par5 par6 par7 par8 par9 par10 %create symbolic variables for the parameters that you want to estimate
    
    alpha_0         =   sym(zeros(34,34));
    alpha_1         =   sym(zeros(34,34));
    alpha_2         =   sym(zeros(34,34));
    beta_0          =   sym(zeros(34,25));
    beta_1          =   sym(zeros(34,25));
elseif irun == 1  
    alpha_0         =   zeros(34,34);
    alpha_1         =   zeros(34,34);
    alpha_2         =   zeros(34,34);
    beta_0          =   zeros(34,25);
    beta_1          =   zeros(34,25);

    xiw       = params(8);
    Hdoupr    = params(9);
    iotaw1    = params(17);
    iotaw2    = params(18);
    iotamu    = params(19);
    sigmaa    = params(26);
    Sdoupr    = params(27);
    xip       = params(39);
    iota1     = params(40);
    iota2     = params(41);
    aptil     = params(56);
    aytil     = params(57);
    amtil     = params(58);
    actil     = params(59);
    rhotil    = params(60);
    adptil    = params(69);
    adytil    = params(70);
    xiE       = params(78);
    par1        = params(80);
    par2        = params(81);
    par3        = params(82);
    par4        = params(83);
    par5        = params(84);
    par6        = params(85);
    par7        = params(86);
    par8        = params(87);
    par9        = params(88);
    par10       = params(89);

end
entr      = params(1);
pref      = params(2);
lambdaw   = params(3);
sigmaL    = params(4);
theta     = params(5);
v         = params(6);
beta      = params(7);
sigmaq    = params(10);
b         = params(11);
psiL      = params(12);
m         = params(13);
chii      = params(14);
duration1  = params(15);
zetac     = params(16);
Fomegabar = params(20);
sigma     = params(21);
mu        = params(22);
gamma     = params(23);
we        = params(24);
bigtheta  = params(25);
etai      = params(28);
muup      = params(29);
zeta      = params(30);
muzstar   = params(31);
upsil     = params(32);
lambdaf   = params(33);
alpha     = params(34);
psik      = params(35);
psil      = params(36);
delta     = params(37);
epsil     = params(38);
ksi       = params(42);
xb        = params(43);
chorse    = params(44);
rhobank   = params(45);
vl        = params(46);
vk        = params(47);
etag      = params(48);
tauk      = params(49);
taul      = params(50);
tauc      = params(51);
taud      = params(52);
tauT      = params(53);
tau       = params(54);
x         = params(55);
timing    = params(61);
nn        = params(62);
xp        = params(63);
phi       = params(64);
pibar     = params(65);
begin     = params(71);
country     = params(72);
money       = params(73);
rpl         = params(74);
util        = params(75);
costreal    = params(76);
static      = params(77);
calvohours  = params(79);
do_qavrg    = params(90);
shock_trans = params(91:end);

if entr == 1 || entr==-3
    full=1; %=1, compute all outputs; =0, compute G only and set to zero the others
    [G,Gamma,Gammap,Gammadp,Gammas,Gammaps,Gp,Gdp,Gs,Gps,lambda] = const(omegabar,sigma,mu,full);
    lambda  =   Gammap/(Gammap-mu*Gp); %we add this because we need not only the numerical value but also its expression below
else
    Gamma=0; Gammap=0; Gammadp=0; Gammas=0; Gammaps=0; G=0; Gp=0; Gdp=0; Gs=0; Gps=0; lambda=0;
end

numshocks =size(beta_1,2);

%Phillips curve
alpha_0(1,1)    =   -beta/(1+beta*iota2);

alpha_1(1,1)    =   1;
alpha_1(1,2)    =   -(1-beta*xip)*(1-xip)/(xip*(1+beta*iota2));

alpha_2(1,1)    =   -iota2/(1+beta*iota2);

beta_0(1,2)     =   iota1*beta/(1+beta*iota2);

beta_1(1,1)     =   -(1-beta*xip)*(1-xip)/(xip*(1+beta*iota2)); %-1; 
beta_1(1,2)     =   -iota1/(1+beta*iota2);

%Marginal cost
alpha_1(2,2)    =   -1;
alpha_1(2,3)    =   alpha;
alpha_1(2,14)   =   alpha*psik*R/(1+psik*R)+(1-alpha)*psil*R/(1+psil*R);
alpha_1(2,20)   =   1-alpha;

beta_1(2,3)     =   (1-alpha)*psil*R/(1+psil*R);
beta_1(2,4)    =   alpha*psik*R/(1+psik*R);
beta_1(2,18)    =   -1;

%eq 3
alpha_1(3,2)    =   -1;
alpha_1(3,3)    =   1;
alpha_1(3,5)    =   1-alpha;
alpha_1(3,14)   =   psik*R/(1+psik*R);
alpha_1(3,21)   =   -(1-alpha);

alpha_2(3,22)   =   1-alpha;

beta_1(3,4)    =   psik*R/(1+psik*R);
beta_1(3,16)    =   -(1-alpha);
beta_1(3,18)    =   -1;

%Tobin's q
if static ==0
    alpha_0(4,4)    =   Sdoupr*beta*(muzstar*upsil)^2;
    
    alpha_1(4,4)    =   -Sdoupr*(1+beta)*(muzstar*upsil)^2;
    alpha_1(4,9)    =   1;
    
    alpha_2(4,4)    =   Sdoupr*(muzstar*upsil)^2;
    
    beta_0(4,16)    =   beta*Sdoupr*(muzstar*upsil)^2;
    beta_0(4,23)    =   beta*Sdoupr*(muzstar*upsil)^2; 
 %alpha_0(4,36)    =   beta*Sdoupr*(muzstar*upsil)^2;
    
    beta_1(4,16)   =   -Sdoupr*(muzstar*upsil)^2;
    beta_1(4,7)    =   1;
    beta_1(4,23)   =   -Sdoupr*(muzstar*upsil)^2;  
 %alpha_1(4,36)   =   -Sdoupr*(muzstar*upsil)^2; 

elseif static ==1
    alpha_1(4,4) = -1/etai;
    alpha_1(4,9) = 1;
    
    alpha_2(4,22) = 1/etai;
    
    beta_1(4,7)  = 1;
    beta_1(4,16)   = -1/etai;
end

%Variable capital utilisation
if util ==1
    alpha_1(5,3)    =   1/sigmaa;
    beta_1(5,24)    =   -1/sigmaa;
elseif util == 0
    alpha_1(5,3)    =   0;
end    
alpha_1(5,5)    =   -1;

%eq. 6
if entr == 1 || entr ==-3
    alpha_0(6,6)    =   -(1-Gamma)*(1+Rk)/(1+Re)*(Gammadp*omegabar-lambda*(Gammadp-mu*Gdp)*omegabar)/Gammap;
    alpha_0(6,7)    =   lambda*Rk/(1+Rk);

    alpha_1(6,23)   =   -lambda*Re/(1+Re);
    
    cst             =   (Gammaps*sigma/Gammap) - lambda*((Gammaps-mu*Gps)*sigma/Gammap);
    beta_1(6,21)    =   ((1+Rk)/(1+Re))*(sigma*(-Gammas+lambda*(Gammas-mu*Gs))-(1-Gamma)*cst);
    %beta_0(6,21)    =   ((1+Rk)/(1+Re))*(sigma*(-Gammas+lambda*(Gammas-mu*Gs))-(1-Gamma)*cst);


%eq. 7 (zero profit condition)
    alpha_1(7,6)    =   (k/n-1)*(Gammap-mu*Gp)*omegabar/(Gamma-mu*G);
    alpha_1(7,7)    =   (k/n-1)*Rk/(1+Rk);
    
    alpha_2(7,8)    =   1;
    alpha_2(7,9)    =   -1;
    alpha_2(7,22)   =   -1;
    alpha_2(7,23)   =   -(k/n-1)*Re/(1+Re);
    
    beta_1(7,21)    =   ((k/n)-1)*((Gammas-mu*Gs)/(Gamma-mu*G))*sigma; %this coefficient should be on sigma(t-1); to accomodate this, we set it on sigma(t) and adjust below tau(7,21) as explained in the manuscript

%eq 8 (net worth evolution)
    a_0     =   gamma*kbar*q*Rk/(pi*muzstar*n)*(1-mu*G);
    a_1     =   (1-kbar*q/n)*gamma*Re/(muzstar*pi);
    a_2     =   gamma*kbar*q/(pi*muzstar*n)*(Rk-Re-(1+Rk)*mu*G);
    a_3     =   we/n;
    a_4     =   a_2+gamma*(1+Re)/(muzstar*pi);
    a_5     =   -a_4;
    a_6     =   -a_4;
    a_7     =   a_2;
    a_8     =   -(gamma/(pi*muzstar))*mu*Gp*(1+Rk)*kbar*(q/n)*omegabar;
    a_9     =   gamma*(1+Re)/(pi*muzstar);
    a_10    =   -(gamma/(pi*muzstar))*mu*Gs*(1+Rk)*kbar*(q/n)*sigma;

    alpha_1(8,1)    =   a_5;
    alpha_1(8,6)    =   a_8;
    alpha_1(8,7)    =   a_0;
    alpha_1(8,8)    =   -1;

    alpha_2(8,8)    =   a_9;
    alpha_2(8,9)    =   a_7;
    alpha_2(8,22)   =   a_2;
    alpha_2(8,23)   =   a_1;
    
    beta_1(8,16)    =   a_6;
    beta_1(8,17)    =   a_4;
    beta_1(8,21)    =   a_10;%this coefficient should be on sigma(t-1); to accomodate this, we set it on sigma(t) and adjust below tau(8,21) as explained in the manuscript
end

%rate of return on capital
alpha_1(9,1)    =   -((1-tauk)*rk+(1-delta)*q)*pi/(upsil*Rk*q);
alpha_1(9,3)    =   -pi*(1-tauk)*rk/(upsil*Rk);
alpha_1(9,7)    =   1;
if static ==0
    alpha_1(9,9)    =   -(1-delta)*pi/(upsil*Rk);
elseif static ==1
    alpha_1(9,9)    =   -pi*muzstar/Rk;

    beta_1(9,7)    =   -pi*muzstar*i/(k*Rk);
end

alpha_2(9,9)    =   ((1-tauk)*rk+1-delta)*pi/(upsil*Rk);

beta_1(9,11)    =   pi*tauk*rk/(upsil*Rk*q)-delta*tauk/Rk; %this coefficient should be on tauk(t-1); to accomodate this, we set it on sigma(t) and adjust below tau(9,11) as explained in the manuscript

%ratio of excess reserves to value added
if entr == 1 || entr ==0
    % Note: notation changed to avoid confusing n/d with the steady state value of net worth/deposits
    num       =   (1-tau)*(mb/(pi*muzstar))*(1-m)-tau*(psil*w*l+psik*rk*k/(muzstar*upsil));
    num_tau   =   ( -tau*(mb/(pi*muzstar))*(1-m)-tau*(psil*w*l+psik*rk*k/(muzstar*upsil)))/num;
    num_mb    =   (1-tau)*(mb/(pi*muzstar))*(1-m)/num;
    num_m     =   -(1-tau)*(mb/(pi*muzstar))*m/num;
    num_psil  =   -tau*psil*w*l/num;
    num_w     =   num_psil;
    num_l     =   num_psil;
    num_psik  =   -tau*psik*rk*k/(muzstar*upsil*num);
    num_rk    =   num_psik;
    num_k     =   num_psik;
    num_muz   =   tau*psik*rk*k/(muzstar*upsil*num);
    den       =   ((1-vk)*k/(muzstar*upsil))^alpha*((1-vl)*l)^(1-alpha);
    den_muz   =   -alpha;
    den_k     =   alpha;
    den_vk    =   -alpha*vk/(1-vk);
    den_l     =   1-alpha;
    den_vl    =   -(1-alpha)*vl/(1-vl);
    
    alpha_1(10,1)   =   -num_mb;
    alpha_1(10,3)   =   num_rk;
    alpha_1(10,5)   =   num_k-den_k;
    alpha_1(10,10)  =   -den_vl;
    alpha_1(10,11)  =   -den_vk;
    alpha_1(10,12)  =   -1;
    alpha_1(10,17)  =   num_m;
    alpha_1(10,20)  =   num_w;
    alpha_1(10,21)  =   num_l-den_l;
    
    alpha_2(10,13)  =   num_mb;
    alpha_2(10,22)  =   num_k-den_k;
    
    %beta_1(10,2)    =   num_tau; %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_1(10,3)    =   num_psil;
    beta_1(10,4)   =   num_psik;
    beta_1(10,16)   =   -num_mb+(num_muz-den_muz);
end

%FOC for capital in banking sector
if entr == 1 || entr == 0
    k_R     =   1-psik*R/(1+psik*R);
    k_xi    =   1-log(ev)*ksi+(tau*her*(1/(1-ksi)+log(ev))*ksi)/(1+tau*her);
    k_x     =   1/(1+tau*her);
    k_e     =   1-ksi+ksi*tau*her/(1+tau*her);
    k_mu    =   1-alpha;
    k_vl    =   -(1-alpha)*vl/(1-vl);
    k_vk    =   (1-alpha)*vk/(1-vk);
    k_l     =   1-alpha;
    k_k     =   -(1-alpha);
    k_tau   =   -tau*her/(1+tau*her);
    k_psik  =   -psik*R/(1+psik*R);
    
    alpha_1(11,3)   =   -1;
    alpha_1(11,5)   =   k_k;
    alpha_1(11,10)  =   k_vl;
    alpha_1(11,11)  =   k_vk;
    alpha_1(11,12)  =   k_e;
    alpha_1(11,14)  =   k_R;
    alpha_1(11,21)  =   k_l;
    
    alpha_2(11,22)  =   k_k;
    
    %beta_1(11,2)    =   k_tau; %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_1(11,4)   =   k_psik;%should be 11,7....but this is dropped in any case
    beta_1(11,5)   =   k_xi;
    beta_1(11,6)   =   k_x;
%alpha_1(11,35)   =   k_x;
    beta_1(11,16)   =   k_mu;
end

%FOC for labour in banking sector
if entr == 1 || entr == 0
    l_R     =   1-psil*R/(1+psil*R);
    l_xi    =   k_xi;
    l_x     =   k_x;
    l_e     =   k_e;
    l_mu    =   k_mu-1;
    l_vl    =   k_vl+vl/(1-vl);
    l_vk    =   k_vk-vk/(1-vk);
    l_l     =   k_l-1;
    l_k     =   1+k_k;
    l_tau   =   k_tau;
    l_psil  =   -psil*R/(1+psil*R);
    
    alpha_1(12,5)   =   l_k;
    alpha_1(12,10)  =   l_vl;
    alpha_1(12,11)  =   l_vk;
    alpha_1(12,12)  =   l_e;
    alpha_1(12,14)  =   l_R;
    alpha_1(12,20)  =   -1;
    alpha_1(12,21)  =   l_l;
    
    alpha_2(12,22)  =   l_k;
    
    %beta_1(12,2)    =   l_tau; %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_1(12,3)    =   l_psil;
    beta_1(12,5)   =   l_xi;
   beta_1(12,6)   =   l_x;
%alpha_1(12,35)   =   l_x;
    beta_1(12,16)   =   l_mu;
end

%production function for deposits
if entr ==1 || entr ==0
    wk=psik*rk*k/(muzstar*upsil);
    wl=psil*w*l;
    F=1/( (1-tau)*(mb/(pi*muzstar))*(1-m)-tau*(wl+wk)  );
    Fb=1/( (mb/(pi*muzstar))*(1-m+chorse*dm)+wl+wk );
    
    alpha_1(13,1)   =    (mb/(pi*muzstar))*(1-tau)*(1-m)*F - (mb/(pi*muzstar))*(1-m+chorse*dm)*Fb;
    alpha_1(13,12)  =    ksi;
    alpha_1(13,20)  =    tau*psil*w*l*F+psil*w*l*Fb;
    alpha_1(13,21)  =    alpha_1(13,20);
    alpha_1(13,3)   =    tau*wk*F +wk*Fb;
    alpha_1(13,5)   =    alpha_1(13,3);
    alpha_1(13,17)  =    (mb/(pi*muzstar))*m*( (1-tau)*F-Fb);
    
    alpha_2(13,13)  =    (mb/(pi*muzstar))*( -(1-tau)*(1-m)*F + (1-m+chorse*dm)*Fb );
    alpha_2(13,22)  =   tau*wk*F+wk*Fb;
    alpha_2(13,27)  =   Fb*(mb/(pi*muzstar))*chorse*dm;
    
    beta_1(13,3)    =   tau*psil*w*l*F+psil*w*l*Fb;
    beta_1(13,16)   =   - tau*wk*F - wk*Fb - (mb/(pi*muzstar))*(1-m+chorse*dm)*Fb + (mb/(pi*muzstar))*(1-tau)*(1-m)*F; 
    beta_1(13,4)   =   alpha_1(13,3);
    beta_1(13,6)   =   -1;
%alpha_1(13,35)   =   -1;    
    %beta_1(13,2)    =   F*tau*( (mb/(pi*muzstar))*(1-m)+(psil*w*l+wk) ); %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_1(13,5)   =   log(ev)*ksi;
end

%Ra arbitrage condition
if entr ==1 || entr ==0
    alpha_1(14,12)  =   ((her-tau*her)/((1-tau)*her-1)-tau*her/(tau*her+1))*ksi;
    alpha_1(14,14)  =   -1;
    alpha_1(14,18)  =   1;
    
    %beta_1(14,2)    =   tau*her/((1-tau)*her-1)+tau*her/(tau*her+1); %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_1(14,5)   =   ((her-tau*her)/((1-tau)*her-1)-tau*her/(tau*her+1))*(1/(1-ksi)+log(ev))*ksi;
    beta_1(14,6)   =   -((her-tau*her)/((1-tau)*her-1)-tau*her/(tau*her+1));
%alpha_1(14,35)   =   -((her-tau*her)/((1-tau)*her-1)-tau*her/(tau*her+1));
end

%defition of ucz
alpha_0(15,19)  =   -beta*b*c*muzstar/((c*(muzstar-b))^2);

alpha_1(15,15)  =   uzc;
alpha_1(15,19)  =   c*(muzstar^2+beta*b^2)/((c*(muzstar-b))^2);

alpha_2(15,19)  =   -b*c*muzstar/((c*(muzstar-b))^2);

beta_0(15,16)   =   -b*c*beta*muzstar/((c*(muzstar-b))^2);
beta_0(15,22)   =   b*beta/(c*(muzstar-b));

beta_1(15,16)   =   -muzstar/(c*muzstar-b*c)+  c*(muzstar^2)/ ((c*(muzstar-b))^2);
beta_1(15,22)   =   -muzstar/(c*(muzstar-b));

%FOC for time deposits
alpha_0(16,1)   =   -1;
alpha_0(16,16)  =   1;

alpha_1(16,16)  =   -1;
alpha_1(16,23)  =   Re*(1-taud)/( 1+(1-taud)*Re);   

beta_0(16,16)   =   -1;
beta_0(16,15)   =   -Re*taud/(1+(1-taud)*Re);
beta_0(16,22)   =   1;

beta_1(16,22)   =   -1;

%FOC for M
if entr ==1 || entr ==0  
    
    Ups171  =   -(1-sigmaq)*(1-chii)*(theta-m*(1-theta)/(1-m))-(theta/m+m*(1-theta)/(1-m)^2)/(theta/m-(1-theta)/(1-m));
    
    if pref ==1 %benchmark preferences
        Ups172 = v*((1+tauc)*c*(1/m)^((1-chii)*theta))^(1-sigmaq)*(pi*muzstar/mb)^(2-sigmaq)*( (1/dm)^(chii*(1-sigmaq)))*(1/(1-m))^((1-chii)*(1-theta)*(1-sigmaq))*((1-chii)*theta/m - (1-chii)*(1-theta)/(1-m));
    elseif pref ==0 %ACEL preferences
        Ups172 = v*((1/m)^((1-chii)*theta))^(1-sigmaq)*(pi*muzstar/mb)^(2-sigmaq)*( (1/dm)^(chii*(1-sigmaq)))*(1/(1-m))^((1-chii)*(1-theta)*(1-sigmaq))*((1-chii)*theta/m - (1-chii)*(1-theta)/(1-m));
    end
    
%     if costreal ==0
%         coef = Hdoupr*((muzstar*pi)^3)/(mb*m);
%     elseif costreal ==1
%         coef = Hdoupr*(pi^2)*(muzstar^3)/(mb*m); 
%     end
%     
%     alpha_0(17,17)  =  beta*coef;
%     
%     if costreal == 0
%         alpha_1(17,1)   =  Ups172*(2-sigmaq) + beta*coef;
%     elseif costreal == 1
%         alpha_1(17,1)   =  Ups172*(2-sigmaq); 
%     end
%     alpha_1(17,13)  =   beta*coef;
%     alpha_1(17,17)  =   Ups172*Ups171 -coef*(1+beta) ;
%     alpha_1(17,16)  =   -lambdaz*(1-taud)*Ra;
%     alpha_1(17,18)  =   -lambdaz*(1-taud)*Ra;
%     if pref == 1%benchmark preferences
%         alpha_1(17,19)  =   Ups172*(1-sigmaq);
%     elseif pref == 0%ACEL preferences
%         alpha_1(17,19)  =   0;
%     end
%     
%     if costreal == 0
%         alpha_2(17,1)   =  -coef;
%     end
%     alpha_2(17,13)  =   -Ups172*(2-sigmaq) - coef*(1+beta);
%     alpha_2(17,17)  =   coef;
%     alpha_2(17,27)  =   -Ups172*chii*(1-sigmaq);
%     alpha_2(17,30)  =   coef;
%     
%     beta_1(17,8)   =   -Ups172*(1-sigmaq)* (1-chii)*(log(m)*theta - log(1-m)*theta) + Ups172*theta/(theta-m);
%     beta_1(17,9)   =   Ups172*(1-sigmaq)*chii*( theta*log(m) + (1-theta)*log(1-m) - log(dm)) - Ups172*(chii/(1-chii)) ;
% %alpha_1(17,34)   =   Ups172*(1-sigmaq)*chii*( theta*log(m) + (1-theta)*log(1-m) - log(dm)) - Ups172*(chii/(1-chii)) ;    
%     beta_1(17,14)   =  Ups172;
%     beta_1(17,15)   =  lambdaz*Ra*taud;
%     beta_1(17,16)   =  1;
%     beta_1(17,22)   =  Ups172 -lambdaz*(1-taud)*Ra;
%     if pref == 1%benchmark preferences
%         beta_1(17,20)   =  Ups172*(1-sigmaq)*tauc/(1+tauc);
%         %beta_1(17,24)   =  Ups172*(1-sigmaq); This term was inserted in
%         %order to allow for an impact of an energy price shock on consumpion 
%     elseif pref == 0 %ACEL preferences
%         beta_1(17,20)   =  0;
%         %beta_1(17,24)   =  0;This term was inserted in
%         %order to allow for an impact of an energy price shock on consumpion
%     end
%     Hdpmuz1   =   Ups172*(2-sigmaq) + beta*coef; %this is the coefficient on muzstar(t) and the next one is on muzstar(t-1). To accommodate that, we adjust tau below so that tau(16,16)=[Hdpmuz1, Hdpmuz2, 0, 0,...]
%     Hdpmuz2   =  -coef;
    
    coef = Hdoupr*pi*(muzstar)^3/(mb*m);
    
    alpha_0(17,17)  =  beta*coef;
    if costreal==1
        alpha_0(17,1)   = -beta*coef;
    end
    
    if costreal == 0
        alpha_1(17,1)   =  Ups172*(2-sigmaq) + beta*coef;
    elseif costreal == 1
        alpha_1(17,1)   =  Ups172*(2-sigmaq) +coef + beta*coef; 
    end
    alpha_1(17,13)  =   beta*coef;
    alpha_1(17,17)  =   Ups172*Ups171 -coef*(1+beta) ;
    alpha_1(17,16)  =   -lambdaz*(1-taud)*Ra;
    alpha_1(17,18)  =   -lambdaz*(1-taud)*Ra;
    if pref == 1%benchmark preferences
        alpha_1(17,19)  =   Ups172*(1-sigmaq);
    elseif pref == 0%ACEL preferences
        alpha_1(17,19)  =   0;
    end
    
    alpha_2(17,1)   =  -coef;
    alpha_2(17,13)  =   -Ups172*(2-sigmaq) - coef*(1+beta);
    alpha_2(17,17)  =   coef;
    alpha_2(17,27)  =   -Ups172*chii*(1-sigmaq);
    alpha_2(17,30)  =   coef;
    
    beta_1(17,8)   =   -Ups172*(1-sigmaq)* (1-chii)*(log(m)*theta - log(1-m)*theta) + Ups172*theta/(theta-m);
    beta_1(17,9)   =   Ups172*(1-sigmaq)*chii*( theta*log(m) + (1-theta)*log(1-m) - log(dm)) - Ups172*(chii/(1-chii)) ;
%alpha_1(17,34)   =   Ups172*(1-sigmaq)*chii*( theta*log(m) + (1-theta)*log(1-m) - log(dm)) - Ups172*(chii/(1-chii)) ;    
    beta_1(17,14)   =  Ups172;
    beta_1(17,15)   =  lambdaz*Ra*taud;
    beta_1(17,16)   =  1;
    beta_1(17,22)   =  Ups172 -lambdaz*(1-taud)*Ra;
    if pref == 1%benchmark preferences
        beta_1(17,20)   =  Ups172*(1-sigmaq)*tauc/(1+tauc);
        %beta_1(17,24)   =  Ups172*(1-sigmaq); This term was inserted in order to allow for an impact of an energy price shock on consumpion 
    elseif pref == 0 %ACEL preferences
        beta_1(17,20)   =  0;
        %beta_1(17,24)   =  0;This term was inserted in order to allow for an impact of an energy price shock on consumpion
    end
    Hdpmuz1   =   Ups172*(2-sigmaq) + beta*coef; %this is the coefficient on muzstar(t) and the next one is on muzstar(t-1). To accommodate that, we adjust tau below so that tau(16,16)=[Hdpmuz1, Hdpmuz2, 0, 0,...]
    Hdpmuz2   =  -coef;


elseif entr == -1
    
    alpha_1(17,1)  = 2-sigmaq;
    alpha_1(17,14) = -1;
    alpha_1(17,16) = -1;
    alpha_1(17,17) = -(2-sigmaq);
    alpha_1(17,19) = 1-sigmaq;
    
    alpha_2(17,13) = -(2-sigmaq);
    
    beta_1(17,14)  = 1;
    beta_1(17,16)  = 2-sigmaq;
    
end    

%FOC for Mb
if entr >-1
    if pref == 1%benchmark preferences
        Ups181  =   beta*v*(1-theta)*(1-chii)*((1+tauc)*c*(1/m)^((1-chii)*theta))^(1-sigmaq)*(1/mb)^(2-sigmaq)*( (1/dm)^(chii*(1-sigmaq)))*(1/(1-m))^((1-chii)*(1-theta)*(1-sigmaq)+1)*(pi*muzstar)^(1-sigmaq);
    elseif pref == 0%ACEL preferences
        Ups181  =   beta*v*(1-theta)*(1-chii)*((1/m)^((1-chii)*theta))^(1-sigmaq)*(1/mb)^(2-sigmaq)*( (1/dm)^(chii*(1-sigmaq)))*(1/(1-m))^((1-chii)*(1-theta)*(1-sigmaq)+1)*(pi*muzstar)^(1-sigmaq);
    end

    Ups182  =   ((1-theta)*(1-chii)*(1-sigmaq)+1)/(1-m);

    alpha_0(18,1)   =   -(beta*lambdaz/(pi*muzstar)) * (1+(1-taud)*Ra) + Ups181*(1-sigmaq);

    alpha_0(18,16)  =   (1/(pi*muzstar))*beta*lambdaz*(1+(1-taud)*Ra);
    alpha_0(18,17)  =   -Ups181*( (1-chii)*theta*(1-sigmaq)-Ups182*m);

    alpha_0(18,18)  =   (1/(pi*muzstar))*beta*lambdaz*(1-taud)*Ra;
    if pref == 1%benchmark preferences
        alpha_0(18,19)  =   Ups181*(1-sigmaq);
    elseif pref == 0%ACEL preferences
        alpha_0(18,19)  =   0;
    end

    alpha_1(18,13)  =   -Ups181*(2-sigmaq);
    alpha_1(18,16)  =   -lambdaz;
    alpha_1(18,27)  =   -chii*(1-sigmaq)*Ups181;

    beta_0(18,8)   =   -Ups181*(theta/(1-theta)+theta*(1-sigmaq)*(1-chii)*log(m)-(1-sigmaq)*(1-chii)*log(1-m)*theta);
    beta_0(18,9)   =   Ups181*( -(chii/(1-chii))+log(m)*(1-sigmaq)*theta*chii+log(1-m)*(1-theta)*(1-sigmaq)*chii-log(dm)*(1-sigmaq)*chii );
    %alpha_0(18,34)   =   Ups181*( -(chii/(1-chii))+log(m)*(1-sigmaq)*theta*chii+log(1-m)*(1-theta)*(1-sigmaq)*chii-log(dm)*(1-sigmaq)*chii );
    beta_0(18,14)   =   Ups181;
    beta_0(18,15)   =   -(1/(pi*muzstar))*beta*lambdaz*taud*Ra;
    beta_0(18,16)   =   -(1/(pi*muzstar))*beta*lambdaz*(1+(1-taud)*Ra) + Ups181*(1-sigmaq);
    beta_0(18,22)   =   Ups181+(beta*lambdaz/(pi*muzstar)) * (1+(1-taud)*Ra);
    if pref == 1 %benchmark preferences
        beta_0(18,20)   =   Ups181*(1-sigmaq)*tauc/(1+tauc);
        %beta_0(18,24)   =   Ups181*(1-sigmaq); This term was inserted in order to allow for an impact of an energy price shock on consumpion
    elseif pref == 0 %ACEL preferences
        beta_0(18,20)   =   0;
        %beta_0(18,24)   =   0;This term was inserted in order to allow for an impact of an energy price shock on consumpion
    end

    beta_1(18,22)   =   -lambdaz;

elseif entr ==-1 || entr ==-2
    alpha_0(18,1)   =   -1;
    alpha_0(18,16)  =   1;

    alpha_1(18,16)  =   -1;
    alpha_1(18,14)  =   R*(1-taud)/(1+(1-taud)*R);
    beta_0(18,16)   =   -1;
    beta_0(18,15)   =   -R*taud/(1+(1-taud)*R);
    %%%%WARNING!!! When estimating CEE with the risk premium shock, disactivate the following two shocks and activate the third (using zetaH)
    beta_0(18,22)   =   1;
    beta_1(18,22)   =   -1;
end

if entr ~= -2
    %for discussion of how the above equation is handled when entr = -2, see
    %the special adjustment on alpha's and beta's done below.

    %FOC for consumption
    if entr ~=-3
       if pref == 0 %ACEL preferences
           Ups19   =  0;
       elseif pref == 1
           Ups19   =   -v*(c^(-sigmaq))*( (1+tauc)*(pi*muzstar/mb)*((1/m)^((1-chii)*theta))*((1/(1-m))^((1-chii)*(1-theta)))*((1/dm)^chii) )^(1-sigmaq);
       end
    else
        Ups19=0;
    end
    alpha_1(19,1)   =  Ups19*(1-sigmaq);
    alpha_1(19,15)  =   uzc;
    alpha_1(19,16)  =   -(1+tauc)*lambdaz;
    alpha_1(19,17)  =   Ups19*(1-chii)*(1-sigmaq)*( ((1-theta)*m/(1-m)) -theta);
    alpha_1(19,19)  =   -Ups19*sigmaq;

    alpha_2(19,13)  =   -Ups19*(1-sigmaq);
    alpha_2(19,27)  =   -Ups19*chii*(1-sigmaq);

    if pref == 1 %benchmark preferences
        beta_1(19,14)   =   Ups19;
        beta_1(19,20)   =   -lambdaz*tauc + Ups19*(1-sigmaq)*tauc/(1+tauc);
        beta_1(19,22)   =   Ups19-(1+tauc)*lambdaz;
        %beta_1(19,24)   =   -lambdaz*(1+tauc) + Ups19*(1-sigmaq);This term was inserted in order to allow for an impact of an energy price shock on consumpion
    elseif pref == 0 %ACEL preferences
        beta_1(19,14)   =   0;
        beta_1(19,20)   =   -lambdaz*tauc;
        beta_1(19,22)   =   -(1+tauc)*lambdaz;
        %beta_1(19,24)   =   -lambdaz*(1+tauc);This term was inserted in order to allow for an impact of an energy price shock on consumpion
    end
    if entr >-1 %when entr=-1, we have m=dm=0; to avoid log(m) and log(dm) we disconnect the following 2 entries when entr<-1
        beta_1(19,8)   =   Ups19*(-(1-chii)*theta*(1-sigmaq)*log(m)+log(1-m)*(1-chii)*(1-sigmaq)*theta  );
        beta_1(19,9)   =   Ups19*( log(m)*theta*(1-sigmaq)*chii + log(1-m)*(1-theta)*(1-sigmaq)*chii - log(dm)*(1-sigmaq)*chii );
%alpha_1(19,34)   =   Ups19*( log(m)*theta*(1-sigmaq)*chii + log(1-m)*(1-theta)*(1-sigmaq)*chii - log(dm)*(1-sigmaq)*chii );        
    end
    beta_1(19,16)   =   Ups19*(1-sigmaq);
end

%wage equation
bw      =   (lambdaw*sigmaL-(1-lambdaw))/((1-xiw)*(1-beta*xiw));
eta_0   =   bw*xiw;
eta_1   =   -bw*(1+beta*xiw^2)+sigmaL*lambdaw;
eta_2   =   beta*xiw*bw;
eta_3b  =   bw*xiw*iotaw2;
eta_3   =   -xiw*bw*(1+beta*iotaw2);
eta_4   =   bw*xiw*beta;
eta_5   =   -sigmaL*(1-lambdaw);
eta_6   =   1-lambdaw;
eta_7   =   bw*xiw*(iotamu-1);
eta_8   =   -bw*xiw*beta*(iotamu-1);
eta_9   =   bw*xiw*iotaw1;
eta_10  =   -bw*xiw*beta*iotaw1;
eta_11  =   -taul*(1-lambdaw)/(1-taul);
eta_12  =   -(1-lambdaw);

alpha_0(20,1)   =   eta_4;
alpha_0(20,20)  =   eta_2;

alpha_1(20,1)   =   eta_3;
alpha_1(20,16)  =   eta_6;
alpha_1(20,20)  =   eta_1;
alpha_1(20,21)  =   eta_5;

alpha_2(20,1)   =   eta_3b;
alpha_2(20,20)  =   eta_0;

beta_0(20,2)    =   eta_10;
beta_0(20,16)   =   eta_8;

beta_1(20,2)    =   eta_9;
beta_1(20,10)   =   eta_11;
%%%WARNING!!! Disactivate the following zetaH shock if you run the estimation of CEE  with the risk premium shock.
beta_1(20,12)   =   eta_12;
beta_1(20,16)   =   eta_7;


%resource constraint
if entr == 1 || entr==-3
    d       =   mu*kbar*(1+Rk)*G/(pi*muzstar);
elseif entr==0 || entr==-1 ||entr==-2 
    d        = 0;
    bigtheta = 0;
end
c_y     =   c/(y+phi+d+(1-gamma)*bigtheta*vn);
g_y     =   g/(y+phi+d+(1-gamma)*bigtheta*vn);
d_y     =   d/(y+phi+d+(1-gamma)*bigtheta*vn);
v_y     =   vn/(y+phi+d+(1-gamma)*bigtheta*vn);
u_y     =   (rk*kbar/(muzstar*upsil))/(y+phi+d+(1-gamma)*bigtheta*vn);
kbar_y  =   kbar/(y+phi+d+(1-gamma)*bigtheta*vn);

alpha_1(21,1)   =   -d_y;
alpha_1(21,4)   =   kbar_y*i/kbar;
alpha_1(21,5)   =   u_y-alpha;
if entr == 1 || entr==-3
    alpha_1(21,6)   =   Gp/G*omegabar*d_y;
    alpha_1(21,8)   =  bigtheta*(1-gamma)*v_y*n/(n-we);
end
alpha_1(21,7)   =   d_y*Rk/(1+Rk);
alpha_1(21,10)  =   -(1-alpha);
alpha_1(21,11)  =   -alpha;
alpha_1(21,19)  =   c_y;
alpha_1(21,21)  =   -(1-alpha);

alpha_2(21,9)   =   d_y;
alpha_2(21,22)  =   d_y-alpha;

beta_1(21,7)   =   -kbar_y*i/k;
beta_1(21,13)   =   g_y;
beta_1(21,16)   =   alpha-d_y;
beta_1(21,17)   =   -bigtheta*v_y;
beta_1(21,18)   =   -1;
%beta_1(21,24)   =   c_y;This term was inserted in rder to allow for an impact of an energy price shock on consumpion
if entr == 1 ||entr==-3
    beta_1(21,21)  =   d_y*(Gs/G)*sigma;%this coefficient should be on sigma(t-1); to accomodate this, we set it on sigma(t) and adjust tau(20,21) below as explained in the manuscript
end

%capital accumulation equation
alpha_1(22,4)   =   -i/kbar;
alpha_1(22,22)  =   1;

alpha_2(22,22)  =   -(1-delta)/(muzstar*upsil);

beta_1(22,16)   =   (1-delta)/(muzstar*upsil);
%beta_1(22,23)   =  -i/kbar;

if entr > -2
    %money base evolution
    if timing == 1
        alpha_1(23,1)   =   1;
        alpha_1(23,13)  =   1;
        alpha_1(23,24)  =   -x/(1+x);

        alpha_2(23,13)  =   -1;

        beta_1(23,16)   =   1;
    end
end

%policy rule
Rb    =  (R*her)/(tau*her+1);

if Taylor == 1 
    if entr <=-1
        error('fatal (makealphabeta) Taylor=1 and entr=-1. When Taylor=1 the rule is on Rb. But when entr=-1 we have dropped Rb')
    end
    if forward ==1 
        alpha_0(24,1)  =  -(1-rhotil)*aptil*pi/Rb;
        alpha_1(24,1)   =  -(1-rhotil)*muzstar*pi*amtil/Rb;
    elseif forward == -1
        alpha_1(24,1)   =  -(1-rhotil)*muzstar*pi*amtil/Rb;
        alpha_2(24,1)  =  -(1-rhotil)*aptil*pi/Rb;
    elseif  forward == 0 
        alpha_1(24,1)   =  -(1-rhotil)*muzstar*pi*amtil/Rb -(1-rhotil)*aptil*pi/Rb;
    end
    alpha_1(24,14)  =  R/Rb;
    alpha_1(24,18)  =  Ra/Rb;
    alpha_1(24,19)  =  -(1-rhotil)*(aytil/(4*Rb))*c/y;
    alpha_1(24,4)   =  -(1-rhotil)*(aytil/(4*Rb))*i/y;
    alpha_1(24,29)  =  -(1-rhotil)*amtil*muzstar*pi/Rb;
    alpha_1(24,30)  =  -(1-rhotil)*actil*muzstar/Rb;
    
    alpha_2(24,14)  =  -rhotil*R/Rb;
    alpha_2(24,18)  =  -rhotil*Ra/Rb;
    alpha_2(24,29)  =  (1-rhotil)*amtil*muzstar*pi/Rb;
    alpha_2(24,30)  =  (1-rhotil)*actil*muzstar/Rb;
    
    beta_1(24,2)   =  (1-rhotil)*aptil*pi/Rb;
    beta_1(24,7)   =  (1-rhotil)*(aytil/(4*Rb))*i/y;
    beta_1(24,13)  =  -(1-rhotil)*(aytil/(4*Rb))*g/y;
    beta_1(24,16)  =  -(1-rhotil)*muzstar*(pi*amtil+actil)/Rb;
    beta_1(24,19)  =  -1/(400*Rb);
    
elseif Taylor == 2     
    ia=23;
    if entr== -1 || entr==-2
        ia = 14;
        RT=R;
        amtil=0;
        actil=0;
    end
    if entr==-3
        amtil=0;
    elseif entr==0
        actil=0;
    end

    if forward ==1 
        alpha_0(24,1)  =  -(1-rhotil)*aptil*pi/RT;
        alpha_1(24,1)  =  -(1-rhotil)*muzstar*pi*amtil/RT - (1-rhotil)*adptil/RT;
        alpha_2(24,1)  =  (1-rhotil)*adptil/RT; 
    elseif forward == -1
        alpha_1(24,1)   =  -(1-rhotil)*muzstar*pi*amtil/RT - (1-rhotil)*adptil/RT;
        alpha_2(24,1)   =  -(1-rhotil)*aptil*pi/RT + (1-rhotil)*adptil/RT;               
    elseif forward == 0 
        alpha_1(24,1)   =  -(1-rhotil)*muzstar*pi*amtil/RT - (1-rhotil)*aptil*pi/RT  - (1-rhotil)*adptil/RT; 
        alpha_2(24,1)   =  (1-rhotil)*adptil/RT; 
    end
       
    alpha_1(24,ia)  =  1;
    alpha_1(24,4)   =  -(1-rhotil)*i/y*(adytil*muzstar+aytil)/(4*RT); %i
    alpha_1(24,19)  =  -(1-rhotil)*c/y*(adytil*muzstar+aytil)/(4*RT); %c
    alpha_1(24,29)  =  -(1-rhotil)*amtil*muzstar*pi/RT; %m3
    %alpha_1(24,8)  =  -(1-rhotil)*actil*muzstar/RT;
    %alpha_1(24,28)  =  1;
    alpha_1(24,31)  =  -(1-rhotil)*actil*muzstar/RT;
    alpha_2(24,4)   =  (1-rhotil)*i/y*(adytil*muzstar)/(4*RT); %i      
    alpha_2(24,19)  =  (1-rhotil)*c/y*(adytil*muzstar)/(4*RT); %c
    
    alpha_2(24,ia)  =  -rhotil;
    %alpha_2(24,8)  =  (1-rhotil)*actil*muzstar/RT;
    %alpha_2(24,28)  =  -rhotil;
    alpha_2(24,29)  =  (1-rhotil)*amtil*muzstar*pi/RT; %m3
    alpha_2(24,31)  =  (1-rhotil)*actil*muzstar/RT;
    beta_1(24,2)   =  1;
    Taylorstar1 = (1-rhotil)*aptil*pi/RT - (1-rhotil)*pi/RT; %this is the coefficient on inflation objective shock (t) and Taylorstar2 is on (t-1). To accommodate that, we adjust tau below so that tau(23,2)=[Taylorstar1, Taylorstar2, 0, 0,...]
    Taylorstar2 = 0; %rhotil*pi/RT; %RM changed it on 8 September 2005

    beta_1(24,7)  = 1;
    beta_1(24,13) = 1;
    Taylormup1 = (1-rhotil)*i/y*(adytil*muzstar+aytil)/(4*RT);
    Taylormup2 = -(1-rhotil)*i/y*(adytil*muzstar)/(4*RT);
    Taylorg1  =  -(1-rhotil)*g/y*(adytil*muzstar+aytil)/(4*RT);
    Taylorg2  = (1-rhotil)*g/y*(adytil*muzstar)/(4*RT);
        
    beta_1(24,16)  =  -(1-rhotil)*muzstar*(pi*amtil + adytil/4 + actil)/RT;
    beta_1(24,19)  =  -1/(400*RT);
    
elseif Taylor == 0 
    alpha_1(24,24)  =   -1;
    
    beta_1(24,19)  =     1;
    
%     beta_1(24,3)    =   1;
%     beta_1(24,5)    =   1;
%     beta_1(24,6)    =   1;
%     beta_1(24,9)    =   1;
%     beta_1(24,12)   =   1;
%     beta_1(24,15)   =   1;
%     beta_1(24,18)   =   1;
%     beta_1(24,21)   =   1;
%     beta_1(24,24)   =   1;
%     beta_1(24,27)   =   1;
%     beta_1(24,30)   =   1;
%     beta_1(24,33)   =   1;
%     beta_1(24,36)   =   1;
%     beta_1(24,39)   =   1;
%     beta_1(24,42)   =   1;
%     beta_1(24,45)   =   1;
%     beta_1(24,48)   =   1;
%     beta_1(24,51)   =   1;
%     beta_1(24,54)   =   1;
%     beta_1(24,55)   =   1;
%     beta_1(24,60)   =   1;
%     beta_1(24,63)   =   1;

elseif Taylor ==3
    alpha_1(24,24) = -1;     
    alpha_1(24,1)  = - (1-par7)*(par1 +par3);
    alpha_1(24,19) = -(1-par7)*par2*c/y;
    alpha_1(24,4)  = -(1-par7)*par2*i/y;
    
    alpha_2(24,1)  = (1-par7)*par3;
    alpha_2(24,19) = (1-par7)*par2*c/y;
    alpha_2(24,4)  = (1-par7)*par2*i/y;
    alpha_2(24,24) = par7;
    
    beta_1(24,7)  = 1;
    Baserule_muupt   = (1-par7)*par2*i/y;
    Baserule_muuptm1 = -(1-par7)*par2*i/y;
    
    beta_1(24,13)    = 1;
    Baserule_gt      = -(1-par7)*par2*g/y;
    Baserule_gtm1    = (1-par7)*par2*g/y;
    
    beta_1(24,5)  = 1;
    Baserule_xit   = (1-par7)*par4;
    Baserule_xitm1 = -(1-par7)*par4;
    
    beta_1(24,6)  = 1;
    Baserule_xbt    = (1-par7)*par6;
    Baserule_xbtm1  = -(1-par7)*par6;
    
    beta_1(24,9)  = 1;
    Baserule_chit   = (1-par7)*par5;
    Baserule_chitm1 = -(1-par7)*par5;

    beta_1(24,2)   = (1-par7)*(1+par1);
    beta_1(24,16)  = -(1-par7)*par2;
    beta_1(24,19)  = 1;  
end    


%FOC for capital (this is relevant when entrepreneurs are absent (i.e when entr=0 and entr=-1))
alpha_0(25,16)  =   1;
alpha_0(25,7)   =   Rk/(1+Rk);
alpha_0(25,1)   =   -1;

alpha_1(25,16)  =   -1;

beta_0(25,16)   =   -1;
beta_0(25,22)   =   1;

beta_1(25,22)   =   -1;

if entr == -1
    %loan market equilibrium (relevant when banks are absent)
    alpha_1(26,1)   =  (mb/(pi*muzstar))*(1-m);
    alpha_1(26,20)  =   psil*w*l;
    alpha_1(26,21)  =   psil*w*l;
    alpha_1(26,3)   =   psik*rk*k/(upsil*muzstar);
    alpha_1(26,5)   =   psik*rk*k/(upsil*muzstar);
    alpha_1(26,17)  =   mb*m/(pi*muzstar);

    alpha_2(26,13)  =   -(mb/(pi*muzstar))*(1-m);
    alpha_2(26,22)  =   psik*rk*k/(upsil*muzstar);

    beta_1(26,3)    =   psil*w*l;
    beta_1(26,4)   =   psik*rk*k/(upsil*muzstar);
    beta_1(26,16)   =   -psik*rk*k/(upsil*muzstar) + (mb/(pi*muzstar))*(1-m);
end

%FOC for banks' choice of Dm
if entr ==1 || entr ==0
    alpha_0(27,14)  =   -(1/RT)*chorse*R/(her*tau+1);
    alpha_0(27,12)  =   -(1/RT)*chorse*R*tau*her*ksi/((her*tau+1)^2);
    
    alpha_1(27,23)   = 1;
    alpha_1(27,28)   =  -Rm/RT;
    
    %beta_0(27,2)    =   (1/RT)*chorse*R*tau*her/((her*tau+1)^2); %note: shock #2 used to be reserve requirement; now it denotes inflation target shock
    beta_0(27,5)   =   -(1/RT)*(chorse*R*tau*her*ksi/((her*tau+1)^2))*( (1/(1-ksi)) + log(ev) );
    beta_0(27,6)   =  (1/RT)*chorse*R*tau*her/((her*tau+1)^2);
%alpha_0(27,35)   =  (1/RT)*chorse*R*tau*her/((her*tau+1)^2);
end

%Household's choice of Dm
if entr ==1 ||entr ==0
    Ups29  =   beta*v*chii*((1+tauc)*c*(1/m)^((1-chii)*theta))^(1-sigmaq)*(1/mb)^(2-sigmaq)*( (1/dm)^(chii*(1-sigmaq)))*(1/(1-m))^((1-chii)*(1-theta)*(1-sigmaq))*(1/dm)*(pi*muzstar)^(1-sigmaq);
    
    alpha_0(28,1)   =  -beta*lambdaz*(1+(1-taud)*Rm)/(pi*muzstar) +Ups29*(1-sigmaq);
    if pref == 1
        alpha_0(28,19)  =  Ups29*(1-sigmaq);
    elseif pref ==0
        alpha_0(28,19)  =0;
    end
    alpha_0(28,17)  =  Ups29*(-(1-chii)*theta*(1-sigmaq) + (1-chii)*(1-theta)*(1-sigmaq)*(1/(1-m))*m );
    alpha_0(28,16)  =  beta*(lambdaz/(pi*muzstar))*(1+(1-taud)*Rm); 
    
    alpha_1(28,13)  =  -Ups29*(2-sigmaq);
    alpha_1(28,27)  =  -Ups29*(chii*(1-sigmaq) +1);
    alpha_1(28,16)  =  -lambdaz;
    alpha_1(28,28)  =  beta*(lambdaz/(pi*muzstar))*(1-taud)*Rm ;
    
    beta_0(28,8)    =  Ups29*( -log(m)*(1-chii)*(1-sigmaq)*theta + log(1-m)*(1-chii)*(1-sigmaq)*theta );
    beta_0(28,9)    =  Ups29*( log(m)*theta*(1-sigmaq)*chii +log(1-m)*(1-theta)*(1-sigmaq)*chii -log(dm)*(1-sigmaq)*chii +1 );
%alpha_0(28,34)    =  Ups29*( log(m)*theta*(1-sigmaq)*chii +log(1-m)*(1-theta)*(1-sigmaq)*chii -log(dm)*(1-sigmaq)*chii +1 );      
    beta_0(28,14)   =   Ups29;
    beta_0(28,15)   =  -beta*lambdaz*taud*Rm/(pi*muzstar);
    beta_0(28,16)   =  -beta*lambdaz*(1+(1-taud)*Rm)/(pi*muzstar) + Ups29*(1-sigmaq);
    beta_0(28,22)   =   Ups29+beta*(lambdaz/(pi*muzstar))*(1+(1-taud)*Rm);
    if pref == 1
        beta_0(28,20) = Ups29*(1-sigmaq)*tauc/(1+tauc);
        %beta_0(28,24) = Ups29*(1-sigmaq);This term was inserted in order to allow for an impact of an energy price shock on consumpion
    elseif pref ==0
        beta_0(28,20) = 0;
        %beta_0(28,24) = 0;This term was inserted in order to allow for an impact of an energy price shock on consumpion
    end
    
    beta_1(28,22)   =  -lambdaz; 
end

%scaled M3 or M3-M1
m3_m1 = 0; %=0, use M3; =1, use M3-M1

if entr==1 || entr==0
    if m3_m1 == 0

        if begin ==1
            alpha_1(29,1)   =  -(1/m3)*(mb/(pi*muzstar))*(1+dm);
        end
        alpha_1(29,3)   =  (1/m3)*psik*rk*kbar/(muzstar*upsil);
        alpha_1(29,5)   =  (1/m3)*psik*rk*kbar/(muzstar*upsil);
        alpha_1(29,20)  =  (1/m3)*psil*w*l;
        alpha_1(29,21)  =  (1/m3)*psil*w*l;
        alpha_1(29,29)  =  -1;
        if begin ==0
            alpha_1(29,13)  =  (1/m3)*mb*(1+dm);
            alpha_1(29,27)  =  mb/m3*dm;

        elseif begin ==1
            alpha_2(29,13)  =  (1/m3)*(mb/(pi*muzstar))*(1+dm);
            alpha_2(29,27)  =  (mb/(m3*pi*muzstar))*dm;
        end
        alpha_2(29,22)  =  (1/m3)*psik*rk*kbar/(muzstar*upsil);

        beta_1(29,3)   =   (1/m3)*psil*w*l;
        beta_1(29,4)   =  (1/m3)*psik*rk*kbar/(muzstar*upsil);
        if begin ==1
            beta_1(29,16)  =   -(1/m3)*(mb/(pi*muzstar))*(1+dm) -(1/m3)*psik*rk*kbar/(muzstar*upsil);
        elseif begin ==0
            beta_1(29,16)  =   -(1/m3)*psik*rk*kbar/(muzstar*upsil);
        end

    elseif m3_m1 == 1
        alpha_1(29,29)  = 1;
        if begin ==1
            alpha_1(29,1)  =  1;
            
            alpha_2(29,13) = -1;
            alpha_2(29,27) = -1;
            
            beta_1(29,16)  =  1;           
        elseif begin ==0
            alpha_1(29,13) = -1;
            alpha_1(29,27) = -1;
        end
    end
end

%Introduce a lag of scaled Mb (we need this for H'' and for constructing M1 growth)
if entr ==1 || entr ==0
    alpha_1(30,30) = 1;
    alpha_2(30,13) = -1;
end

%scaled total loans
if entr ==1 || entr==-3
    if begin ==1
        alpha_1(31,1)   = (kbar-n)/(btot*pi*muzstar);
    end
    alpha_1(31,3)   = -psik*rk*kbar/(upsil*muzstar*btot);
    alpha_1(31,5)   = -psik*rk*kbar/(upsil*muzstar*btot);
    alpha_1(31,20)  = -psil*w*l/btot;
    alpha_1(31,21)  = -psil*w*l/btot;
    alpha_1(31,31)  = 1;
    if begin ==0
        alpha_1(31,8)   = n/btot; %n
        alpha_1(31,9)   = -kbar/btot; %q
        alpha_1(31,22)  = -kbar/btot;
        alpha_2(31,22)  = -psik*rk*kbar/(upsil*muzstar*btot);
    elseif begin ==1
        alpha_2(31,8)   = n/(btot*pi*muzstar); %n
        alpha_2(31,9)   = -kbar/(btot*pi*muzstar); %q
        alpha_2(31,22)  = -psik*rk*kbar/(upsil*muzstar*btot) -kbar/(btot*pi*muzstar);
    end
    
    beta_1(31,3)    = -psil*w*l/btot;
    beta_1(31,4)    = -psik*rk*kbar/(upsil*muzstar*btot);
    if begin ==1
        beta_1(31,16)   = psik*rk*kbar/(upsil*muzstar*btot) + (kbar-n)/(btot*pi*muzstar);
    elseif begin ==0
        beta_1(31,16)   = psik*rk*kbar/(upsil*muzstar*btot);
    end
end

%Introduce a lag of scaled k (we need this for constructing M1 growth)
if entr ==1 || entr ==0
    alpha_1(32,32) = 1;
    alpha_2(32,22) = -1;
end

%Calvo equation linking employment and hours
alpha_0(33,33) = beta/(1+beta); %E(t+1)

alpha_1(33,21) =  (1-beta*xiE)*(1-xiE)/(xiE*(1+beta)); %h
alpha_1(33,33) =  -1 - (1-beta*xiE)*(1-xiE)/(xiE*(1+beta)); %E(t)

alpha_2(33,33) =  1/(1+beta); %E(t-1)

%Average q
qavrg = muzstar*( (vk*(k/(muzstar*upsil))^alpha *l^(1-alpha) -phi) - w*l -i) / ( (1-delta)*kbar*(1-beta)/(upsil*muup));

G33a = upsil*muup*muzstar*(vk*(k/(muzstar*upsil))^alpha*l^(1-alpha) -phi)/(kbar*qavrg*(1-delta));
G33b = upsil*muup*muzstar*w*l/(kbar*qavrg*(1-delta));
G33c = upsil*i*muzstar/(kbar*qavrg*(1-delta));
G33d = upsil*muup*muzstar/(kbar*qavrg*(1-delta)) *(vk*(k/(muzstar*upsil))^alpha*l^(1-alpha) ); 

alpha_0(34,16) = beta;
alpha_0(34,34) = beta;

alpha_1(34,4) = -G33c;
alpha_1(34,5) = G33d*alpha;
alpha_1(34,10) = G33d;
alpha_1(34,16) = -beta;
alpha_1(34,20) = -G33b;
alpha_1(34,21) = -G33b +G33d*(1-alpha);
alpha_1(34,22) = beta;
alpha_1(34,34) = -1;

alpha_2(34,22) = -G33a +alpha*G33d  +G33b +G33c -beta;

beta_0(34,7) = -beta;
beta_0(34,16) = -beta;

beta_1(34,7) = G33a - G33b +beta;
beta_1(34,16) = G33a -G33d*alpha -G33b -G33c +beta;
beta_1(34,18) = G33d;

% %autoregressive representation of chi
% alpha_1(35,35) = 1;
% alpha_2(35,35) = -par1;
% beta_1(35,9)   = 1;
% 
% %autoregressive representation of xb
% alpha_1(36,36) = 1;
% alpha_2(36,36) = -par3;
% beta_1(36,6)   = 1;

% %autoregressive representation of gamma
% alpha_1(37,37) = 1;
% alpha_2(37,37) = -par6;
% beta_1(37,17)   = -1;

% %autoregressive representation of zetai
% alpha_1(37,37) = 1;
% alpha_2(37,37) = -par5;
% beta_1(37,23)  = -1;
% %beta_1(37,17)  = -par7;


%--------------------------------------------------------------------------
% Sum up column 10 and 11 in order to eliminate vk; 
alpha_0(:,10)   =   alpha_0(:,10)+alpha_0(:,11);
alpha_1(:,10)   =   alpha_1(:,10)+alpha_1(:,11);
alpha_2(:,10)   =   alpha_2(:,10)+alpha_2(:,11);

%Drop row 11; 
alpha_0         =   [alpha_0(1:10,:);alpha_0(12:end,:)];
alpha_1         =   [alpha_1(1:10,:);alpha_1(12:end,:)];
alpha_2         =   [alpha_2(1:10,:);alpha_2(12:end,:)];
beta_0          =   [beta_0(1:10,:);beta_0(12:end,:)];
beta_1          =   [beta_1(1:10,:);beta_1(12:end,:)];

%Drop column 11, 24 and 25 in the alphas
alpha_0         =   [alpha_0(:,1:10),alpha_0(:,12:24),alpha_0(:,27:end)];
alpha_1         =   [alpha_1(:,1:10),alpha_1(:,12:24),alpha_1(:,27:end)];
alpha_2         =   [alpha_2(:,1:10),alpha_2(:,12:24),alpha_2(:,27:end)];
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------

%set the vector sss containing the steady-state value of all the shocks
sss =[lambdaf; pi; psil; psik; ksi; xb; muup; theta; chii; taul; tauk; zeta; g; v; taud; muzstar; gamma; epsil; x; tauc; sigma; 1; 1; 1;1];

%--------------------------------------------------------------------------

%There are three adjustments are now made to the beta's. First, they must
%be padded out with zeros to reflect that overall vector exogenous process
%is modelled as AR(1), while each shock can be a univariate AR(2). Also,
%each shock can potentially have a signal, and this also gives rise to a need for padding.
%Second, some shocks enter with a lag, and this requires idiosyncratic
%treatment. The details are recorded in the matrix taux below, and are
%discussed in the big manuscript. Third, manipulations are done to
%transform the shocks to lie inside the unit circle. 
% All these manipulations are checked carefully when we do redo them based
% on numerical derivatives. 

%Construct the tau's that connect beta0 to beta0_tilde and beta1 to beta1_tilde. Note that we consider only the shocks that ...
%are in the vector taushock.
%Note that we have to accommodate sigma(t-1) in eq. 7, 8, 21, tauk(t-1) in eq. 9 and the presence of muzstar(t) and muzstar(t-1) in FOC for M
betasmall_0 = beta_0; %store the original betas to be used for checking analitical derivatives
betasmall_1 = beta_1;

M=eye(numshocks);

for ii = 1:length(shock_trans)
    M(shock_trans(ii),shock_trans(ii))=1-sss(shock_trans(ii));
    if max(shock_trans(ii)==taushock)==1
        if sss(shock_trans(ii)) ==1 || sss(shock_trans(ii))==0
            error('fatal (makealphabeta), the steady-state value of the shock that should lie within the unit interval has been set at 0 or 1')
        end
    end
end
betaM_0 = beta_0*M; %adjust the betas
betaM_1 = beta_1*M;

b_0j=[];
beta_0=[];
b_1j=[];
beta_1=[];
for ii=1:size(betaM_0,1)
    for j=1:length(taushock)
        taux    = zeros(1,parstoch(taushock(j))+2);
        taux(1) = 1; 

        bb0 =betaM_0(ii,taushock(j))*taux;
        b_0j =[b_0j, bb0];

        if taushock(j)==21 && ii==7 %commented out when we changed the timing moving sigma_t shock one period backward
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(2) = 1; 
        elseif taushock(j)==21 && ii==8
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(2) = 1; 
        elseif taushock(j)==21 && ii==20
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(2) = 1; 
        elseif taushock(j)==11 && ii==9 
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(2) = 1; 
            
            
        elseif taushock(j)==2 && ii == 23 %taylor rule
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0 || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor==2 
               taux(1)= Taylorstar1;
               taux(2)= Taylorstar2;
            elseif Taylor ==3 || Taylor==0
               taux(1)= 1;
            end

        elseif taushock(j)==7 && ii==23
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0  || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor ==2
                taux(1)= Taylormup1;
                taux(2)= Taylormup2;
            elseif Taylor ==3 
                taux(1)= Baserule_muupt;
                taux(2)= Baserule_muuptm1;
            elseif Taylor ==0
                taux(1)= 1;
            end
            
        elseif taushock(j)==13 && ii==23
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0 || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor ==2
                taux(1)= Taylorg1;
                taux(2)= Taylorg2;
            elseif Taylor ==3
                taux(1)= Baserule_gt;
                taux(2)= Baserule_gtm1;
            elseif Taylor ==0
                taux(1)= 1;
            end
            
        elseif taushock(j)==5 && ii==23
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0 || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor ==2 || Taylor ==0
                taux(1)= 1;
            elseif Taylor ==3
                taux(1)= Baserule_xit;
                taux(2)= Baserule_xitm1;
            end

        elseif taushock(j)==6 && ii==23
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0 || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor ==2 || Taylor ==0
                taux(1)= 1;
            elseif Taylor ==3
                taux(1)= Baserule_xbt;
                taux(2)= Baserule_xbtm1;
            end
            
         elseif taushock(j)==9 && ii==23
            if irun ==1  
                taux    = zeros(1,parstoch(taushock(j))+2);
            elseif irun ==0 || irun ==7 
                taux    = sym(zeros(1,parstoch(taushock(j))+2));                
            end
            if Taylor ==1 || Taylor ==2 || Taylor ==0
                taux(1)= 1;
            elseif Taylor ==3
                taux(1)= Baserule_chit;
                taux(2)= Baserule_chitm1;
            end
            
            
%         elseif taushock(j)==9 & ii==35
%             taux    = sym(zeros(1,parstoch(taushock(j))+2));
%             taux(1)= -1;
%             taux(2)= -par2;
%             
%         elseif taushock(j)==6 & ii==36
%             taux    = sym(zeros(1,parstoch(taushock(j))+2));
%             taux(1)= -1;
%             taux(2)= -par4;

           
        elseif taushock(j)==16 && ii==16 
            if entr >-1
                if irun ==1  
                    taux    = zeros(1,parstoch(taushock(j))+2);
                elseif irun ==0 || irun ==7 
                    taux    = sym(zeros(1,parstoch(taushock(j))+2));
                end
                taux(1) = Hdpmuz1;
                taux(2) = Hdpmuz2;
            elseif entr<=-1
                taux    = zeros(1,parstoch(taushock(j))+2);
                taux(1) = 1; 
            end
            
        else
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(1) = 1; 
        end
        
        bb1 =betaM_1(ii,taushock(j))*taux;
        b_1j =[b_1j, bb1];
    end
    beta_0 = [beta_0; b_0j];
    b_0j=[];
    
    beta_1 = [beta_1; b_1j];
    b_1j=[];    
end

%alternative versions of the model
if entr == -2;%model without entrepeneurs, banks or money
    %drop equations 6, 7, 8, 10, 11,12,13,16,18,22,25,26,27,28. Add 24.
    %drop variables: 6 (omegabar),8 (n) ,10 (vl) ,11 (ev),12 (mb),15 (lamz),16 (m), 23 (x),Ra,dm,Rm,m3,btot
 
    %alpha_i, i=0,1,2, have right dimension 30. This corresponds to all the date t endogenous
    %                  variables in the model, as listed in the manuscript.    %                  
    %beta_i, i=0,1, have right dimension 2 * number of elements in taushock
    %
    %For this version of the model, zetac_hat(t) = ucz_hat(t) - lambdaz_hat(t) - (tauc/(1+tauc))*tauc_hat(t). 
    %We want to use this to substitute out lambdaz-hat(t) from z(t).
    %
    %To do this, we take the column of alpha_i, corresponding to
    %ucz(t) (i.e., 14th variable in z(t)), and add to it the column that
    %corresponds to lambdaz(t) (15th variable in z(t)), for i=0,1,2.
    %
    alpha_0(:,14)=alpha_0(:,14)+alpha_0(:,15);
    alpha_1(:,14)=alpha_1(:,14)+alpha_1(:,15);
    alpha_2(:,14)=alpha_2(:,14)+alpha_2(:,15);
    %
    %we now turn to the beta's. If zetac and tauC are not among the shocks, no
    %further adjustment is required.
    %
    
    if max(taushock==22) == 1         
        II=2*(find(taushock==22)-1)+1;
        beta_0(:,II)=beta_0(:,II)-alpha_0(:,15);
        beta_1(:,II)=beta_1(:,II)-alpha_1(:,15);
        if max(abs(double(alpha_2(:,15)))) > .1e-10 
            error('fatal (makealphabeta) a lagged value of lambaz is trying to sneak in')
        end
    end
    if max(taushock==20) == 1         
        II=2*(find(taushock==20)-1)+1;
        beta_0(:,II)=beta_0(:,II)-(tauc/(1+tauc))*alpha_0(:,15);
        beta_1(:,II)=beta_1(:,II)-(tauc/(1+tauc))*alpha_1(:,15);
        if max(abs(double(alpha_2(:,15)))) > .1e-10 
            error('fatal (makealphabeta) a lagged value of lambaz is trying to sneak in')
        end
    end
    
    if do_qavrg ==0
        tt1=[1:5,9,14, 17,19:21,23:24,32];  %equations being kept
        tt2=[1:5,7,9,13,14,18:21,30];  %variables
        ssp=[1:5,9,14,17,19:21,23:24];  %equations to be checked   
    elseif do_qavrg ==1
        tt1=[1:5,9,14, 17,19:21,23:24,32,33];  %equations being kept
        tt2=[1:5,7,9,13,14,18:21,30,31];  %variables
        ssp=[1:5,9,14,17,19:21,23:24,33];  %equations to be checked
    end
    
elseif entr ==-3 %model with entrepreneurs and no banks
    %drop equations 10,11,12,13,16,17,22,24,25,26,27,28,29,31   
    %drop variables: 10(vl), 11(ev),12(mb),13(R),16(m),17(Ra),23(x),24(dm), 25(Rm), 26(m3), 27(mb(lag)),29(k(lag))
    
    if do_qavrg ==0
        tt1=[1:9,14:15,18:21,23,30,32]; %equations being kept
        tt2=[1:9,14:15,18:22,28,30];    %variables
        ssp=[1:9 14:15 18:21 23 30]; %equations to be checked
    elseif do_qavrg ==1
        tt1=[1:9,14:15,18:21,23,30,32,33]; %equations being kept
        tt2=[1:9,14:15,18:22,28,30,31];    %variables
        ssp=[1:9 14:15 18:21 23 30 33]; %equations to be checked
    end


elseif entr == -1  %model without entrepeneurs or banks
    %drop equations 6, 7, 8, 10, 11,12,13,26,27,28. Add 24 and 25.
    %drop variables: 6,8,10,11,Ra,dm,Rm,m3,btot

    if do_qavrg ==0
        tt1=[1:5,9,14, 16,17:24,25,32];  %equations being kept
        tt2=[1:5,7,9,12,13,14,15,16,18:21,23,30];  %variables
        ssp=[1:5,9,14,16,17,18,19,20:23,24,25];  %equations to be checked
    elseif do_qavrg ==1
        tt1=[1:5,9,14, 16,17:24,25,32,33];  %equations being kept
        tt2=[1:5,7,9,12,13,14,15,16,18:21,23,30,31];  %variables
        ssp=[1:5,9,14,16,17,18,19,20:23,24,25,33];  %equations to be checked  
    end

elseif entr == 0  %benchmark, no entrepreneurial sector NOTE THAT THE z(t) VECTOR IS REDEFINED...
    %drop equations 6, 7 and 8 and add 24. Drop variables 6 and 8.

    if do_qavrg ==0
        tt1=[1:5,9:24,26:29,31:32]; %equations being kept
        tt2=[1:5,7,9:27,29:30]; %variables
        ssp=[1:5,9:18,19,20:23,24,26:28]; %equations to be checked (numerical derivatives)
    elseif do_qavrg ==1
        tt1=[1:5,9:24,26:29,31:32,33]; %equations being kept
        tt2=[1:5,7,9:27,29:30,31]; %variables
        ssp=[1:5,9:18,19,20:23,24,26:28,33]; %equations to be checked (numerical derivatives)
    end

elseif entr == 1 %benchmark

    if do_qavrg ==0
        tt1=[1:23,26:32]; %equations being kept
        tt2=[1:30];  %variables
        ssp=[1:23 26:28 30 31]; % equations to be checked (numerical derivatives)
    elseif do_qavrg ==1
        tt1=[1:23,26:32,33]; %equations being kept
        tt2=[1:31];  %variables
        ssp=[1:23 26:28 30 31 33]; % equations to be checked (numerical derivatives)
    end

end

if length(tt1) ~= nn
    error('fatal (makealphabeta) number of elements in z(t) does not match length of tt1')
end

tt=1:length(tt1);
for ii = 1:length(ssp)
    sp(ii)=tt(tt1==ssp(ii));%this is the index number of the equations being analyzed, where the numbering corresponds to what is here.
end

alpha_0=alpha_0(tt1,tt2);
alpha_1=alpha_1(tt1,tt2);
alpha_2=alpha_2(tt1,tt2);

beta_0=beta_0(tt1,:);
beta_1=beta_1(tt1,:);

%if you want to check the analytic derivatives by comparing them with numerical derivatives, execute the following code:
if icheck == 1
    if irun ~=1
        error('you want to do the check using numerical derivative, but it only works with irun=1. Reset irun')
    end
    alpha_00=alpha_0;
    alpha_10=alpha_1;
    alpha_20=alpha_2;

    beta_00=beta_0;
    beta_10=beta_1;

    disp(' (makealphabeta) comparing alpha''s and beta''s from analytic formulas with corresponding objects obtained numerically')
    disp(' the results of the check are reported in checkalpha.out')


    %the manuscript refers to 28 elements in z(t). However, in various
    %versions of the model some of these are dropped, so that z(t) has only
    %nn elements. To find where a variable, say the 9th in the old ordering,
    %is in the new ordering, evaluate tts(tt2==9). Similarly, the
    %10th equation in the old ordering is now the one in tts(tt1==10).

    tts=1:37;%numbering of variables in z(t) in manuscript

    h=l;%as long as steady-state prices are not distorted, h=l. this is the only case that will ever be addressed
    %by makealphabeta

    pstar = 1;
    wstar = 1;
    Yzss = vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))/lambdaf;
    Fp = lambdaz*Yzss/(1-beta*xip);
    Fw = (l*(1-taul)*lambdaz/lambdaw)/(1-beta*xiw);
    wplus = 1;
    
    loadupnonlinnew

    ppnonlin=[zp1'; z0'; zm1'; psip1'; psip0'];
    
    if Taylor ~= 2
        error('fatal (makealphabeta): file nonlin does not include yet versions of policy rule different from the one associated with Taylor=2')
    end
    %verify that the steady states are correct:
    [ffnonlin] = nonlinnew(ppnonlin,params,pi,rk,country,Taylor,forward,Re,c,i,g,R,Ra,begin,kbar);

    tt1bis = [tt1, size(ffnonlin,1)-6, size(ffnonlin,1)-5, size(ffnonlin,1)-4, size(ffnonlin,1)-3, size(ffnonlin,1)-2, size(ffnonlin,1)-1, size(ffnonlin,1)];
    if max(abs(ffnonlin(tt1bis ))) > .2e-7
        error('fatal (makealphabeta) steady state failed accuracy check')
    end

    %get the numerical derivatives:
    [QQnonlin]=derivative('nonlinnew',ppnonlin,params,pi,rk,country,Taylor,forward,Re,c,i,g,R,Ra,begin,kbar);

    %convert the numerical derivatives to 'hats'...
    a1=3*length(zp1)+19;%location of xpp1
    a2=3*length(zp1)+numshocks+37;%xp0
    a3=3*length(zp1)+numshocks+38;%xpm1
    
    JJ=[[1:a1-1], [a1+1:a2-1],[a3+1:length(ppnonlin)]];   

    for ii = JJ
        QQnonlin(:,ii)=QQnonlin(:,ii)*ppnonlin(ii);
    end

    QQnonlin(1,:) = QQnonlin(36,:)-QQnonlin(37,:);
    QQnonlin(1,:) = QQnonlin(1,:)/QQnonlin(1,nn+5+1); %normalise on pi(t)

    QQnonlin(19,:) = (QQnonlin(38,:)./QQnonlin(38,nn+5+nn+4))-(QQnonlin(39,:)./QQnonlin(39,nn+5+nn+4));
    QQnonlin(19,:) = QQnonlin(19,:)/QQnonlin(19,nn+5+tts(tt2==19)); %normalise on w(t)
    axx2 = alpha_10(tts(tt1==19),tts(tt2==19));
    alpha_00(tts(tt1==19),:) = alpha_00(tts(tt1==19),:)/axx2;
    alpha_10(tts(tt1==19),:) = alpha_10(tts(tt1==19),:)/axx2;
    alpha_20(tts(tt1==19),:) = alpha_20(tts(tt1==19),:)/axx2;
    beta_00(tts(tt1==19),:)  = beta_00(tts(tt1==19),:)/axx2;
    beta_10(tts(tt1==19),:)  = beta_10(tts(tt1==19),:)/axx2;
    
    for ij = 1:5
        if QQnonlin(1,nn+ij) >.2e-6 || QQnonlin(1,nn+5+nn+ij) >.2e-6 || QQnonlin(1,nn+5+nn+5+nn+ij) >.2e-6  || QQnonlin(19,nn+ij) >.2e-6 || QQnonlin(19,nn+5+nn+ij) >.2e-6 || QQnonlin(19,nn+5+nn+5+nn+ij) >.2e-6 
            error('fatal, check on nonlinear pricing equation failed')
        end
    end
            
    QQ=QQnonlin(1:(size(QQnonlin,1)-7),[1:nn, ((nn+5)+1):(nn+5)+nn, (2*(nn+5)+1):2*(nn+5)+nn, (3*(nn+5)+1):(3*(nn+5)+numshocks), (3*(nn+5)+numshocks+1):length(QQnonlin)] );


    a=(-QQ(2,nn+2));
    QQ(2,:)=QQ(2,:)/a;

    a=(-QQ(3,nn+2));
    QQ(3,:)=QQ(3,:)/a;

    a=(QQ(4,nn+tts(tt2==9)));
    QQ(4,:)=QQ(4,:)/a;
    
    a=-(QQ(5,nn+tts(tt2==5)));
    QQ(5,:)=QQ(5,:)/a;
  
    if entr == 1 || entr==-3;
        a=(QQ(7,2*nn+tts(tt2==8)));
        QQ(7,:)=QQ(7,:)/a;

        a=(-QQ(8,nn+tts(tt2==8)));
        QQ(8,:)=QQ(8,:)/a;
    end

    a=(QQ(9,nn+tts(tt2==7)));
    QQ(9,:)=QQ(9,:)/a;

    if entr ==0 || entr==1
        sign_=sign(alpha_1(tts(tt1==10),tts(tt2==11)));
        a=QQ(10,nn+tts(tt2==11));
        QQ(10,:)=QQ(10,:)/(sign_*a);

        a=(-QQ(11,nn+tts(tt2==19)));
        QQ(11,:)=QQ(11,:)/a;

        a=(-QQ(12,3*nn+numshocks+11)); %it is normalised on xb(t)
        QQ(12,:)=QQ(12,:)/a;

        a=(QQ(13,nn+tts(tt2==17)));
        QQ(13,:)=QQ(13,:)/a;
    end
    
    if entr ~= -2
        a=(-QQ(15,nn+tts(tt2==15)));
        QQ(15,:)=QQ(15,:)/a;
    end
    
    if entr <= -1
        if entr == -1;QQ(16,:)=-QQ(16,:)/QQ(16,nn+tts(tt2==13));end
        QQ(17,:)=-QQ(17,:)/QQ(17,1);
    end

    %a=(-QQ(16,nn+tts(tt2==15)));
    %QQ(16,:)=QQ(16,:)/a;
    
    a=(-QQ(20,3*nn+numshocks+35)); %it is normalised on eps_t
    QQ(20,:)=QQ(20,:)/a;

    a=(QQ(21,nn+tts(tt2==21)));
    QQ(21,:)=QQ(21,:)/a;

    if timing == 1
        a=(QQ(22,nn+tts(tt2==12)));
    elseif timing == 0
        %a=(QQ(22,2*nn+tts(tt2==12)));
    end
    
    if entr > -2;QQ(22,:)=QQ(22,:)/a;end
    
    if entr ~=1
        if entr > -2
            a=-(QQ(24,nn+tts(tt2==15)));
            QQ(24,:)=QQ(24,:)/a;
        end
        if entr == -2
            a=-QQ(24,1);
            QQ(24,:)=QQ(24,:)/a;
        end
    end

    if entr >-1
        a=(QQ(26,nn+tts(tt2==22)));
        QQ(26,:)=QQ(26,:)/a;

        a=-(QQ(28,nn+tts(tt2==26)));
        QQ(28,:)=QQ(28,:)/a;
    end
    if entr ==1 || entr==-3
        a=(QQ(30,nn+tts(tt2==28)));
        QQ(30,:)=QQ(30,:)/a;
    end
    
    if do_qavrg ==1
       a=-(QQ(33,nn+tts(tt2==31)));
       QQ(33,:)=QQ(33,:)/a;
    end

    %load the QQ's into alphas and betas
    alpha0=QQ(tt1,[1:nn]);
    alpha1=QQ(tt1,[nn+1:2*nn]);
    alpha2=QQ(tt1,[2*nn+1:3*nn]);
    beta0=QQ(tt1,[3*nn+1:3*nn+numshocks]);
    beta1=QQ(tt1,[3*nn+numshocks+1:end]);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    M_beta1 = eye(2*size(M,1)); %the left dimension of beta1 is: number of shocks (ie. 25) times 2
    %ss_beta1 = [5 7 9 15 17 19 21 29 33 39]; %this is related to the shocks that lie in the unit interval defined above
    %ss=[3 4 5 8 9 10 11 15 17 20];
    for ii=1:length(shock_trans)
        ss_beta1(ii) = (shock_trans(ii)-1)*2+1;
    end
   
    for ii = 1:length(shock_trans)
        M_beta1(ss_beta1(ii),ss_beta1(ii))=1-sss(shock_trans(ii));
        M_beta1(ss_beta1(ii)+1,ss_beta1(ii)+1)=1-sss(shock_trans(ii));
    end
    beta0M = beta0*M; %adjust beta0
    beta1M = beta1*M_beta1; %adjust beta1

    b0j=[];
    beta0=[];
    b1j=[];
    beta1=[];
    for ii=1:size(beta0M,1)
        for j=1:length(taushock)
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(1) = 1;
            bb0 = beta0M(ii,taushock(j))*taux;
            b0j = [b0j, bb0];

            bb1_1 = beta1M(ii,2*(taushock(j)-1)+1)*taux;
            taux(1) =0;
            taux(2) =1;
            bb1_2 = beta1M(ii,2*(taushock(j)-1)+2)*taux;
            bb1 = bb1_1 + bb1_2;
            b1j =[b1j, bb1];

        end
        beta0 = [beta0; b0j];
        b0j=[];

        beta1 = [beta1; b1j];
        b1j=[];
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ix0=0;
    ix1=0;
    ix2=0;
    ixb0=0;
    ixb1=0;
    tol=.1e-4;
    for ii = sp
        for jj = 1:length(tt1)
            if abs(alpha_00(ii,jj)-alpha0(ii,jj)) > tol
                ix0=ix0+1;
                II0(ix0,1)=ii;
                II0(ix0,2)=jj;
            end
            if abs(alpha_10(ii,jj)-alpha1(ii,jj)) > tol
                ix1=ix1+1;
                II1(ix1,1)=ii;
                II1(ix1,2)=jj;
            end
            if abs(alpha_20(ii,jj)-alpha2(ii,jj)) > tol
                ix2=ix2+1;
                II2(ix2,1)=ii;
                II2(ix2,2)=jj;
            end
        end
        for jj = 1:size(beta0,2)
            if abs(beta_00(ii,jj)-beta0(ii,jj)) > tol
                ixb0=ixb0+1;
                IIb0(ixb0,1)=ii;
                IIb0(ixb0,2)=jj;
            end
            if abs(beta_10(ii,jj)-beta1(ii,jj)) > tol
                ixb1=ixb1+1;
                IIb1(ixb1,1)=ii;
                IIb1(ixb1,2)=jj;
            end
        end
    end

    if ix0 == 0 && ix1 == 0 && ix2 == 0 && ixb0 == 0 && ixb1 == 0
        disp(' Congratulations....all the alphas and betas are correct!')
    end
    %keyboard
    
    fid = fopen([cdir '\checkalphas.out'],'w');
    fprintf(fid,'Indeces reported in checks pertain to equation number in manuscript, alpha0 is nonlinear and alpha_0 is linearised\n');
    if ix0 > 0
        fprintf(fid,'Following are the checks on alpha0\n\n\n');
        for ii = 1:ix0
            fprintf(fid,'alpha0(%d,%d) = %8.5f, alpha_0(%d,%d) = %8.5f, percent difference = %12.9f\n',tt1(II0(ii,1)),tt2(II0(ii,2)), ...
                alpha0(II0(ii,1),II0(ii,2)),tt1(II0(ii,1)),tt1(II0(ii,2)),alpha_00(II0(ii,1),II0(ii,2)), ...
                100*(alpha0(II0(ii,1),II0(ii,2))-alpha_00(II0(ii,1),II0(ii,2)))/alpha_00(II0(ii,1),II0(ii,2)));
        end
        fprintf(fid,'\n\n\n');
    end
    if ix1 > 0
        fprintf(fid,'Following are the checks on alpha1\n\n\n');
        for ii = 1:ix1
            fprintf(fid,'alpha1(%d,%d) = %8.5f, alpha_1(%d,%d) = %8.5f, percent difference = %12.9f\n',tt1(II1(ii,1)),tt2(II1(ii,2)), ...
                alpha1(II1(ii,1),II1(ii,2)),tt1(II1(ii,1)),tt2(II1(ii,2)),alpha_10(II1(ii,1),II1(ii,2)), ...
                100*(alpha1(II1(ii,1),II1(ii,2))-alpha_10(II1(ii,1),II1(ii,2)))/alpha_10(II1(ii,1),II1(ii,2)));
        end
        fprintf(fid,'\n\n\n');
    end
    if ix2 > 0
        fprintf(fid,'Following are the checks on alpha2\n\n\n');
        for ii = 1:ix2
            fprintf(fid,'alpha2(%d,%d) = %8.5f, alpha_2(%d,%d) = %8.5f, percent difference = %12.9f\n',tt1(II2(ii,1)),tt2(II2(ii,2)), ...
                alpha2(II2(ii,1),II2(ii,2)),tt1(II2(ii,1)),tt2(II2(ii,2)),alpha_20(II2(ii,1),II2(ii,2)), ...
                100*(alpha2(II2(ii,1),II2(ii,2))-alpha_20(II2(ii,1),II2(ii,2)))/alpha_20(II2(ii,1),II2(ii,2)));
        end
        fprintf(fid,'\n\n\n');
    end
    if ixb0 > 0
        fprintf(fid,'Following are the checks on beta0\n\n\n');
        for ii = 1:ixb0
            fprintf(fid,'beta0(%d,%d) = %8.5f, beta_0(%d,%d) = %8.5f, percent difference = %12.9f\n',tt1(IIb0(ii,1)),IIb0(ii,2), ...
                beta0(IIb0(ii,1),IIb0(ii,2)),tt1(IIb0(ii,1)),IIb0(ii,2),beta_00(IIb0(ii,1),IIb0(ii,2)), ...
                100*(beta0(IIb0(ii,1),IIb0(ii,2))-beta_0(IIb0(ii,1),IIb0(ii,2)))/beta_00(IIb0(ii,1),IIb0(ii,2)));
        end
        fprintf(fid,'\n\n\n');
    end
    if ixb1 > 0
        fprintf(fid,'Following are the checks on beta1\n\n\n');
        for ii = 1:ixb1
            fprintf(fid,'beta1(%d,%d) = %8.5f, beta_1(%d,%d) = %8.5f, percent difference = %12.9f\n',tt1(IIb1(ii,1)),IIb1(ii,2), ...
                beta1(IIb1(ii,1),IIb1(ii,2)),tt1(IIb1(ii,1)),IIb1(ii,2),beta_10(IIb1(ii,1),IIb1(ii,2)), ...
                100*(beta1(IIb1(ii,1),IIb1(ii,2))-beta_10(IIb1(ii,1),IIb1(ii,2)))/beta_10(IIb1(ii,1),IIb1(ii,2)));
        end
    end
    fclose(fid);
    
    if rpl == 0 %=0, the code will use the results coming from the numerical linearisation. The reason is that in presence of Leontief technology in the banking sector, we have adjusted the steady state and the non-linear FOCs, but not the analytical derivatives
        alpha_0(sp,:)=alpha0(sp,:);
        alpha_1(sp,:)=alpha1(sp,:);
        alpha_2(sp,:)=alpha2(sp,:);
        beta_0(sp,:)=beta0(sp,:);
        beta_1(sp,:)=beta1(sp,:);
        alphas  =  [alpha_0 alpha_1 alpha_2];
        betas  =  [beta_0 beta_1];
    elseif rpl == 1
        alpha_0(sp,:)=alpha_00(sp,:);
        alpha_1(sp,:)=alpha_10(sp,:);
        alpha_2(sp,:)=alpha_20(sp,:);
        beta_0(sp,:)=beta_00(sp,:);
        beta_1(sp,:)=beta_10(sp,:);
        alphas  =  [alpha_0 alpha_1 alpha_2];
        betas  =  [beta_0 beta_1];
    end
end

%specify the shocks which are not seen on impact
excl  = ones(1,size(beta_0,2)); %you see everything. this corresponds to setting money=3 in parameterseuro
if money == 1 %the shocks you don't see are [3 4 5 8 9 14 17]. you do see the monetary shock
    excl=[];
    limited  =  [3 4 5 8 9 14 17];
    for ii = 1:length(taushock)
        exclu = ones(1,parstoch(taushock(ii))+2);
        if max(limited==taushock(ii))==1
            exclu=zeros(1,parstoch(taushock(ii))+2);
        end
        excl = [excl, exclu];
    end
elseif money == 2 %you see all the shocks but the monetary shock
    excl=[];
    limited  =  [19];
    for ii = 1:length(taushock)
        exclu = ones(1,parstoch(taushock(ii))+2);
        if max(limited==taushock(ii))==1
            exclu=zeros(1,parstoch(taushock(ii))+2);
        end
        excl = [excl, exclu];
    end
elseif money == 0 %you see all the shocks but the monetary shock
    excl=[];
    limited  =  [3 4 5 8 9 14 17 19];
    for ii = 1:length(taushock)
        exclu = ones(1,parstoch(taushock(ii))+2);
        if max(limited==taushock(ii))==1
            exclu=zeros(1,parstoch(taushock(ii))+2);
        end
        excl = [excl, exclu];
    end
end

%impose information restrictions on the alternative models
if entr <= -1  %model without entrepeneurs and banks
    
    if entr == -1
        %reorder the equations to match "a" variables with "a" equations (i.e. exchange 12 with 10, 16 with 14)
        nn_check = 18;
        if do_qavrg ==1
            nn_check = nn_check+1;
        end
        sel=1:nn_check;
        if money ~= 3 || nn ~= nn_check
            error('fatal (makealphabeta) program not designed to handle exotic information sets')
        end
    elseif entr==-2
        nn_check = 14;
        if do_qavrg ==1
            nn_check = nn_check+1;
        end
        sel=1:nn_check;
        if money ~= 3 || nn ~= nn_check
            error('fatal (makealphabeta) program not designed to handle exotic information sets')
        end
    elseif entr==-3
        nn_check = 18;
        if do_qavrg ==1
            nn_check = nn_check +1;
        end
        sel=1:nn_check;
        if money ~= 3 || nn ~= nn_check
            error('fatal (makealphabeta) program not designed to handle exotic information sets')
        end
    end
    II=eye(nn);
    Je=II(sel,:);
    alpha_2=Je*alpha_2;
    alpha_1=Je*alpha_1;
    alpha_0=Je*alpha_0;
    alphas =[alpha_0 alpha_1 alpha_2];
    beta_0 = Je*beta_0;%adjust beta0 and beta1 to reflect change of equations 
    beta_1 = Je*beta_1;
    betas = [beta_0 beta_1];  
    
    if max(excl) ~= 1 && min(excl) ~= 1
        error('fatal (makealphabeta) program not designed to handle exotic info sets')
    end

    nnn=size(excl,2);
    taumat          =   ones(nn,nnn);

    taumat(1,:)     =   excl;
    taumat(4,:)     =   excl;
    taumat(5,:)     =   excl;
    taumat(11,:)    =   excl;
    taumat(12,:)    =   excl;
    taumat(13,:)    =   excl;
    if entr == -1;taumat(14,:)    =   excl;end
  
    taumat          =   taumat';
    
elseif entr == 0  % model without entrepreneurial sector
    
    %make a change in variable. Define Vf(t) = vl(t) +(1-alpha)L(t)
    Q = eye(nn);
    Q(18,18) = 1-alpha;
    Q(18,8) = 1;
    QI=inv(Q);  
    
    alpha_0=alpha_0*QI;
    alpha_1=alpha_1*QI;
    alpha_2=alpha_2*QI;

    %reorder the equations to match "a" variables with "a" equations (i.e. exchange 14 with 13, 17 with 15 and 21 with 19)
    nn_check = 27;
    if do_qavrg ==1
        nn_check = nn_check+1;
    end
    sel=[1 2 3 4 5 6 7 8 9 10 11 12 14 13 17 16 15 18 21 20 19 22 23 24 25 26 27:nn_check];
    II=eye(nn);
    Je=II(sel,:);
    
    alpha_2=Je*alpha_2;
    alpha_1=Je*alpha_1;
    alpha_0=Je*alpha_0;
    alphas =[alpha_0 alpha_1 alpha_2];
    beta_0 = Je*beta_0;%adjust beta0 and beta1 to reflect change of equations 
    beta_1 = Je*beta_1;
    betas = [beta_0 beta_1];  %adjust beta0 and beta1 to reflect change of equations 
    
    nnn=size(excl,2);
    taumat          =   ones(nn,nnn);
    
    taumat(1,:)     =   excl;
    taumat(4,:)     =   excl;
    taumat(5,:)     =   excl;
    taumat(14,:)    =   excl;
    taumat(16,:)    =   excl;
    taumat(17,:)    =   excl;
    taumat(18,:)    =   excl;
    taumat(19,:)    =   excl;
  
    taumat          =   taumat';
    
elseif entr == 1%benchmark    
    nnn=size(excl,2);   
    taumat   =   ones(nn,nnn);
    part=[1, 4, 5, 16, 18, 19, 21];%these are the partial information equations...
    
    for ll = 1:length(part)
        taumat(part(ll),:)=excl;
    end
    
    taumat   =   taumat';
       
    %interchange the 3rd and 10th equations, and the 11th and 20th. This is helpful for imposing that vl and l are limited information variables
    nn_check = 30;
    if do_qavrg ==1
        nn_check = nn_check +1;
    end
    sel=[1 2 10 4 5 6 7 8 9 3 20 12 13 14 15 16 17 18 19 11 21 22 23 24 25 26 27 28 29 30:nn_check];
    II=eye(nn);
    Je=II(sel,:);
    alpha_2=Je*alpha_2;
    alpha_1=Je*alpha_1;
    alpha_0=Je*alpha_0;
    alphas  =  [alpha_0 alpha_1 alpha_2];

    beta_0 = Je*beta_0;%adjust beta0 and beta1 to reflect change of equations 
    beta_1 = Je*beta_1;
    betas = [beta_0 beta_1]; 

end

if irun == 0  || irun ==7 
    a0 = myfortran(alpha_0,'alpha0');
    a1 = myfortran(alpha_1,'alpha1');
    a2 = myfortran(alpha_2,'alpha2');
    b0 = myfortran(beta_0,'beta0');
    b1 = myfortran(beta_1,'beta1');
    
    fid = fopen([cdir '\newalphabeta.m'],'w');
    
    title = 'function [alphas,alpha2,alpha1,alpha0,betas] = newalphabeta(size_a,size_b,sigmaa,xiw,xip,Sdoupr,Hdoupr,rhotil,aptil,aytil,amtil,actil,iota1,iota2,iotaw1,iotaw2,iotamu,adptil,adytil,xiE,par1,par2,par3,par4,par5,par6,par7,par8,par9,par10)';
    fprintf(fid,'%s\n',title);
    fprintf(fid,'%s\n','alpha0 = zeros(size_a);');
    fprintf(fid,'%s\n','alpha1 = zeros(size_a);');
    fprintf(fid,'%s\n','alpha2 = zeros(size_a);');
    fprintf(fid,'%s\n','beta0 = zeros(size_b);');
    fprintf(fid,'%s\n','beta1 = zeros(size_b);');
    for ii=1:size(a0,1)
        fprintf(fid,'%s\n',char(a0(ii,:)));
    end
    for ii=1:size(a1,1)
        fprintf(fid,'%s\n',char(a1(ii,:)));
    end
    for ii=1:size(a2,1)
        fprintf(fid,'%s\n',char(a2(ii,:)));
    end
    for ii=1:size(b0,1)
        fprintf(fid,'%s\n',char(b0(ii,:)));
    end
    for ii=1:size(b1,1)
        fprintf(fid,'%s\n',char(b1(ii,:)));
    end
    fprintf(fid,'%s\n','alphas =[alpha0 alpha1 alpha2];');
    fprintf(fid,'%s\n','betas = [beta0 beta1];');
    fclose(fid);
end