function maketable_vardec_sample(Corrs_cmr,Corrs_fish,Corrs_bgg,Corrs_sw,Corrs_b,Relvar_cmr,Relvar_fish,Relvar_bgg,Relvar_sw,Relvar_b, ...
     name,nameshock,namevariable,taushock_cmr,taushock_bgg,taushock_b,taushock_fish,taushock_sw,tauvar_cmr,tauvar_bgg, ...
     tauvar_b,tauvar_fish,tauvar_sw,signal_cmr,signal_bgg,signal_b,signal_fish,signal_sw,outfolder,cdir,parstoch)

nameshock = nameshock(1:end-1,:); %remove the string in last row which refers to 'Measurement error'

n_col= size(nameshock,1); %this # includes the activated signals

legend_str = 'For each variable, figures for the benchmark model are in the first row. The alternative models, if present, are in the following rows.';

%inflate the size of Relvar and Corrs in alternative models in order to make them of same size as benchmark model
indx_row = [];
if isempty(Relvar_fish)==0
    [Relvar_fish,Corrs_fish,V_total_fish]=maketable_vardec_sample_util(Relvar_fish,Corrs_fish,taushock_fish,tauvar_fish,signal_fish,signal_cmr,taushock_cmr,tauvar_cmr,n_col,parstoch);
    legend_str = [legend_str ' Benchmark model with no Fisher effect is denoted by [()].'];
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Relvar_bgg)==0
    [Relvar_bgg,Corrs_bgg,V_total_bgg]=maketable_vardec_sample_util(Relvar_bgg,Corrs_bgg,taushock_bgg,tauvar_bgg,signal_bgg,signal_cmr,taushock_cmr,tauvar_cmr,n_col,parstoch);
    legend_str = [legend_str ' Financial accelerator model is denoted by ().']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Relvar_b)==0
    [Relvar_b,Corrs_b,V_total_b]=maketable_vardec_sample_util(Relvar_b,Corrs_b,taushock_b,tauvar_b,signal_b,signal_cmr,taushock_cmr,tauvar_cmr,n_col,parstoch);
    legend_str = [legend_str ' Model without entrepreneuers is denoted by (()).']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Relvar_sw)==0
    [Relvar_sw,Corrs_sw,V_total_sw]=maketable_vardec_sample_util(Relvar_sw,Corrs_sw,taushock_sw,tauvar_sw,signal_sw,signal_cmr,taushock_cmr,tauvar_cmr,n_col,parstoch);
    legend_str = [legend_str ' Simple Model is denoted by [].']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end

nameshock = char(nameshock,'Total');

ncol = n_col+2; %last 2 additional columns allow for variables' names and column with sum of relative variances
lengthxx = length(tauvar_cmr);

fid=fopen([outfolder '\write_temp_big_sample.m'],'w');

fprintf(fid,'function write_temp_big_sample \n');

fprintf(fid,['fid = fopen(''' [strrep(cdir,'\','\\') '\\' outfolder(3:end) '\\' name] ''',''w''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\documentclass{article} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsfonts} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsmath} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\setcounter{MaxMatrixCols}{10} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{OutputFilter=LATEX.DLL} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Version=4.10.0.2345} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\\\Standard LaTeX Article">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{CSTFile=40 LaTeX article.cst} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\newtheorem{theorem}{Theorem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{acknowledgement}[theorem]{Acknowledgement} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{algorithm}[theorem]{Algorithm} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{axiom}[theorem]{Axiom} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{case}[theorem]{Case} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{claim}[theorem]{Claim} \\n''); \n' );
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conclusion}[theorem]{Conclusion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{condition}[theorem]{Condition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conjecture}[theorem]{Conjecture} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{corollary}[theorem]{Corollary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{criterion}[theorem]{Criterion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{definition}[theorem]{Definition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{example}[theorem]{Example} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{exercise}[theorem]{Exercise} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{lemma}[theorem]{Lemma} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{notation}[theorem]{Notation} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{problem}[theorem]{Problem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{proposition}[theorem]{Proposition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{remark}[theorem]{Remark} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{solution}[theorem]{Solution} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{summary}[theorem]{Summary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newenvironment{proof}[1][Proof]{\\\\noindent\\\\textbf{#1.} }{\\\\ \\\\rule{0.5em}{0.5em}} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\input{tcilatex} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{document} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{equation*} \\n''); \n');

nn = '|l||';
for ii=1:ncol-3
    nn = [nn 'c|'];
end
nn= [nn 'c||' 'c|'];
fprintf(fid,['fprintf(fid,'' \\\\begin{tabular}{' nn '} \\\\hline \\n ''); \n']);

fprintf(fid,['fprintf(fid,'' \\\\multicolumn{' num2str(ncol) '}{|c|}{Table: Variance Decomposition Computed in Sample in Alternative Models } \\\\\\\\ [1.5ex] \\\\hline \\n''); \n']);

fprintf(fid,' keyboard  \n');


nameshock_ = ['''$' deblank(nameshock(1,:)) '$'''];
ssf = '{%%s}';
for ii=2:ncol-1
    nameshock_ = [nameshock_ ',''$' deblank(nameshock(ii,:)) '$'''];
    ssf = [ssf '& {%%s}'];
end
ssf = ['multicolumn{1}{|l||}{}& ' ssf];

fprintf(fid,['fprintf(fid, '' \\\\'  ssf ' \\\\\\\\  [1.5ex] \\\\hline \\\\hline \\n'',' nameshock_ '); \n']);

for ii=1:lengthxx
    
    if abs(Relvar_cmr(ii,1)) <1
        if abs(Relvar_cmr(ii,1)) < 0.05
            Relvar_cmr(ii,1) = 0;
        elseif abs(Relvar_cmr(ii,1)) >= 0.05 && abs(Relvar_cmr(ii,1)) < 0.1
            Relvar_cmr(ii,1) = 0.1;
        else
            Relvar_cmr(ii,1) = round(Relvar_cmr(ii,1)*10)/10;
        end
    end

    if abs(Corrs_cmr(ii,1)) < 0.05
        Corrs_cmr(ii,1) = 0;
    elseif abs(Corrs_cmr(ii,1)) >= 0.05 && abs(Corrs_cmr(ii,1)) < 0.1
        if sign(Corrs_cmr(ii,1)) < 0
            Corrs_cmr(ii,1) = -0.1;
        else
            Corrs_cmr(ii,1) = 0.1;
        end
    end

    rowii = [num2str(Relvar_cmr(ii,1),2) '|' num2str(Corrs_cmr(ii,1),1)];

    for jj=2:ncol-2
        if abs(Relvar_cmr(ii,jj)) <1
            if abs(Relvar_cmr(ii,jj)) < 0.05
                Relvar_cmr(ii,jj) = 0;
            elseif abs(Relvar_cmr(ii,jj)) >= 0.05 && abs(Relvar_cmr(ii,jj)) < 0.1
                Relvar_cmr(ii,jj) = 0.1;
            else
                Relvar_cmr(ii,jj) = round(Relvar_cmr(ii,jj)*10)/10;
            end
        end

        if abs(Corrs_cmr(ii,jj)) < 0.05
            Corrs_cmr(ii,jj) = 0;
        elseif abs(Corrs_cmr(ii,jj)) >= 0.05 && abs(Corrs_cmr(ii,jj)) < 0.1
            if sign(Corrs_cmr(ii,jj)) < 0
                Corrs_cmr(ii,jj) = -0.1;
            else
                Corrs_cmr(ii,jj) = 0.1;
            end
        end

        rowii = [rowii ' & ' num2str(Relvar_cmr(ii,jj),2) '|' num2str(Corrs_cmr(ii,jj),1)];
    end

    rowii = ['multicolumn{1}{|l||}{' namevariable(tauvar_cmr(ii),1:11) '} & ' rowii '& ' num2str(sum(Relvar_cmr(ii,:)),2)];

    if indx_row(1,1) ==1
        if all(isnan(Relvar_fish(ii,:))) == 0  %we need to know whether variable ii is present also in other models in order to draw or not the horizontal line below
           indx_row(1,2) = 1;
        end
    end
    if indx_row(2,1) ==1
        if all(isnan(Relvar_bgg(ii,:))) == 0           
          indx_row(2,2) = 1;
        end
    end 
    if indx_row(3,1) ==1
        if all(isnan(Relvar_b(ii,:))) == 0
          indx_row(3,2) = 1;
        end
    end 
    if indx_row(4,1) ==1
        if all(isnan(Relvar_sw(ii,:))) == 0
          indx_row(4,2) = 1;
        end
    end 
    
    if sum(indx_row(:,2))>=1
        line_string = ' ';
    else
        line_string = ' \\\\hline';
    end
    
    fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);

    if isempty(Relvar_fish)==0
        if all(isnan(Relvar_fish(ii,:)))==0
            if isnan(Relvar_fish(ii,1))==1
                rowii = '[(--)]';
            else
                rowii = ['[(' num2str(Relvar_fish(ii,1),2) '|' num2str(Corrs_fish(ii,1),1) ')]'];
            end
            for jj=2:ncol-2
                if isnan(Relvar_fish(ii,jj))==1
                    rowii = [rowii ' & ' '[(--)]'];
                else
                    rowii = [rowii ' & [(' num2str(Relvar_fish(ii,jj),2) '|' num2str(Corrs_fish(ii,jj),1) ')]'];
                end
            end
            rowii = [' & ' rowii '& ' num2str(V_total_fish(ii),2)];
            
            if sum(indx_row(2:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);
        end
    end
    if isempty(Relvar_bgg)==0
        if all(isnan(Relvar_bgg(ii,:)))==0
            if isnan(Relvar_bgg(ii,1))==1
                rowii = '(--)';
            else
                rowii = ['(' num2str(Relvar_bgg(ii,1),2) '|' num2str(Corrs_bgg(ii,1),1) ')'];
            end
            for jj=2:ncol-2
                if isnan(Relvar_bgg(ii,jj))==1
                    rowii = [rowii ' & ' '(--)'];
                else
                    rowii = [rowii ' & (' num2str(Relvar_bgg(ii,jj),2) '|' num2str(Corrs_bgg(ii,jj),1) ')'];
                end
            end
            rowii = [' & ' rowii '& ' num2str(V_total_bgg(ii),2)];
            
            if sum(indx_row(3:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);
        end
    end
    if isempty(Relvar_b)==0
        if all(isnan(Relvar_b(ii,:)))==0
            if isnan(Relvar_b(ii,1))==1
                rowii = '((--))';
            else
                rowii = ['((' num2str(Relvar_b(ii,1),2) '|' num2str(Corrs_b(ii,1),1) '))'];
            end
            for jj=2:ncol-2
                if isnan(Relvar_b(ii,jj))==1
                    rowii = [rowii ' & ' '((--))'];
                else
                    rowii = [rowii ' & ((' num2str(Relvar_b(ii,jj),2) '|' num2str(Corrs_b(ii,jj),1) '))'];
                end
            end
            rowii = [' & ' rowii '& ' num2str(V_total_b(ii),2)];
            
            if sum(indx_row(4:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);
        end
    end
    if isempty(Relvar_sw)==0
        if all(isnan(Relvar_sw(ii,:)))==0
            if isnan(Relvar_sw(ii,1))==1
                rowii = '[--]';
            else
                rowii = ['[' num2str(Relvar_sw(ii,1),2) '|' num2str(Corrs_sw(ii,1),1) ']'];
            end
            for jj=2:ncol-2
                if isnan(Relvar_sw(ii,jj))==1
                    rowii = [rowii ' & ' '[--]'];
                else
                    rowii = [rowii ' & [' num2str(Relvar_sw(ii,jj),2) '|' num2str(Corrs_sw(ii,jj),1) ']'];
                end
            end
            rowii = [' & ' rowii '& ' num2str(V_total_sw(ii),2)];
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\  \\\\hline \\n''); \n']);
        end
    end
    
    indx_row(:,2) = 0;
end

fprintf(fid,'fprintf(fid,'' \\\\end{tabular}%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\end{equation*}%%%% \\n''); \n');

fprintf(fid,['fprintf(fid,'' {\\\\small Legend: }{\\\\small ' legend_str '}\\n''); \n']);

fprintf(fid,['fprintf(fid,'' {\\\\small Note: }{\\\\small The first element of each column refers to the in-sample relative variance computed as var(y(i))/var(y), where var(y(i)) is the variance of variable y under the counterfactual simulation that all estimated shocks, with the exception of shock i, are set to zero, and var(y) is the variance of the two-sided fitted variable y. The second element of each column refers to the correlation, corr(y,y(i)). The last column displays the sum of the relative variances.}\\n''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\end{document} \\n''); \n');
fprintf(fid,'fclose(fid);');

fclose(fid);

addpath([cdir outfolder(2:end)])
write_temp_big_sample
rmpath([cdir outfolder(2:end)])
