%load estimated parameters
if country == 1
    if entr == -2
        load results_cee_ea xx
    elseif entr == 1
        load results_cmr_ea xx
    elseif entr == -3
        load results_bgg_ea xx
    elseif entr ==2
        load results_cmr_Fisher_ea xx
    end
elseif country == 2
    if entr == -3
        load results_bgg_us xx
    elseif entr == 1
        load results_cmr_us xx
    elseif entr==-2
        load results_cee_us xx
    end
end
xx=imap(xx);

disp('INITIAL PARAMETER VALUES')
printshocks(xx,par,parstoch,taushock,cdir,tauvar,tauvar2,nXXX,taushock2,taushock1,taushock3,fdiff,II,name,[]);

if ric == 0
    disp('(prep) iterating 100 times on Riccati equation')       
else
    disp('(prep) Solving Riccati equation')
end

check_taus %it checks numerically the taus (i.e. the mapping of the observables variables into the model states

profile on
disp('(maxlike) time needed for one likelihood evaluation')
tic
floglik   =   ssloglik(xx,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
    currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
    taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
toc
profile off
disp(['floglik = ',num2str(floglik,16)])

if opt_routine >0

    maximize

    hess_direction=0; %=1, compute a direction using a hessian (it's in loadtaylor) that has a negative eigenvalue (see technical appendix for more discussion).
    if hess_direction ==1
        xxnew=xx;
        loadtaylor
        d1=-.0000000000001*sign(ss);
        xxp=xx'+dir*d1;
        floglikp   =   ssloglik(xxp,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk, ...
            Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
            taushock1,gamma,alpha,R,params,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman)
    end

elseif opt_routine == 0
    xxnew=xx;
end

%------------------------------------------------------
%   Now, do post-processing on the results
%------------------------------------------------------
xx=xxnew;

if irun==7
    xx  = map(xx);
    undo

    for kj=1:length(taushock)
        if max(taushock(kj)==shock_trans)==1
            error('(maxlike) you want to convert the model in dynare .mod but some of the shocks included in the estimation have been constrined to lie in unit interval. The conversion in dynare would give rise to troubles')
        end
    end
    main_mat2dyn
    return
end

[alphas,alpha_2,alpha_1,alpha_0,betas,D,rho,V_eps,Vmeas,l_psi,l_x,l_eps, ...
    tau,x,gamma,alpha,tauc,taud,beta,b,upsil,ksi,psil,psik,muzstar,Taylor,params,Re,c,y,i,w,l, ...
    rk,k,n,pi,g,Pe,G,Gp,omegabar,Rk,Gs,sigma,her,Rb,mb,m,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M] = ...
    unld(xx,par,taushock,tauvar,tauvar2,parstoch,XXX,taushock1,taushock3,size_a,size_b,params, ...
    Re,c,y,i,w,l,k,n,pi,g,Pe,G,Gp,omegabar,Rk,rk,Gs,her,Rb,mb,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M);

disp('PARAMETER VALUES AFTER ESTIMATION')
printshocks(xx,par,parstoch,taushock,cdir,tauvar,tauvar2,nXXX,taushock2,taushock1,taushock3,fdiff,II,name,[]);

floglik   =   ssloglik(xx,par,taumat,her,Rb,Re,c,y, i,mb,w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff, ...
    Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
    taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
disp('value of the likelihood'); disp(floglik)


[XXXsmooth,xismooth,laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1,dinvest,dout,infl, ...
        dwage,dcons,Spread1,money1,money3,output,invest,cons, ...
        wage,price,laborwedgek2,laborwedgek2a,effwedgek2,netk2,dmoney3k2,dmoney1k2,dinvestk2,doutk2, ...
        inflk2,dwagek2,dconsk2,Spread1k2, ...
        money1k2,money3k2,outputk2,investk2,consk2,wagek2,pricek2,hours,hoursk2,capacity,capacityk2,btott,btottk2,dbtott,dbtottk2, ...
        Ra_series,Ra_seriesk2,Re_series,Re_seriesk2,Pe_series,Pe_seriesk2,l_z,govc,dgovc,idef,didef,govck2,dgovck2, ...
        idefk2,didefk2,oilp,doilp,oilpk2,doilpk2,Spread2,Spread2k2,dnet,dnetk2,Fmle,xinosmooth,reserves,reservesk2, ...
        dreserves,dreservesk2,m1,Ra,dm,m3,muzstar,Pe,Rb,Re,alpha,pi] ...
    = getgraphdat(XXX,trendm3,trendm1,accuracy,zz,xx,par,taumat,her,Rb,Re,c,y,i,mb,w,l,k,n,pi,g, ...
    ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,taushock1,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,user);

[tt,compfilt] = plotstuff(XXXsmooth,xismooth,laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1, ...   
    dinvest,dout,infl,dwage,dcons,Spread1,money1,money3,output,invest,cons, ...
    wage,price,laborwedgek2,laborwedgek2a,effwedgek2,netk2,dmoney3k2,dmoney1k2,dinvestk2,doutk2, ...
    inflk2,dwagek2,dconsk2,Spread1k2,money1k2,money3k2,outputk2,investk2,consk2,wagek2,pricek2,hours,hoursk2,capacity,capacityk2, ...
    btott,btottk2,dbtott,dbtottk2,Ra_series,Ra_seriesk2,Re_series,Re_seriesk2,Pe_series,Pe_seriesk2, ...
    date,tauvar,XXX,m1,currdep,Ra,dm,m3,l_z,muzstar,Pe,Rb,Re,alpha,govc,dgovc,idef,didef,govck2,dgovck2, ...
    idefk2,didefk2,pi,oilp,doilp,oilpk2,doilpk2,Spread2,Spread2k2,dnet,dnetk2,reserves,reservesk2,dreserves,dreservesk2);
        
psismooth = xismooth([2*l_z+1:2*l_z+l_psi],:); 
zz1smooth = xismooth(1:l_z,:);

plotpsikal(psismooth,zz1smooth,xinosmooth,XXXsmooth,Xdat,Fmle,taushock,tauvar,parstoch,entr, ...
    date,start_estimation,end_estimation,init_kalman,shockss,ssvalues,shock_trans,fdiff,J,l_z,l_psi,l_x,outfolder,cdir);

Compute_Hessian = 0;
if Compute_Hessian == 1
    
    [QQ]=deriv('ssloglik',xx,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff, ...
        Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior,taushock1, ...
        gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
    
    findhess = 2;
    if findhess==1  %finite difference (one sided)
        Hess = fdhess('ssloglik',xx',par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff, ...
            Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior,taushock1, ...
            gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
    elseif findhess ==2   %two-sided
        Hess = hessian_2s('ssloglik',xx',[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp, ...
            omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2, ...
            size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
    elseif findhess ==3  %uses Abramowitz and Stegun (1965) formulas 25.3.24 and 25.3.27 p. 884
        Hess = hessian('ssloglik',xx',par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar, ...
            Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b, ...
            prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
        Hess = reshape(Hess,length(xx),length(xx));
    elseif findhess ==4   %uses Abramowitz and Stegun (1965) formulas 25.3.24 and 25.3.27 p. 884
        Hess = hessian_sparse('ssloglik',xx',par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp, ...
            omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2, ...
            size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
        Hess = reshape(Hess,length(xx),length(xx));
    elseif findhess ==5   %uses Richardson`s extrapolation method
        Hess = hessext('ssloglik',xx',[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar, ...
            Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
            taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman); 
        Hess = reshape(Hess,length(xx),length(xx));
    end
    Hess   = generalized_cholesky(Hess);

    covmat = inv(Hess);
    
    floglik   =   ssloglik(xx,par,taumat,her,Rb,Re,c,y, i,mb,w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff, ...
    Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
    taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

    marg_Laplace = marg_laplace(xx,covmat,floglik);

    sexx   = sqrt(diag(covmat)); %standard error of the estimated parameters
    
    printshocks(xx,par,parstoch,taushock,cdir,tauvar,tauvar2,nXXX,taushock2,taushock1,taushock3,fdiff,II,name,sexx);
    
    % Selecting the parameter pairs with highest correlations based on the inverse Hessian
    ExtremeCorrBound = 0.5;
    CorrHessian = diag(1./sqrt(diag(covmat)))*covmat*diag(1./sqrt(diag(covmat)));
    CorrHessian = tril(CorrHessian,-1);
    [RowIndex,ColIndex] = find(abs(CorrHessian)>ExtremeCorrBound);
    ExtremeCorrParams = cell(length(RowIndex),3);
         for i=1:length(RowIndex)
           ExtremeCorrParams{i,1}=xxname3(RowIndex(i),:);
           ExtremeCorrParams{i,2}=xxname3(ColIndex(i),:);
           ExtremeCorrParams{i,3}=CorrHessian(RowIndex(i),ColIndex(i));
         end
     Index=[ExtremeCorrParams{:,3}];
     [IInde,Index] = sort(abs(Index),2,'descend');
     disp('Highest Correlation among Estimated Parameters')
     ExtremeCorrParams(Index,:)
end

ccheck=0;%if 1, graph the likelihood in the neighborhood of the point estimates this can take some time!
if ccheck == 1
    %if you don't have computed the Hessian yet, leave the input 'Hess' empty
    checkmin(xx,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
        taushock,Pe,G,Gp,omegabar,Rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
        currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
        taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman,xxname3,Hess);
end

save([outfolder '\maxlikeout']);
