function [std_data,std_dare]=modelvariance(Xdat_s,F,H,RR,Q,ric,is,l_z,l_psi,fdiff,tauvar,entr)

%if ric == 1
[initV_dare,L,G,RRR]  =   dare(F',zeros(size(F)),Q);
ee = initV_dare - F*initV_dare*F' - Q;
if max(max(abs(ee))) > .1e-8
    error('fatal (modelvariance) failed to solve Riccati Equation')
end

%else
if is == 1
    initV1  =   .01*eye(2*(l_z+l_psi));
else
    initV1  =   .01*eye(2*l_z+l_psi);
end
for ii = 1:100
    initVn = F*initV1*F'+ Q;
    initV1 = initVn;
end
ee=max(max(abs(initV1-F*initV1*F'-Q)));
if max(max(abs(ee))) > .1e-8
    warning('(modelvariance) approximation error very high')
end
initV_appr = initV1;
%end

Var_implied_dare = diag(H*initV_dare*H' + RR);
Var_implied_appr = diag(H*initV_appr*H' + RR);

std_data = 100*std(Xdat_s,0,2);

std_dare = 100*sqrt(Var_implied_dare);
std_appr = 100*sqrt(Var_implied_appr);

[nameshocks,nameXXX] = getnames(fdiff);
nameXX = nameXXX(tauvar,:);

disp(['Standard Deviation of Data and Implied by Estimated Model (in percent). Model entr =' num2str(entr)]);
str_ = char('data','using dare','approximation using 100 iterations');
tableMAT(nameXX(:,1:11),str_,[std_data std_dare std_appr]);


