function [loglik] = mykalman(data,T,Z,Q,H,xini,P,alf)

%Compute kalman filter
%Written by Gianni Lombardo. Modified by Roberto Motto

bigt = size(data,2);
n    = size(data,1);

% initialize likelihood with the Gaussian constant
loglik = (n*bigt*0.5)*log(2*pi);% negative of constant part of likelihood times #series*lenght

scfc=1;

for i=1:bigt
    
    Ft = Z*P*Z'+ H; % observables' forecast error
    
    if rcond(Ft) > 1e-15
    %if det(Ft) > 1e-35
        invFt = inv(Ft);
        if any(diag(invFt)<0)
            error('invFt is not psd')
        end
    else
        loglik = -10e12;
        return
    end
    
    ut = data(:,i)-(Z*xini) - alf;
    
    loglik = loglik + (0.5)*(log(abs(det(Ft))) + ut'*invFt*ut);  %likelihood function
    
    % start the filter
    Kt   = T*P*Z'*invFt; %Kalman gain (see Hamilton p. 381)
    xini = T*xini + Kt*ut; %xi(t+1|t)=T*xi(t|t)
    %L    = T - Kt*Z;
    %P    = T*P*L'+ Q; %update of MSE of projection of state variables
    P = T*P*T' - Kt*Z*P*T' + Q;  %MSE of xi(t+1|t)
% [Rowi] = find((diag(P))<eps);
% for ij=1:length(Rowi)
% if P(Rowi(ij),Rowi(ij)) >-0.000000000001
% P(Rowi(ij),Rowi(ij)) = eps;
% end
% end
    %if  i > 87
    %    Proby = P - P*Z'*invFt*Z*P; %MSE of the updated inference on the current value of the state, i.e. MSE of xi(t|t). (i.e. after having observed current y). see Hamilton p 478 (italian edition)
    %end
end
loglik = -loglik;