function [rk,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,R,Fp,Kp,Fw,Kw,ucz,q,Gamma,Gam_muG,g,y] = nobanks_ss1(lambdaf, ...
    infl,muz,beta,delta,Fomegabar,mu,alpha,gam,sigmaL,psiL,lambdaw,we,bigtheta,b,phi, ...
    muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,etag,zeta,zetac,taul,psik,psil,tauc,taud)

sw=0;
if phi == 0;%in this case we are solving for phi assuming infl=pibar. So we use sw=1 as a flag to skip some redundant computations
    sw=1;
    lambdafs=1; %in order to solve for phi we need to eliminate the subsidies (given the way phi is solved for, we would get otherwise that phi=0)
    lambdaws=1;
end

R   = (infl*muz/beta-1)/(1-taud);

rrk = 0.054; %EA=0.04; US=0.054; %we try with an initial value; if it does not find a solution it will bracket the solution
try
    opt=optimset('diagnostics','on','LevenbergMarquardt','on','TolX',1e-16,'TolFun',1e-16);                                       %
    [rkopt,fval,exitflag] =   fzero(@nobanks_ss2,rrk,opt,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
        bigtheta,we,beta,psiL,sigmaL,lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw, ...
        epsil,sw,lambdafs,lambdaws,etag,tauc,taul);
    if abs(fval ) > .1e-9 || abs(imag(rkopt))>.1e-10 || exitflag <= 0
        error('fatal (steadystate) failed to find steady state')
    end

catch
    lasterr
    
    rkk = ((upsil/infl*(R+1-tauk*delta)-1+delta)/(1-tauk))  + .000001:.001:0.08;
    rk = rkk(1);
    [ffold] = nobanks_ss2(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
        lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdafs,lambdaws,etag, ...
        tauc,taul);
    ix=0;
    fx(1)=ffold;
    for ii = 2:length(rkk)
        rk=rkk(ii);
        [ff] = nobanks_ss2(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
            lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdafs,lambdaws, ...
            etag,tauc,taul);

        if ff > 0 & ffold < 0

            ix=ix+1;
            I(ix)=ii;

        end
        ffold=ff;
        fx(ii)=ff;
    end

    if ix > 1
        error('fatal (steadystate) found more than one steady state')
    end
    if ix == 0
        error('fatal (steadystate) failed to bracket a steady state')
    end
    rk1 = rkk(I(ix)-1);
    rk2 = rkk(I(ix));
    rrk = [rk1,rk2];

    [rkopt,fval,exitflag] =   fzero(@nobanks_ss2,rrk,opt,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
        bigtheta,we,beta,psiL,sigmaL,lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw, ...
        epsil,sw,lambdafs,lambdaws,etag,tauc,taul);
    if abs(fval ) > .1e-9 || abs(imag(rkopt))>.1e-10 || exitflag <= 0
        error('fatal (steadystate) failed to find steady state')
    end
end


rk=rkopt;

[ff,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw,pitildw,wstar, ...
    wplus,Rk,q,Gamma,Gam_muG] = nobanks_ss2(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
    bigtheta,we,beta,psiL,sigmaL,lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1, ...
    iotaw2,xiw,epsil,sw,lambdafs,lambdaws,etag,tauc,taul);


[Fp,Kp,Fw,Kw] = nobanks_ss4(lambdaz,yz,pitild,infl,lambdaf,beta,xip,mc,zetac, ...
    wstar,lambdaw,h,taul,muz,sigmaL,xiw,pitildw,piw,zeta,lambdafs,lambdaws);

x=infl*muz-1;
ucz=(muz-b*beta)*zetac/(c*(muz-b));
g = etag*(c+I)/(1-etag);
y = c + I + g;

%do a check, to verify the steady state equations are satisfied.
[err] = check_nobanks(mc,rk,w,R,h,k,wstar,Rk,q,infl, ...
    piw,ucz,I,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muz,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,Gamma,omegabar, ...
    Fomegabar,mu,gam,we,n,bigtheta,Gam_muG,psiL,sw,lambdafs,lambdaws,taud);

if max(abs(err)) > .1e-9
    error('fatal (steadystate) failed to find a steady state for cee&bgg model')
end