%Warning: Not ALL parameters are set in this file.
%*taumat...the vector that indicates what shocks are not observed in partial equations, is set in makealphabeta
%*run sets the shocks to be included in the current analysis.
%*checkB contains taup, a list of variables not observed in partial information equations 
%*checkB also contains part, a list of the partial information equations

%Household
lambdaw     =   1.05;                 % CEE page 22. Euro area: same
l           =   0.09043076545480;                    
sigmaL      =   1;                    % CEE page 21. Euro area: same
zeta        =   1.000;                % ??. Euro area: same
theta       =   0.785; %0.7960172; %0.81; %Euro area:0.745 
v           =   0.0015; %Euro area: 0.002;   
beta        =   1.00623^(-0.25);  %Euro area: 1.0133^(-0.25)
xiw         =   0.7;                  % CEE page 42
Hdoupr      =   2; 
sigmaq      =   -7; %Euro area: same 
b           =   .63;   %CEE page 42. Euro area: 0.56
psiL        =   61.82056721029309; %Euro area: same
m           =   0.757; %The ratio for the US is 0.755; %Euro area: 0.69;
chii        =   0.53; %0.5143123; %0.4851; % Euro area: 0.4851; It governs the sostituibility between Dm and more liquid asset in the utility function
duration    =   4; %duration of the long bond (number of quarters)
zetac       =   1; %consumption preference shock
iotaw1      =   0.318;%degree of indexation to inflation target
iotaw2      =   1-iotaw1;;%degree of indexation to past inflation
iotamu      =   1;%degree of indexation of wage to stochastic productivity growth


%Entrepreneur
Fomegabar   =   0.013; %0.01441993; %0.025;  %0.008; % BGG page 33 (.03). Euro area: same
sigma       =   0.33123064253832;  %variance of shock omega. Euro area: same
mu          =   0.26;%0.2609152; %0.14;     %0.12;   % BGG page 33 (.12), monitoring cost. Euro area: 0.0938 
gamma       =   1-0.0238; %1-0.025;%0.9215234; %1-0.027; %1-0.0272;     % BGG page 33 1-0.0272; 1 - "death rate". Euro area: same
we          =   0.009;  %0.001;                 % ??. Euro area: same                
bigtheta    =   0.1;%0.12;%0.0918328; %0.09; %0.09; % ?? Euro area: same
tauo        =   1; %0.05;

%Capital Producer
sigmaa      =   0.2;     % Euro area: 0.2
Sdoupr      =   6.1;      % elasticity in dynamic specification of adjustment costs %ACEL page 49  7.69
etai        =   2;      %elasticity in static speification of adjustment costs
muup        =   1;  %investment specific shock
zetai       =   1;  %shock to the marginal efficiency of investment

%Goods Producers
muzstar     =   1.0136^(.25);          % Euro area:1.015^(.25);
upsil       =   1.0132^(.25);   %trend in relative price of consumption. Euro area:1.002^(.25);
rk = 0.058572; %0.06; %0.0729; %rk=0.04195; great depression paper %rk=0.041225; euro area paper with m=0.7; %rk=0.04625; with delta=0.025 %rk=0.04124; with delta =0.02
lambdaf     =   1.2;                  % Euro area: same 
alpha       =   0.3987246; %0.36;% From ACEL. Euro area: same.
psik        =   0.45;%Euro area: 1; % ??, fraction of k services financed in advance. 
psil        =   0.45;%Euro area: 1;??, fraction of l services financed in advance. 
delta       =   0.025; %0.02540868; %0.025;              % Euro area: 0.02
eps_shock   =   1;
xip         =   0.767;              % Euro area: 0.767
iota1       =   0.724;
iota2       =   1-iota1;


%Banks
ksi         =   0.94145141467876;
xb          =   1.153432323688070e+002;
chorse      =  0.088; %0.083; %0.07247163; % 0.15; %0.1
rhobank     =   0; %-40;
R           =   0.0073; %0.00715530831117;
vl          =   (1-0.0095);% For the US the fraction of non-FIRE work hours over total hours is (1-0.059). Euro area:.99271; 
vk          =   (1-0.0095);%(1-0.059);%0.99271; 

%Taxes and government consumption
etag        =   0.2043;            % ??
tauk        =   0.32;%.366;                 
taul        =   .241;           
tauc        =   0.047;        
tauD        =   .0; %it has been removed in euro area model
tauT = tauD;                   % ??   

%Monetary Policy
tau         =   0.01; %0.09;  %reserve requirement. For the US the official rate (not effective) is 0.09. Euro area: 0.02
x           =   0.01357; %0.0131; %in the US base money growth over 1959-2003 is 0.0131 quarterly (5.4 annually)
xp          =   0;

Taylor      =   2;%2; % =0, money growth rule; 
                   % =-1, fully exogenous money base rule (i.e. it does not respond to shocks); 
                   % if =1, taylor rule on Rb
                   % if =2 taylor rule on Re
                   % if = 3 monetary base rule feeding back on output growth, 
                   % if = 4, base rule on deviation of output from trend
forward     =  1;   % if =1, the inflation term in the Taylor rule is 1 period forecast; if =0, it is contemporaneous; if =-1, it is 1 period lag;
aptil       =  1.5;   %0.5 coefficent on inflation in Taylor rule
aytil       =  0.5;   %0.5 coefficient on output in Taylor rule
amtil       =  0.001; %0.1 %coefficient on nominal M3 growth in Taylor rule
actil       =  0.01;  %0.02; %coefficient on real credit growth in Taylor rule
rhotil      =  0.9;   %interest rate smoothing parameter in Taylor rule

%Alternative specifications of the model
entr       = 1;      %1 benchmark model (w/ entrepreneur and banks), 0: benchmark without entrepreneurs, -1: benchmark with no entrepreneurs or banks

pref       = 1;      %1: benchmark preferences, 0: ACEL preferences

costreal =0; %=0, adjustment cost in changing money holding is in terms of nominal money growth; =1, the cost is in terms of real money growth

util =1; % =1 variable capital utilisation; =0 remove variable capital utilisation;

static=0; % =0 dynamic adjustment cost in investment; =1 static adjustment cost in investment

timing=1; %if 1 set the timing to specification (22) in the manuscript; if 0 set the timing to specification (22)'.
if timing ==0
    error('fatal (makealphabeta) timing=0.Look at the manuscript')
end

if iota1+iota2 > 1
    error('fatal (parameterseuro) indeces on price setting too big')
end
if iotaw1+iotaw2 > 1
    error('fatal (parameterseuro) indeces on wage setting too big')
end
%Information restrictions
money       = 3;  %3, you see everything
                  %2, you see everything but the policy shock
                  %0, you only see technology shocks
                  %1, except for monetary policy shock, you don't see financial market shocks...money you do see. (works for entr=1)

%Set parameters that pertain to the time series representation of the exogenous stochastic processes
parametersstoch 

%load parameters and some desired alternatives into params
params=zeros(51,1);
params   =   [Fomegabar,mu,x,muzstar,lambdaf,lambdaw,alpha,psik,psil,delta,tauk,taul,tauc, ...
        gamma,l,tauT,tauD,sigmaL,zeta,etag,theta,v,...
        beta,xiw,xip,sigmaa,sigmaq,b,we,R,m,vl,vk,Sdoupr,tau,psiL,ksi,xb,eps_shock,xp];
params(46)=pref;
params(47)=entr;

params(49)=timing;
params(50)=Hdoupr;
params(51)=rhobank;
params(52)=rhotil;
params(53)=aptil;
params(54)=aytil;
params(55)=amtil;
params(56)=upsil;
params(57)=chii;
params(58)=chorse;
params(59)=bigtheta;
params(60)=muup;
params(61)=actil;
params(70)=iota1;
params(71)=iota2;
params(72)=iotaw1;
params(73)=iotaw2;
params(74)=iotamu;
params(75)=0; %note: params(75) is reset in makealphabeta with tt2 (i.e. it specifies which variables are present in z(t) in the alternative versions of the model)
params(76)=zetai; 