function pltposterior(ii,P,A,ss,pp,xx)

dist    = P(ii,end);
mbetaEA = P(ii,1);
sbetaEA = P(ii,2);
mbetaUS = P(ii,3);
sbetaUS = P(ii,4);
mEA     = A(ii,1);
sEA     = A(ii,2);
mUS     = A(ii,5);
sUS     = A(ii,6);
SS      = deblank(ss(ii,:));
PP      = deblank(pp(ii,:));

if dist == 1
    %EA priors
    [a1,b1] = betain(mbetaEA,sbetaEA^2);
    %US priors
    [a2,b2] = betain(mbetaUS,sbetaUS^2);
elseif dist == 4
    %inverse gamma prior...copied from draw_prior_density.m, lines 49-58 and set_prior.m lines 127-128.
    truncprior = 10^(-3);
    pmean      = P(ii,1);
    pstdev     = P(ii,2);
    [p1,p2]    = inverse_gamma_specification(pmean,pstdev,1);
    density    = inline('2*inv(gamma(nu/2))*(x.^(-nu-1))*((s/2)^(nu/2)).*exp(-s./(2*x.^2))','x','s','nu');
    nu = p2;
    s  = p1;
    a  = nu/2;
    b  = 2/s;
    infbound = 1/sqrt(mj_qgamma(1-10*truncprior,a)*b); 
    supbound = 1/sqrt(mj_qgamma(10*truncprior,a)*b);
    stepsize = (supbound-infbound)/200;
    abscissa = infbound:stepsize:supbound;
    dens     = density(abscissa,s,nu);
end
%EA posterior
aa1 = mEA;
bb1 = sEA;
%US posterior
aa2 = mUS;
bb2 = sUS;
xlo1 = norminv(.05,aa1,bb1);
xup1 = norminv(.95,aa1,bb1);
xlo2 = norminv(.05,aa2,bb2);
xup2 = norminv(.95,aa2,bb2);
fprintf(SS)
fprintf(' (EA) lower bound - %4.2f, upper bound - %4.2f, post mean (std dev) = %4.2f (%4.2f)\n',xlo1,xup1,aa1,bb1) 
fprintf(' (US) lower bound - %4.2f, upper bound - %4.2f, post mean (std dev) = %4.2f (%4.2f)\n',xlo2,xup2,aa2,bb2) 

if dist==1; plot(xx,normpdf(xx,aa1,bb1),'-',xx,betapdf(xx,a1,b1),':','LineWidth',0.3);end
if dist==2; plot(xx,normpdf(xx,aa1,bb1),'-',xx,normpdf(xx,mbetaEA,sbetaEA),':','LineWidth',0.3);end
if dist==3; plot(xx,normpdf(xx,aa1,bb1),'-',xx,exp(lgammapdf(xx,mbetaEA,sbetaEA)),':','LineWidth',0.3);end
if dist==4; plot(xx,normpdf(xx,aa1,bb1),'-',abscissa,dens,':','LineWidth',0.3);end
hold on
if mbetaUS > 0.000000001
    if dist==1; plot(xx,normpdf(xx,aa2,bb2),'-',xx,betapdf(xx,a2,b2),':','LineWidth',3);end
    if dist==2; plot(xx,normpdf(xx,aa2,bb2),'-',xx,normpdf(xx,mbetaUS,sbetaUS),':','LineWidth',3);end
    if dist==3; plot(xx,normpdf(xx,aa2,bb2),'-',xx,exp(lgammapdf(xx,mbetaEA,sbetaEA)),':','LineWidth',3);end
    if dist==4
        error('fatal (pltposterior) not able to handle this case')
    end
else
    plot(xx,normpdf(xx,aa2,bb2),'-','LineWidth',3)
end
title(PP)
axis tight

