%This program plots the prior and posterior densities of the estimated parameters

[A] = getstddev;

Aparam = A(1:13,:);
Arho   = A(14:27,:);
Asig   = A(28:end,:);

%priors and distribution for structural parameters
%first two columns are mean and standard deviation of prior for EA, third and fourth columns are for US, 
%last column is the distribution. If prior for US is identical to EA, set colums 3:4 =0
%1 - beta
%2 - normal
%3 - gamma
%4 - inverse gamma
P=[.75    .05   .375  .05  1
   .75    .1    .375  .1   1
    2      2     0     0   2
   .5     .15    0     0   1
   .5     .15    0     0   1
   .5     .15    0     0   1
    10     5     0     0   2 
    6      5     0     0   2
    1.75  .1     0     0   2
   .25    .1     0     0   2
   .05   .025   0     0   2
   .3     .1     0     0   2
   .8     .05    0     0   1];

    
ss=['\n Calvo sticky prices\n                      '
    '\n Calvo sticky wages\n                       '
    '\n Curvature on currency demand\n             '
    '\n Weight in price equation, iota \n          '
    '\n Weight in wage equation, iota _{w} \n      '
    '\n Wage equation, vartheta \n                 '
    '\n Investment adjustment cost, S''''  \n        '
    '\n Utilization rate, sigma _{a}  \n           '
    '\n Monetary policy, alpha _{pi }  \n          '
    '\n Monetary policy, alpha _{dy}  \n           '
    '\n Monetary policy, alpha _{delta c }   \n    '
    '\n Monetary policy, alpha _{dpi }  \n         '
    '\n Monetary policy, rho _{i}  \n              '];

pp=['Calvo prices, \xi _{p}                                  '
    'Calvo wages, \xi _{w}                                   '
    'Curvature on currency demand (H'''')                      '
    'Inflation indexation: price setting, 1-\iota            '
    'Weight in wage equation, \iota _{w}                     '
    'Technology growth indexation: wage setting, \vartheta   '
    'Investment adjustment cost, S''''                         '
    'Utilization rate, \sigma _{a}                           '
    'Monetary policy, \alpha _{\pi }                         '
    'Monetary policy, \alpha _{\Delta y}                     '
    'Monetary policy, \alpha _{\Delta c }                    '
    'Monetary policy, \alpha _{\Delta \pi }                  '
    'Monetary policy, \rho _{i}                              '];

figure('name','priors vs posteriors, model parameters'), orient landscape
ia=3;
ib=5;
jj=1;

ii=1;
xx=.15:.01:.9;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;
legend('posterior','prior')

ii=2;
xx=.15:.01:.9;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;

ii = 4;
xx=-.05:.001:0.99;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;

ii = 5;
xx=-.05:.001:0.9;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;

ii=6;
xx=.1:.001:1.1;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;

ii=3;
gg=0:0.001:0.4;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,gg);
jj = jj+1;

ii=7;
xx=.001:.01:50;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,xx);
jj = jj+1;

ii=8;
yy=0:1:50;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

ii=9;
yy=1.4:.001:2.12;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

ii=10;
yy=0:.001:.6;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

ii=11;
yy=.0:.001:.15;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

ii=12;
yy=.0:.01:.6;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

ii=13;
yy=.7:.005:.95;
subplot(ia,ib,jj)
pltposterior(ii,P,A,ss,pp,yy);
jj = jj+1;

hout=suptitle(['Figure 1: Priors and Posteriors (US - thick line, EA - thin line) Model Paramters']);

%now plot the autoregressive parameters
%priors:
P=[ .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .2    0   0   1
    .5  .1   .5  .025 1
    .5  .2   .5  .05  1
    .5  .2    0   0   1
    .5  .05   0   0   1
    .5  .2    0   0   1
    .5  .2   .5  .05   1];

pp=['Banking technol. shock  x_{t}^{b}              '
    'Bank reserve demand shock  \xi _{t}            '
    'Term premium shock  \sigma _{t}^{\aleph }      '
    'Investm. specific shock  \mu _{\Upsilon ,t}    '
    'Money demand shock  \chi _{t}                  '
    'Government consumption shock  g_{t}            '
    'Persistent product. shock  \mu _{t}^{\ast }    '
    'Transitory product. shock  \epsilon _{t}       '
    'Financial wealth shock   \gamma _{t}           '
    'Riskiness shock \sigma _{t}                    '
    'Consump. prefer. shock  \zeta _{c,t}           '
    'Margin. effic. of invest. shock  \zeta _{i,t}  '
    'Oil price shock  \tau _{t}^{oil}               '
    'Price mark-up shock  \lambda _{f,t}            '];

figure('name','priors vs posteriors, auto coef'), orient landscape
jj =1;

ii =1;
yy=.85:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

legend('posterior','prior')

ii =2;
yy=.001:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =3;
yy=.75:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =4;
yy=.85:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =5;
yy=.85:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =6;
yy=.2:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =7;
yy=.001:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =8;
yy=.2:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =9;
yy=.3:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =10;
yy=.3:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =11;
yy=.2:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =12;
yy=.1:.001:.85;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =13;
yy=.2:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

ii =14;
yy=.2:.001:.999;
subplot(3,5,jj)
pltposterior(ii,P,Arho,pp,pp,yy);
jj=jj+1;

hout=suptitle(['Figure 2: Priors and Posteriors (US - thick line, EA - thin line) Autoregressive coefficients']);

%now plot the innovations std
%priors:
P=[ 0.1	   5   0   0  4
   0.001   5   0   0  4
   0.01	   5   0   0  4
   0.003   5   0   0  4 
   0.001   5   0   0  4
   0.01    5   0   0  4
   0.001   5   0   0  4
   0.001   5   0   0  4
   0.001   5   0   0  4
   0.001/sqrt(8) 5  0  0  4
   0.001   5   0   0  4
   0.001/sqrt(8)   5   0   0  4
   0.001   5   0   0  4
   0.001   5   0   0  4
   0.01    5   0   0  4
   0.25   10   0   0  4
   0.0005  5   0   0  4];

pp=['Banking technol. shock  x_{t}^{b}               '
    'Bank reserve demand   \xi _{t}                  '
    'Term premium shock   \sigma _{t}^{ \aleph }     '
    'Investm. specific shock   \mu _{ \Upsilon,t}    '
    'Money demand shock   \chi _{t}                  '
    'Government consumption shock  g_{t}             '
    'Persistent product. shock   \mu _{t}^{ \ast }   '
    'Transitory product. shock   \epsilon _{t}       '
    'Financial wealth shock   \gamma _{t}            '
    'Signal, Financial wealth  \gamma _{t}           '
    'Riskiness shock   \sigma _{t}                   '
    'Signal, risk shock   \sigma _{t}                '
    'Consump. prefer. shock   \zeta _{c,t}           '
    'Margin. effic. of invest. shock   \zeta _{i,t}  '
    'Oil price shock   \tau _{t}^{oil}               '
    'Monetary policy shock   \epsilon _{t}           '
    'Price markup shock   \lambda _{f,t}             '];

figure('name','priors vs posteriors, std dev'), orient landscape
%yy=.0001:.0001:.6;
for ii = 1:17
    subplot(5,4,ii)
    if ii==1
        yy=.0001:.0001:0.12;
    elseif ii==2
        yy=.0001:.0001:.009;
    elseif ii==3
        yy=.0001:.0001:.02;
    elseif ii==4
        yy=.0001:.0001:.0045;
    elseif ii==5 
        yy=.0001:.0001:.03;
    elseif ii==6
        yy=.0001:.0001:.03;
    elseif ii==7
        yy=.0001:.0001:.009;
    elseif ii==8
        yy=.0001:.0001:.006;
    elseif ii==9
        yy=.0001:.0001:.006;
    elseif ii==10 
        yy=.0001:.0001:.0025;
    elseif ii==11
        yy=.0001:.001:.15;
    elseif ii==12 
        yy=.0001:.001:.08;
    elseif ii==13
        yy=.0001:.0001:.025;
    elseif ii==14
        yy=.0001:.0001:.025;
    elseif ii==15
        yy=.0001:.0001:.19;
    elseif ii==16
        yy=.0001:.001:.65;
    elseif ii==17
        yy=.0001:.0001:0.025;
    else
        yy=.0001:.0001:.012;
    end
    pltposterior(ii,P,Asig,pp,pp,yy);
end
hout=suptitle(['Figure 3: Priors and Posteriors (US - thick line, EA - thin line) Innovation std deviations']);
legend('posterior','prior')
