function []=referencevalue(taushock,ij,tt,pi,beta,muzstar,out_R,yhat,infhat,inv_R,ihat,c_R,chat,l_R,lhat,real_R,...
             M1_nom,M3,M_nom,Dm_unscaled,Rehatp,Re,Rmhatp,Rm)
         
         
if taushock(ij)==18
    String1=['Response to a temporary productivity shock'];
elseif taushock(ij)==16
    String1=['Response to a permanent productivity shock'];
end


figure
xx=3; 
x=2;

subplot(x,xx,1)
plot(tt,infhat(tt)*pi*400,'b-');
axis tight
set (gca,'XTick',[0 20])
title('Inflation (APR)');


subplot(x,xx,2)
plot(tt,yhat(tt)*100,'b-',tt,out_R(tt)*100,'kd-')
axis tight
ylabel('percent');
set (gca,'XTick',[0 20])
title('Output');

subplot(x,xx,3)
plot(tt,ihat(tt)*100,'b-',tt,inv_R(tt)*100,'kd-');
axis tight
ylabel('percent');
set (gca,'XTick',[0 20])
title('Investment');

subplot(x,xx,4)
plot(tt,chat(tt)*100,'b-',tt,c_R(tt)*100,'kd-');
axis tight
ylabel('percent');
set (gca,'XTick',[0 20])
title('Consumption');

subplot(x,xx,5)
plot(tt,lhat(tt)*100,'b-',tt,l_R(tt)*100,'kd-');
axis tight
ylabel('percent');
set (gca,'XTick',[0 20])
title('Hours Worked');


subplot(x,xx,6)
plot(tt,(Rehatp(tt)-infhat(tt(1)+1:tt(end)+1))*(muzstar/beta-1)*400*100,'b-',tt,real_R(tt)*(muzstar/beta-1)*400*100,'kd-')
axis tight
set (gca,'XTick',[0 20])
title('Re real (annual)');
ylabel('basis points')

hout=suptitle(String1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
n1=2;
n2=3;

subplot(n1,n2,1)
plot(tt,M3(tt)*100,'b-')
axis tight
set (gca,'XTick',[0 20])
ylabel('percent')
title('M3 (nominal)');

subplot(n1,n2,2)
plot(tt,M1_nom(tt)*100,'b-')
set(gca,'XTick',[0 20]);
title('M1 (nominal)')
ylabel('percent')
axis tight

subplot(n1,n2,3)
plot(tt,M_nom(tt)*100,'b-')
set(gca,'XTick',[0 20]);
title('Currency (nominal)')
ylabel('percent')
axis tight

subplot(n1,n2,4)
plot(tt,Dm_unscaled(tt)*100,'b-')
set(gca,'XTick',[0 20]);
title('M3-M1 (nominal)')
ylabel('percent')
axis tight

subplot(n1,n2,5)
plot(tt,Rehatp(tt)*Re*400*100,'b-')
axis tight
set(gca,'Xticklabel',[0 20]);
ylabel('basis points')
title('Short Rate (Annual)');

subplot(n1,n2,6)
plot(tt,Rmhatp(tt)*Rm*400*100,'b-')
axis tight
set(gca,'Xticklabel',[0 20]);
ylabel('basis points')
title('Own Rate on M3-M1 (Annual)');

hout=suptitle(String1);
