function [q,pii,Re,RT,rentk,Retk,w,u,k,invest,y,phi,g,c,uzc,mb,lambdaz,psiL] = ssnobank(l,R,parameters)

entr      = parameters(1);
pref      = parameters(2);
lambdaw   = parameters(3);
sigmaL    = parameters(4);
theta     = parameters(5);
v         = parameters(6);
beta      = parameters(7);
xiw       = parameters(8);
Hdoupr    = parameters(9);
sigmaq    = parameters(10);
b         = parameters(11);
psiL      = parameters(12);
m         = parameters(13);
chii      = parameters(14);
duration  = parameters(15);
zetac     = parameters(16);
iotaw1    = parameters(17);
iotaw2    = parameters(18);
iotamu    = parameters(19);
Fomegabar = parameters(20);
sigma     = parameters(21);
mu        = parameters(22);
gamma     = parameters(23);
we        = parameters(24);
bigtheta  = parameters(25);
sigmaa    = parameters(26);
Sdoupr    = parameters(27);
etai      = parameters(28);
muup      = parameters(29);
zeta      = parameters(30);
muzstar   = parameters(31);
upsil     = parameters(32);
lambdaf   = parameters(33);
alpha     = parameters(34);
psik      = parameters(35);
psil      = parameters(36);
delta     = parameters(37);
eps_shock = parameters(38);
xip       = parameters(39);
iota1     = parameters(40);
iota2     = parameters(41);
ksi       = parameters(42);
xb        = parameters(43);
chorse    = parameters(44);
rhobank   = parameters(45);
vl        = parameters(46);
vk        = parameters(47);
etag      = parameters(48);
tauk      = parameters(49);
taul      = parameters(50);
tauc      = parameters(51);
tauD      = parameters(52);
tauT      = parameters(53);
tau       = parameters(54);
x         = parameters(55);


[q,pii,Re,RT,rentk,Retk,w,u,k,invest,y,phi,g,c,uzc] = helpnobank(l,x,muzstar,beta,tauT,tauD,tauk,delta,alpha,psik,psil,vk,etag,b, ...
    lambdaf,entr,upsil,R);

    mb1=.0001;
    mb2=y;
    if pref==0
        mb2=y*50;
    end
    mbb=[mb1:.01:mb2];
    mb=mbb(1);
    ixx=0;
    [mb,lambdaz,ff(1)] = nobanknoentr(mb,pii,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);

    for ii = 2:length(mbb)
        mb=mbb(ii);
        [mb,lambdaz,ff(ii)] = nobanknoentr(mb,pii,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);
        if ff(ii)*ff(ii-1) < 0
            ixx=ixx+1;
            II(ixx)=ii;
        end
    end
    if ixx == 0
        error('fatal (ssnobank) failed to bracket steady state value of mb')
    end
    if ixx > 1
        error('fatal (ssnobank) found multiple steady states')
    end
    mb1=mbb(II(1)-1);
    mb2=mbb(II(1));
%     [ff1] = findnobanknoentr(mb1,pi,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);
%     [ff2] = findnobanknoentr(mb2,pi,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);
%     if ff1*ff2 > 0
%         error('fatal (steadystate) failed to bracket m')
%     end

    %if the solution is successfully bracketed, try and actually find it...
    opts =optimset('TolFun',1e-10,'TolX',1e-10,'Maxit',1000);
    [mb,fval,exitflag]=fzero(@findnobanknoentr,[mb1,mb2],opts,pii,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);
    if abs(fval) > 5.6e-10 | abs(imag(mb)) > .1e-10 | mb<0 | exitflag ~= 1
        error('fatal (ssnobank) failed to solve for steady state')
    end
    [mb,lambdaz,ff] = nobanknoentr(mb,pii,c,uzc,muzstar,beta,v,sigmaq,tauc,entr,pref);

    %equation aa21
    psiL = (w*lambdaz*(1-taul)/lambdaw)/(zeta*(l^sigmaL));
