function [ff1,Ra,R,ev,Rm,dm,mb,lamz,Fomegabar,Gamma,G,Rk,rk,n,k,w,l,i,y,vk,costs,erz] = ssteadyexog(xxin, ...
    x,theta,Re,alpha,ksi,xb,tau,lambdaf,chorse,chii,tauD,muzstar,beta,pii,sigma,mu,tauk, ...
    delta,upsil,we,gamma,psik,psil,lambdaw,zeta,psiL,sigmaL,taul,tauc,sigmaq,b,v,etag,bigtheta,pref)

m = real(exp(xxin(1)));
her = real(exp(xxin(2)));
c = real(exp(xxin(3)));
omegabar = real(1/(1+exp(-xxin(4))));

Ra = fRa(m,x,theta,Re);

if Ra <0
    ff=1.e+12
    return
end

% opt=optimset('display','iter','diagnostics','off','LevenbergMarquardt','on','TolX',1e-15,'TolFun',1e-15);
% [her,fval,exitflag,output] =  fzero(@findher,1.28,opt,Ra,alpha,ksi,xb,tau,lambdaf);
% if abs(fval ) > .1e-9 | abs(imag(her))>.1e-10 | exitflag <= 0
%     error('fatal (steadysolve) failed to find omega')
% end
ff1(1) = 1 - (Ra*alpha*ksi*xb/(her*(1-tau)-1))*(lambdaf/alpha)*(her/(xb*(1-ksi)))^(-(1-ksi)/ksi);

R = Ra*(1+tau*her)/(her*(1-tau)-1);
if R <0
    ff=1.e+12
    return
end

ev = (her/((1-ksi)*xb))^(-1/ksi);

Rm = Re - chorse*R/(her*tau+1);
if Rm <0
    ff=1.e+12
    return
end

if pref ==1
    %equation for dm
    bb = ((1-chii)*theta/m)-((1-chii)*(1-theta)/(1-m));
    dm = chii*(1-tauD)*Ra / ( bb*pii*( (muzstar/beta)- ((1+(1-tauD)*Rm)/pii)) );
end
if dm <0
    ff=1.e+12
    return
end

% oom=[.0000001:.1:.99];
% ij=0;
% omega=oom(1); 
% [ff(1)] = findomegabar(omega,sigma,Re,mu,tauk,delta,upsil,pii,we,gamma,muzstar,lambdaf,alpha,psik,R,psil, ...
%         ksi,chorse,dm,lambdaw,zeta,psiL,sigmaL,taul,tauc,m,chii,theta,sigmaq,b,beta,v,etag,ev,bigtheta,tau,her);
% for ii = 2:length(oom)
%     omega=oom(ii);
%     [ff(ii)] = findomegabar(omega,sigma,Re,mu,tauk,delta,upsil,pii,we,gamma,muzstar,lambdaf,alpha,psik,R,psil, ...
%         ksi,chorse,dm,lambdaw,zeta,psiL,sigmaL,taul,tauc,m,chii,theta,sigmaq,b,beta,v,etag,ev,bigtheta,tau,her);
%     if ff(ii)*ff(ii-1) < 0
%         ij=ij+1;
%         II(ij)=ii;
%     end
% end
% if ij > 1 
%     error('(steadysolve) multiple solutions to eq. aa5')
% end
% if ij < 1 
%     error('(steadysolve) no solution to eq. aa5')
% end
% omega1=.0000001; %oom(II(1)-1);
% omega2=0.99; %oom(II(1));
% 
% opt=optimset('diagnostics','on','LevenbergMarquardt','on','TolX',1e-15,'TolFun',1e-15);
% [omegabar,fval,exitflag,output] =   fzero(@findomegabar,[omega1,omega2],opt,sigma,Re,mu,tauk,delta,upsil,pii,we,gamma,muzstar,lambdaf,alpha,psik,R,psil, ...
%         ksi,chorse,dm,lambdaw,zeta,psiL,sigmaL,taul,tauc,m,chii,theta,sigmaq,b,beta,v,etag,ev,bigtheta,tau,her);
% if abs(fval ) > .1e-9 | abs(imag(omega))>.1e-10 | exitflag <= 0
%     error('fatal (steadysolve) failed to find omega')
% end

% [ffom,c,mb,lamz,Fomegabar,Gamma,G,Rk,rk,n,k,w,l,i,y,vk,costs,erz]=findomegar(omegabar,sigma,Re,mu,tauk,delta,upsil,pii,we,gamma,muzstar,lambdaf,alpha,psik,R,psil, ...
%         ksi,chorse,dm,lambdaw,zeta,psiL,sigmaL,taul,tauc,m,chii,theta,sigmaq,b,beta,v,etag,ev,bigtheta,tau,her);

Fomegabar = logncdf(omegabar,-.5*sigma^2,sigma);
z       =   (log(omegabar)+sigma^2/2)/sigma;
Gamma   =   normcdf(z-sigma)+omegabar*(1-normcdf(z));
G       =   normcdf(z-sigma);
hh      =   lognpdf(omegabar,-sigma^2/2,sigma)/(1-Fomegabar);

Rk = -1 + ((1+Re)/(1-mu*omegabar*hh))* (1-Gamma + (Gamma-mu*G)/(1-mu*omegabar*hh) )^(-1);
if Rk <0
    ff=1.e+12
    return
end

rk = ((Rk+1-tauk*delta)*(upsil/pii)-(1-delta))/(1-tauk);

n    =   we/(1-gamma/muzstar*(1+Re)/pii-gamma/(pii*muzstar)*(Rk-Re-mu*(1+Rk)*G)/(1-(1+Rk)/(1+Re)*(Gamma-mu*G)));

k    =   n/(1-((1+Rk)/(1+Re))*(Gamma-mu*G));
if n <0 | k <0
    ff=1.e+12
    return
end

%equation aa1
w  = (lambdaf*(1/(1-alpha))^(1-alpha)*(1/alpha)^alpha*(rk*(1+psik*R))^alpha *(1+psil*R)^(1-alpha))^(-(1/(1-alpha)));
if w <0
    ff=1.e+12
    return
end
%equation aa2
l  = (k/(muzstar*upsil))*((1-alpha)/alpha)*(rk*(1+psik*R)/(w*(1+psil*R)));
if l <0
    ff=1.e+12
    return
end

%equation aa3
i  = k*(1-(1-delta)/(muzstar*upsil));
if i <0
    ff=1.e+12
    return
end

mb = pii*muzstar*(psil*w*l + psik*rk*k/(muzstar*upsil))*(1+tau*her/(1-ksi)) / (her*(1-tau)*(1-m)/(1-ksi)-(1-m+chorse*dm));
if mb <0
    ff=1.e+12
    return
end
lamz = lambdaw*zeta*psiL*l^sigmaL/(w*(1-taul));

% opt=optimset('diagnostics','off','LevenbergMarquardt','on','TolX',1e-15,'TolFun',1e-15);
% [c,fval,exitflag,output] =   fzero(@findc,[0,100],opt,pii,muzstar,dm,tauc,m,chii,theta,sigmaq,b,beta,v,lamz,mb);
% if abs(fval ) > .1e-9 | abs(imag(c))>.1e-10 | exitflag <= 0
%     error('fatal (findomegabar) failed to find c')
% end

aa= ((1+tauc)* ((1/m)^((1-chii)*theta)) * ((1/(1-m))^((1-chii)*(1-theta))) * (1/dm)^chii )^(1-sigmaq);
ff1(2) = (muzstar-b*beta)/(muzstar-b) -(1+tauc)*lamz*c - v*((mb/(pii*muzstar))^(sigmaq-1)) *aa*c^(1-sigmaq);

y = (c+i)/(1-etag);

vk = (y + bigtheta*(1-gamma)*(n-we)/gamma + mu*G*(1+Rk)*k/(muzstar*pii) ) / ( (1/lambdaf)*(k/(muzstar*upsil))^alpha*l^(1-alpha)  );
if vk <0 | vk>1
    ff=1.e+12
    return
end
%equation aa13
costs=psil*w*l+psik*rk*k/(upsil*muzstar);
erz=(1-tau)*(mb/(pii*muzstar))*(1-m)-tau*costs;
ff1(3) = ev - erz/ ( (1-vk)*((k/(upsil*muzstar))^alpha)*(l^(1-alpha)) );


aa= ((1+tauc)* c*(1/m)^((1-chii)*theta) * (1/(1-m))^((1-chii)*(1-theta)) * (1/dm)^chii )^(1-sigmaq);
ff1(4) = v*(1-theta)*(1-chii)*aa*(mb^(sigmaq-2))*(pii*muzstar)^(1-sigmaq)*(1/(1-m)) - lamz*(1/beta - (1+(1-tauD)*Ra)/(pii*muzstar));

ff = (ff1(1)^2 + ff1(2)^2 +ff1(3)^2 +ff1(4)^2)^0.5;


