function [pii,s,rentk,invest,u,omegabar,Retk,n,q,vl,ev,mb,R,uzc,lambdaz,m,Ra,c,w,l,k,kbar,Re,dm,Rm,m3,btot,pstar,wstar, ...
          Fp,Fw,Yz,wplus, ... 
          gov,y,phi,RT,m1,Rb,Pe,currdep,costs,vk,pitarget, ...
          psiL,theta,chii,tau, ...
          xb,ksi,psik,psil,chorse,hkb,her,erz, ...
          sigma,vn,bigtheta,mu,we,Fomegabar,pibar,parameters] = steadystate(rentk,parameters)


entr = parameters(1);
pref = parameters(2);

x = parameters(55);
muzstar = parameters(31);


pibar  = (1+x)/muzstar; %this is an indexing parameter in the price and wage equations with optimal policy, this is a parameter
parameters(65) = pibar;%at this point, we assume we are not optimizing monetary policy. With exogenous policy, 
                     %we set it equal to the steady-state inflation rate.
parameters(68) = (1+x)/muzstar; %pitarget

%the steady state is always computed first for the full CMR model. If entr
%= 0 or -1, the resulting model parameters (remember, some of the
%parameters of the CMR model are endogenous in the steady-state
%calculation) are then used in these alternative formulations.
%Only entr = -1 and entr=3 allow for the possibility that pibar is not equal to 
%steady-state inflation. This is required when considering optimal policy.

opp=1;% if = 1, provide the following interval for R. Otherwise, provide a point estimate for R
if opp == 1
    xxlow  = 0.001; %0.001;
    xxhigh = 0.06; %0.03;
    xxx=[xxlow xxhigh];
else
    xxx= 0.00803063181303;
end

try
opts =optimset('TolFun',1e-15,'TolX',1e-15,'Maxit',1000);

[R,fval,exitflag]=fzero(@findequil,xxx,opts,rentk,parameters);

[ff,ix,pii,Re,Ra,her,Retk,omegabar,sigma,Gamma,G,n,k,invest,w,l,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi, ...
    xb,hkb,gov,y,phi,RT,Rm,dm,vn]  = rkequationn(R,rentk,parameters);

parameters(12) = psiL; %psiL
parameters(21) = sigma; %sigma
parameters(42) = ksi; %ksi
parameters(43) = xb; %xb
parameters(64) = phi;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zzz=0; %implement an algorithm where all deep parameters are considered exogenous
if zzz == 1
    %lld

    [q,u,pii,RT,Re,Retk,omegabar,Fomegabar,Gamma,G,n,k,invest,w,l,y,phi,gov,c,vn,uzc,lambdaz,Ra,her,Rm,dm,mb,m, ...
        erz,ev,hkb,vl,costs,R] = steadyexog(parameters);

    parameters(20) = Fomegabar;
    parameters(13) = m;
    parameters(46) = vl;
    vk=vl;
    parameters(47) = vk;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if R < 0 || sigma<0
    error('fatal (steadystate) non-negativity constraints violated')
end

tau = parameters(54); 
mu  = parameters(22);
Rb = R*her/(tau*her+1);
Pe = mu*G*(1+Retk)*k/(k-n);%external finance premium in steady state
if Rb<0 || Pe<0
    error('fatal(steadystate) Rb<0 or Pe<0')
end

catch
   if entr==1 || entr==2
       disp('error (steadystate) model does not solve' )
       return
   elseif entr == -2 || entr ==-1 || entr==-3 ||entr==-4
       disp('warning (steadystate) model with entr=1 does not solve. However, you are using entr ~1')
       k=1;vk=1;l=1;lambdaz=1;w=1;rentk=1;n=1;pii=1;
   end
end

psil    = parameters(36); 
psik    = parameters(35);
upsil   = parameters(32);
muzstar = parameters(31);
m       = parameters(13);

begin  = parameters(71);
if begin ==1
    btot = psil*w*l + psik*rentk*k/(upsil*muzstar) + (k-n)/(pii*muzstar);%this is total loans scaled by P(t)z*(t)
elseif begin ==0
    btot = psil*w*l + psik*rentk*k/(upsil*muzstar) + (k-n);
end

theta     = parameters(5);
chii      = parameters(14);
bigtheta  = parameters(25);
Fomegabar = parameters(20);
we        = parameters(24);
chorse    = parameters(44);
vl        = parameters(46);
vk        = parameters(47);

alpha     = parameters(34);
lambdaf   = parameters(33);
xip       = parameters(39);
xiw       = parameters(8);
beta      = parameters(7);
taul      = parameters(50);
lambdaw   = parameters(3);
v         = parameters(6);
tauc      = parameters(51);
sigmaq    = parameters(10);

s = 1/lambdaf;

pstar = 1;
wstar = 1;
Yz  = vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))/lambdaf;
Fp  = lambdaz*Yz/(1-beta*xip);
Fw  = (l*(1-taul)*lambdaz/lambdaw)/(1-beta*xiw);
wplus = 1;

if entr == 0  %the benchmark model, minus the entrepreneur
    ppsiL = psiL; %value of psiL used in benchmark model
    kksi  = ksi;
    xxb   = xb;

    [R,ix,pii,Re,Ra,her,Retk,k,invest,w,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi,xb,hkb,gov,y,phi,rentk,RT,Rm,dm] = snoentr(l,parameters);
    
    xx(1) =log(l); %l
    xx(2) =-log(1/parameters(46)-1); %vl
    xx(3) =-log(1/parameters(13)-1); %m
    opts =optimset('TolFun',1e-10,'TolX',1e-10,'Maxit',9000); 
    [xxnew,fval,exitflag]=fminsearch(@sssnoentr,xx,opts,l,parameters,ppsiL,kksi,xxb);
    if abs(fval) > 5.6e-10 | abs(imag(xxnew(1))) > .1e-10 | abs(imag(xxnew(2))) > .1e-10 | abs(imag(xxnew(2))) > .1e-10 |exitflag ~= 1
        error('fatal (steadystate) failed to solve for steady state')
    end
    l  = exp(xxnew(1)); %l
    vl = 1/(1+exp(-xxnew(2))); %vl
    vk = vl; 
    m  = 1/(1+exp(-xxnew(3))); %m
    parameters(46) = vl;
    parameters(47) = vk;
    parameters(13) = m;
    

    [R,ix,pii,Re,Ra,her,Retk,k,invest,w,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi,xb,hkb,gov,y,phi,rentk,RT,Rm,dm] = snoentr(l,parameters);
    
    if Re <0 | Ra<0 | her<0 | Retk<0 | k<0 | invest<0 | c<0 | w<0 | uzc<0 | mb<0 lambdaz<0 | xb<0 | rentk <0 |l<0 | Rm<0 |dm<0 |l<0 | vl<0 |vl>1 | m<0
        error('fatal (steadystate) non negativity constraints violated')
    end
    
    Rb=R*her/(tau*her+1);
    if R < 0 | Rb<0
        error('fatal (steadystate) non-negativity constraints violated')
    end
    
    parameters(12)  = psiL; %psiL
    parameters(42)  = ksi; %ksi
    parameters(43)  = xb; %xb
    parameters(64)  = phi;
    
    theta     = parameters(5);
    chii      = parameters(14);
    chorse    = parameters(44);
    vl        = parameters(46);
    vk        = parameters(47);
    tau       = parameters(54); 

    omegabar=0; n=0; Pe=0; vn=0; sigma=0; bigtheta=0; mu=0; Fomegabar=0; we=0; btot=0;
    parameters(21)  = sigma;
    parameters(25)  = bigtheta;
    parameters(22)  = mu;
    parameters(20)  = Fomegabar;
    parameters(24)  = we;

    pstar = 1;
    wstar = 1;
    Yz  = vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))/lambdaf;
    Fp  = lambdaz*Yz/(1-beta*xip);
    Fw  = (l*(1-taul)*lambdaz/lambdaw)/(1-beta*xiw);
    wplus = 1;

elseif entr == -2  %the benchmark model, minus the entrepreneurs and the banks
    
    psiL = parameters(12);
    
    parameters(5)   = 1; %theta
    parameters(14) = 0; %chii 
    parameters(44) = 0; %chorse
    parameters(46) = 1; %vl
    parameters(47) = 1; %vk
    parameters(52) = 0; %taud
    
    psil=0;
    psik=0;
    parameters(36)=psil; 
    parameters(35)=psik;

    if abs(parameters(52)) > 0
        disp('fatal (steadystate) program not yet ready for taud ~= 0')
    end
       
    vl = 1;
    vk = 1;   
    
    [q,pii,Retk,rentk,R,pstar,wstar,wplus,k,l,lambdaz,m,mb,c,Yz,gov,invest,Fp,Kp,Fw,Kw,uzc,s,phi,w] ...
        = nobanknoentrss(pibar,parameters); 
    y=c+invest+gov;
         
    %convention in this program: l - homogeneous labor, h,L - household labor. In non-distorted steady state, l = L,h.
    
    if w <0 | invest <0 | k <0 | y<0 | c<0 | uzc<0 | lambdaz<0 | mb <0
       error('fatal (steadystate) w or i or k or y or c or uzc<0')
    end
    
    parameters(64)   = phi;
    
    costs = psil*w*l+psik*rentk*k/(upsil*muzstar);
    
    omegabar=0; n=0; Pe=0; vn=0; sigma =0; her= 0; ev= 0; ksi= 0; bigtheta=0; theta=1; chii=0; chorse=0;
    mu=0; Fomegabar=0; we=0; hkb=0; erz=0; tau=0;xb=0; btot=0;Rm=0; Rb=0; Ra=0; dm=0; RT=0; Re=0;m=0;
   
    
    parameters(21)  = sigma;
    parameters(25)  = bigtheta;
    parameters(22)  = mu;
    parameters(20)  = Fomegabar;
    parameters(24)  = we;
    parameters(54)  = tau;
    parameters(42)  = ksi;
    parameters(43)  = xb;
    parameters(13)  = m;

elseif entr ==-3 || entr==-4
    psiL = parameters(12);
    
    parameters(5)   = 1; %theta
    parameters(6)   = 0; % nu
    parameters(14) = 0; %chii 
    parameters(44) = 0; %chorse
    parameters(46) = 1; %vl
    parameters(47) = 1; %vk
    parameters(52) = 0; %taud
        
    psil=0;
    psik=0;
    parameters(36)=psil; 
    parameters(35)=psik;
   
    vl = 1;
    vk = 1;   
    
    tic
    [pii,Retk,rentk,omegabar,sigma,n,k,invest,w,l,c,y,gov,uzc,lambdaz,Re,pstar,wstar,wplus,Fp,Kp,Fw,Kw,s, ...
        Yz,phi,btot,Pe,vn,q,u] = nobanks_ss(pibar,parameters); 
    toc
    %convention in this program: l - homogeneous labor, h,L - household labor. In non-distorted steady state, l = L,h.
    
    if w <0 | invest <0 | k <0 | y<0 | c<0 | uzc<0 | lambdaz<0
       error('fatal (steadystate) w or i or k or y or c or uzc<0')
    end
    
    parameters(64)   = phi;
    parameters(21)  = sigma;
    
    costs = psil*w*l+psik*rentk*k/(upsil*muzstar);
    
    her= 0; ev= 0; ksi= 0; theta=1; chii=0; chorse=0;
    hkb=0; erz=0; tau=0;xb=0; Rm=0; Rb=0; Ra=0; dm=0; R=0; m=0;
       
    parameters(54)  = tau;
    parameters(42)  = ksi;
    parameters(43)  = xb;
    parameters(13)  = m;
end

if entr==0 || entr==1 || entr==2
    if begin ==1
        m3 = mb/(pii*muzstar)*(1+dm) + psil*w*l + psik*rentk*k/(muzstar*upsil);
        m1 = mb/(pii*muzstar)+ psil*w*l + psik*rentk*k/(upsil*muzstar);%this is M1, scaled by Pz*
    elseif begin ==0
        m3 = mb*(1+dm) + psil*w*l + psik*rentk*k/(muzstar*upsil);
        m1 = mb + psil*w*l + psik*rentk*k/(upsil*muzstar);
    end
    currdep = m/(1-m+dm+ psil*pii*muzstar*w*l/mb + psik*pii*rentk*k/(upsil*mb));
elseif entr <0 
    m3=0; m1=0; currdep=0;
end

u = 1;
q = 1;
kbar=k;
pitarget = pii;

