% compute the RBC version of the model. It corresponds at "Step 4" of
% alternative version of the model in the manuscript

clear all
taushock=[8 18];

parameterseuro
rho(22:24,22:24)=[0.95 0 0;0 0 0; 0 0 0];
rho(52:54,52:54)=[1 0 0;0 0 0; 0 0 0];

psiL=61.9045;
N=21; %number of shocks

accuracy= 4.9e-10;

%steadystate
pi=(1+x)/muzstar;
RT=( (muzstar*pi/beta)-1 )* (1/(1-tauD));
Rk=RT*(1-tauD)/(1-tauk);
q=1;
u=1;
rk= upsil*Rk/( (1-tauk)*pi ) - (1-delta)/(1-tauk) - upsil*tauk*delta/((1-tauk)*pi)  + upsil/((1-tauk)*pi);
w=( (1/lambdaf) * ((1/(1-alpha))^(alpha-1)) * ((1/alpha)^(-alpha)) * rk^(-alpha) )^(1/(1-alpha));

num= w*(muzstar-b*beta)*(1-taul) /(muzstar-b);
den1= (1+tauc)*lambdaw*zeta*psiL;
den2= (1-etag)*(1/lambdaf)*(w*alpha/(rk*(1-alpha)))^alpha;
den3= (w*alpha*upsil*muzstar/(rk*(1-alpha)))*(1-(1-delta)/(muzstar*upsil));
l=( num / (den1*(den2-den3)) )^(1/(1+sigmaL));

k= w*alpha*upsil*muzstar*l / (rk*(1-alpha));
i= k*(1-(1-delta)/(muzstar*upsil));
y= (1/lambdaf) * ((k/(muzstar*upsil))^alpha) * l^(1-alpha);
c= (1-etag)*y-i;
lamz= ( 1/(c*(1+tauc)) ) * (muzstar-b*beta)/(muzstar-b);
phi= ((k/(upsil*muzstar))^alpha) * (l^(1-alpha)) * (1-(1/lambdaf));
uzc= (1+tauc)*lamz;
a_prime=rk;
g=etag*y;

%list of variables
% rk(t)
% l(t)
% i(t)
% uzc(t)
% RT(t)
% Rk(t)
% q(t)
% lamz(t)
% w(t)
% c(t)
% k(t+1)

% Linearised equations
alpha_0=zeros(12,12);
alpha_1=zeros(12,12);
alpha_2=zeros(12,12);
beta_0=zeros(12,63);
beta_1=zeros(12,63);

%
alpha_1(1,1) = alpha;
alpha_1(1,10)  = 1-alpha;

beta_1(1,52) = -1; beta_1(1,22)=1;
beta_1(1,1)  = 1;


%
alpha_1(2,1)  = 1; %rk
alpha_1(2,2)  = -(1-alpha); %l
alpha_1(2,4)  = (1-alpha); %u

alpha_2(2,12)  = (1-alpha); %k

beta_1(2,52)  = -1; beta_1(2,22)=1;
beta_1(2,46)  = -(1-alpha);
beta_1(2,1)   = 1;

%
alpha_0(3,3)  = beta*Sdoupr*(muzstar*upsil)^2;

alpha_1(3,8)  = 1;
alpha_1(3,3)  = -Sdoupr*(1+beta)*(muzstar*upsil)^2; 

alpha_2(3,3) = Sdoupr*(muzstar*upsil)^2;

beta_0(3,46) = beta*Sdoupr*(muzstar*upsil)^2;

beta_1(3,46)  = -Sdoupr*(muzstar*upsil)^2;
beta_1(3,19)  = 1;

%
alpha_1(4,1)  = 1;
alpha_1(4,4)  = -sigmaa;

%
alpha_0(5,11)  = -c*b*beta*muzstar / ( (c^2)*(muzstar-b)^2 ) ;

alpha_1(5,5)  = uzc;
alpha_1(5,11)  = c*( (muzstar^2)+beta*(b^2) ) / ( (c^2)*(muzstar-b)^2 ) ;

alpha_2(5,11)  = - c*b*muzstar / ( (c^2)*(muzstar-b)^2 );

beta_0(5,46)  = -b*beta*muzstar*c / (c*(muzstar-b) )^2;

beta_1(5,46) =  ( -muzstar/(c*(muzstar-b)) ) + (muzstar^2)*c / (c*(muzstar-b) )^2;

%
alpha_1(6,9)  = -1;
alpha_1(6,6)  = RT*(1-tauD) / (1+(1-tauD)*RT);

alpha_0(6,9)  = 1;

beta_0(6,46)  = -1;
beta_0(6,43)  = -RT*tauD / (1+(1-tauD)*RT);

%
alpha_1(7,9)  = -1;

alpha_0(7,7)  = Rk*(1-tauk) / (1+(1-tauk)*Rk);
alpha_0(7,9)  = 1;

beta_0(7,46)  = -1;
beta_0(7,43)  = -Rk*tauk / (1+(1-tauk)*Rk);

%
alpha_1(8,7)  = 1;
alpha_1(8,1)  = -pi*(1-tauk)*rk/(upsil*Rk*q);
alpha_1(8,8)  = -(1-delta)*pi/(upsil*Rk);

alpha_2(8,8)  = ( (1-tauk)*rk*pi +(1-delta)*q*pi )/(upsil*Rk*q);

beta_1(8,57)  = (rk*pi*tauk/(upsil*Rk*q)) -delta*tauk/Rk;

%
alpha_1(9,5)  = uzc;
alpha_1(9,9)  = -(1-tauc)*lamz;

beta_1(9,58)  = -lamz*tauc;

%
alpha_1(10,10)  = 1;
alpha_1(10,2)  = -sigmaL;
alpha_1(10,9)  = 1;

beta_1(10,28)  = -taul/(1-taul);
beta_1(10,34)  = -1;

%
u_y = (a_prime*k/(muzstar*upsil))/(y+phi);
c_y = c/(y+phi);
g_y = g/(y+phi);
k_y = k/(y+phi);

alpha_1(11,4)  = u_y -alpha;
alpha_1(11,11) = c_y;
alpha_1(11,3)   = k_y*i/k;
alpha_1(11,2)  =-(1-alpha);

alpha_2(11,12)  = -alpha;

beta_1(11,19)  = -k_y*i/k;
beta_1(11,37)  = g_y;
beta_1(11,52)  = -1; beta_1(11,22)=1;
beta_1(11,46)  =alpha;

%
alpha_1(12,12)  = 1;
alpha_1(12,3)  = -i/k;

alpha_2(12,12)  = -(1-delta)/(muzstar*upsil);

beta_1(12,46)  = (1-delta)/(muzstar*upsil);

%%%%%%%%%%%%
alphas=[alpha_0 alpha_1 alpha_2];
betas=[beta_0 beta_1];

%
taumat   =   ones(12,63); %don't exclude anything
taumat   =   taumat';

%
% M=eye(63);
% ss=[2 3 4 5 8 9 10 11 15 17 20];%these are the shocks that live in unit interval
% sss(1)=tau;
% sss(2)=psil;
% sss(3)=psik;
% sss(4)=xi;
% sss(5)=theta;
% sss(6)=chii;
% sss(7)=taul;
% sss(8)=tauk;
% sss(9)=tauD;
% sss(10)=gamma;
% sss(11)=tauc;
% 
% for ii = 1:length(ss)
%     M((ss(ii)-1)*3+1,(ss(ii)-1)*3+1)=1-sss(ii);
% end    

%%
[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);

oldrho=rho;
oldbetas=betas;
[B,P,rho,betas] = findandcheckB(A,alphas,oldrho,taushock,taumat,oldbetas);

if max(max(abs(imag(A)))) > 1e-12
    error('fatal (solvemodel) A complex')
end
if max(max(abs(imag(B)))) > 2e-12
    error('fatal (solvemodel) B complex')
end

A=real(A);
B=real(B);
B1=B(:,[1:3*N]);
B2=B(:,[3*N+1:2*3*N]);

Time=20;

%printshocks

%RR = impulres(A,B,P,Time,D,rhop,etap,x,Taylor);
%%%%

Impuls=[];
[zxz,zxz]=size(P);
[n1,N]=size(D);

if zxz ~= 2*n1
    error('fatal (impulres) parameters of D and P don''t match properly')
end

eps0 = zeros(zxz,1);
epsbar = zeros(N,1);

epsbar(18)= 0.1;
epsbar(8)= 0.1;
    
eps0=[D*epsbar; zeros(3*N,1)];

shock(:,[1])=eps0;
z1(:,[1])=B*eps0;
Resp=[z1(:,[1]); shock(52,[1])]; 
for t=2:Time,
    shock(:,[t])=P*shock(:,[t-1]);
    z1(:,[t])=A*z1(:,[t-1])+B*shock(:,[t]);
    Respp=[z1(:,[t]);shock(52,[t])];
    Resp=[Resp,Respp]; 
end

RR=[Impuls;Resp];

%%%
if max(max(abs(imag(RR)))) > .1e-10
    error('fatal (simulate) simulated data complex')
end
RR=real(RR);
[n1,n2]=size(rho);
[bv,bvn]=size(A);

SameA=0; %if it is 0, axis for each plot are chosen as default; if it is set to 1, same axis on each plot

givenames; %this calls the list of variables and shocks
variables= [];
variables(1,:)  = 'rk    ';
variables(2,:)  = 'l     ';
variables(3,:)  = 'i     ';
variables(4,:)  = 'u     ';
variables(5,:)  = 'ucz   ';
variables(6,:)  = 'RT    ';
variables(7,:)  = 'Rk    ';
variables(8,:)  = 'q     ';
variables(9,:)  = 'Lamz  ';
variables(10,:) = 'w     ';
variables(11,:) = 'c     ';
variables(12,:) = 'K(t+1)';

[righe,colonne]=size(RR);
tt=1:colonne;

mar=.1;
VV = [0 tt min(min(RR'))+mar max(max(RR'))+mar ];

taushock=[18];
dd=13; %number of variables to be plotted
%for jjj =1:length(taushock)  % we have 21 shocks
    %jaj=taushock(jjj);
    %sss=dd*(jaj-1);
    %pltstuff %%%%%%%%%%%%%%%%%  to be checked
    %String1=['Response to a shock in ' texlabel(nameshocks(jjj,:))];
    %figure('Name',[String1]);
    
    
    figure
    for iii=1:dd, 
        subplot(4,4,iii)
        hold;
        if SameA==1, axis(VV); end;
        plot(tt,RR(iii,:))
        set (gca,'XTick',[0 20])
        grid on
        if (iii) ~= (bv+1),
            title([texlabel(variables(iii,:))]);
        elseif (iii) == (bv+1),
            title([texlabel(shockss(18,:))]);
        end;
        
        hold 
    end
    
    %str=['sigmaq = ',num2str(sigmaq),'pref=',num2str(pref)];
    %String1=['Figure 7: Response to a Permanent Shock to Technology'];
    String1=['Response to a shock in ' texlabel(nameshocks(18,:))];
    hout=suptitle(String1);
    
    %end