
% option(4) = 40; %maximum number of iterations (15000 by default)
% option(5) = 1;  %in order to print intermediate results
% 
% [xxnew,fval,options] = solvopt(xx,'ssloglik',[],option,[],[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
%     taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
%     tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
% 
% xx=xxnew;
% save([outfolder '\maxlike'], 'xx', 'xxnew', 'par');
% 
optionals = optimset('LevenbergMarquardt','on','Display','iter','TolFun',1e-10,'TolX',1e-10,'MaxFun',5000,'Diagnostics','on','MaxFunEvals',5000,'MaxIter',5000);

[xxnew,fval,exitflag] = fminsearch(@ssloglik,xx,optionals,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

xx_fminsearch=xxnew;
xx=xxnew
save([outfolder '\maxlike'], 'xx', 'xx_fminsearch', 'par');


optionals = optimset('LevenbergMarquardt','on','GradObj','on','Hessian','on','HessUpdate','bfgs','Display','iter','TolFun',1e-10,'TolX',1e-10,'MaxFun',100,'Diagnostics','on','MaxFunEvals',100);

[xxnew,fval,exitflag,report,QQ,Hess] = fminunc(@sslogliktest,xx,optionals,par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
    tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

xx_opt=xxnew;
xx=xxnew
save([outfolder '\maxlike'], 'xx_opt', '-append');


Hess = hessian_2s('ssloglik',xx',[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev,taushock,Pe,G,Gp, ...
    omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2, ...
    size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);

save([outfolder '\maxlike'], 'Hess', '-append');





% option(4) = 50; %maximum number of iterations (15000 by default)
% option(5) = 1;  %in order to print intermediate results
% 
% Xdat_long = Xdat;
% for ji=1:11
%     Xdat=Xdat_long(:,1:105-ji*2); 
% [xxnew,fval,options] = solvopt(xx,'ssloglik',[],option,[],[],par,taumat,her,Rb,Re,c,y,i,mb, w,l,k,n,pi,g,ev, ...
%     taushock,Pe,G,Gp,omegabar,Rk,Gs,fdiff,Xdat,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar, ...
%     tauvar2,size_a,size_b,prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params);
% 
% xx=xxnew;
% xxxx(ji,:)=xx;
% end
% 
