function [duration,rho,phi,xb,psiL,ksi,sigmaL,v,sigmaq,theta,Hdoupr,b,xiw,lambdaw,muzstar,Sdoupr,sigmaa,xip,psik,psil,delta,alpha,lambdaf, ...
        gamma,mu,sigma,tau,tauc,tauk,taul,we,x,tauT,tauD,zeta, ...
        vl,Fomegabar,beta,xi,pi,R,Re,Ra,her,Rk,rk,omegabar,Gamma,G,n,k,i,w,l,c,uzc,m,mb,lambdaz,costs,erz,ev, ...
        hkb,g,y,Rb,Pe,Gammap,Gammadp,Gammas,Gammaps,Gp,Gdp,Gs,Gps,lambda,lamz,params,Taylor,forward,money,rhobank, ...
        q,s,u,Rm,dm,chii,vn,RT,upsil,chorse,bigtheta,muup,m3,m1,currdep,D,etag,eps_shock,entr,util,costreal, ...
        static,parstoch,etai,parstoch1,parstoch2,stdshocks1,stdshocks2,btot] = untitled_2(taushock,chii)

% This file computes the steady state using the 
% one dimensionsal search algorithm described in the text,
% in which some economically exogenous variables are endogenous.
% The search is now set up, so that rk is fixed, and the variable
% that is adjusted is R, which is denoted below by xx.

parameterseuro

if entr == -1  %the benchmark model, minus the entrepreneurs and the banks
    
    theta =0; %if entr=-1, banks' liabilities such as demand deposits do not exist
    chii=0; %if entr=-1, bank's liabilities such as saving deposits (dm) do not exist
    chorse=0;
    psik=0; psil=0;
    vl=1; vk=vl; %when banks are dropped, vk=vl=1
    R=0;
    
    [q,pi,Re,RT,rk,Rk,w,u,k,i,y,phi,g,c,uzc,mb,lambdaz,psiL0] = ssnobank(l,x,muzstar,beta,tauT,tauD,tauk,delta,alpha,psik,psil, ...
        vk,etag,b,lambdaf,entr,upsil,R,pref,v,sigmaq,tauc,taul,lambdaw,zeta,sigmaL);
    
    opts =optimset('TolFun',1e-10,'TolX',1e-10,'Maxit',1000);
    [l,fval,exitflag]=fminsearch(@sssnobank,l,opts,x,muzstar,beta,tauT,tauD,tauk,delta,alpha,psik,psil, ...
        vk,etag,b,lambdaf,entr,upsil,R,pref,v,sigmaq,tauc,taul,lambdaw,zeta,sigmaL,psiL);
    if abs(fval) > 5.6e-10 | abs(imag(l)) > .1e-10 | l<0 | exitflag ~= 1
        error('fatal (steadystate) failed to solve for steady state')
    end
    
    [q,pi,Re,RT,rk,Rk,w,u,k,i,y,phi,g,c,uzc,mb,lambdaz,psiL] = ssnobank(l,x,muzstar,beta,tauT,tauD,tauk,delta,alpha,psik,psil, ...
        vk,etag,b,lambdaf,entr,upsil,R,pref,v,sigmaq,tauc,taul,lambdaw,zeta,sigmaL);
    if w <0 | i <0 | k <0 | y<0 | c<0 | uzc<0 | lambdaz<0 | mb <0
       error('fatal (helpp) w or i or k or y or c or uzc<0')
    end
    
    Rm=0; Rb=0; Ra=0; m=0;dm=0;
    
    costs=psil*w*l+psik*rk*k/(upsil*muzstar);
    
    params(8)=psik;
    params(9)=psiL;
    params(31)=m;
    params(21)=theta;
    params(32)=vl;
    params(33)=vk;
    params(57)=chii;
    params(58)=chorse;
    params(59)=bigtheta;
    
    omegabar=0; n=0; Pe=0; vn=0; sigma =0; her= 0; ev= 0; ksi= 0; xi=ksi; bigtheta=0; 
    mu=0; Fomegabar=0; we=0; hkb=0; erz=0; tau=0;xb=0; btot=0;
    
elseif entr == 0  %the benchmark model, minus the entrepreneur
    ppsiL=params(36); %value of psiL used in benchmark model
    kksi=params(37);
    xxb=params(38);

    [R,ix,pi,Re,Ra,her,Rk,k,i,w,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi,xb,hkb,g,y,phi,rk,RT,Rm,dm] = snoentr(params);
    
    xx(1) =log(params(15)); %l
    xx(2) =-log(1/params(32)-1); %vl
    xx(3) =-log(1/params(31)-1); %m
    opts =optimset('TolFun',1e-15,'TolX',1e-15,'Maxit',3000); 
    [xxnew,fval,exitflag]=fminsearch(@sssnoentr,xx,opts,params,ppsiL,kksi,xxb);
    if abs(fval) > 5.6e-10 | abs(imag(xxnew(1))) > .1e-10 | abs(imag(xxnew(2))) > .1e-10 | abs(imag(xxnew(2))) > .1e-10 |exitflag ~= 1
        error('fatal (steadystate) failed to solve for steady state')
    end
    params(15)=exp(xxnew(1)); %l
    params(32)=1/(1+exp(-xxnew(2))); %vl
    params(33)=1/(1+exp(-xxnew(2))); %vk
    params(31)=1/(1+exp(-xxnew(3))); %m

    [R,ix,pi,Re,Ra,her,Rk,k,i,w,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi,xb,hkb,g,y,phi,rk,RT,Rm,dm] = snoentr(params);
    params(30)=R;
    
    l=params(15);
    vl=params(32);
    vk=vl;
    m=params(31);
    if Re <0 | Ra<0 | her<0 | Rk<0 | k<0 | i<0 | c<0 | w<0 | uzc<0 | mb<0 lambdaz<0 | xb<0 | rk <0 |l<0 | Rm<0 |dm<0 |l<0 | vl<0 |vl>1 | m<0
        error('fatal (steadystate) non negativity constraints violated')
    end
    
    Rb=R*her/(tau*her+1);
    if R < 0 | Rb<0 
        error('fatal (steadystate) non-negativity constraints violated')
    end
    
    omegabar=0; n=0; Pe=0; vn=0; sigma=0; bigtheta=0; mu=0; Fomegabar=0; we=0; btot=0;
    
elseif entr == 1%the benchmark model
    xxlow  = 0.001; %0.001;  
    xxhigh = 0.06; %0.03; 
    
    %try to bracket the solution
    %[ff] = findequil(xxlow,rk,params);
    %[ff1] = findequil(xxhigh,rk,params);
    %
    %if ff*ff1 > 0
    %    error('fatal (steadystate) failed to bracket solution')
    %end
    
    opts =optimset('TolFun',1e-15,'TolX',1e-15,'Maxit',1000);
    [R,fval,exitflag]=fzero(@findequil,[xxlow,xxhigh],opts,rk,params);
    
    params(30)=R;
    
    [ff,ix,pi,Re,Ra,her,Rk,omegabar,sigma,Gamma,G,n,k,i,w,l,c,uzc,mb,lambdaz,costs,psiL,erz,ev,ksi, ...
        xb,hkb,g,y,phi,RT,Rm,dm,vn]  = rkequationn(rk,params);
    if R < 0 | sigma<0
        error('fatal (steadystate) non-negativity constraints violated')
    end

    zzz=0; %implement the algorithm described in the manuscript where all deep parameters are considered exogenous
    if zzz == 1
        
        lld
        
        %try to bracket the solution
        rklow  = 0.04195; %0.04194999;
        rkhigh = 0.041951;
        [ffrk1,q,u,pi,RT,Re,Rk,omegabar,Fomegabar,Gamma,G,n,k,i, ...
            w,l,y,phi,g,c,vn,uzc,lambdaz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl,costs,R] = steadysolve(rklow,params,sigma);
         
         [ffrk2,q,u,pi,RT,Re,Rk,omegabar,Fomegabar,Gamma,G,n,k,i, ...
             w,l,y,phi,g,c,vn,uzc,lambdaz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl,costs,R] = steadysolve(rkhigh,params,sigma);
%         if ffrk1*ffrk2 > 0
%             error('fatal (steadystate) failed to bracket solution for rk')
%         end       
        
        opts =optimset('TolFun',1e-10,'TolX',1e-10,'Maxit',1000);
        [rk,fval,exitflag]=fzero(@ssteadysolve,[rklow,rkhigh],opts,params,sigma);
        if exitflag < 0 | abs(fval) > .5e-8 | abs(imag(rk)) > .1e-10 | rk<0
            error('fatal (steadystate) rk<0')
        end

        [ffrk,q,u,pi,RT,Re,Rk,omegabar,Fomegabar,Gamma,G,n,k,i, ...
            w,l,y,phi,g,c,vn,uzc,lambdaz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl,costs,R] = steadysolve(rk,params,sigma);
        
        params(1) = Fomegabar;
        params(31) = m;
        params(32) = vl;
        vk=vl;
        params(33) = vk;
    end
    Rb=R*her/(tau*her+1);
    Pe=mu*G*(1+Rk)*k/(k-n);%external finance premium in steady state
    if Rb<0 | Pe<0
        error('fatal(steadystate) Rb<0 or Pe<0')
    end
    
    btot = psil*w*l + psik*rk*k/(upsil*muzstar) + (k-n)/(pi*muzstar);%this is total loans scaled by P(t)z*(t)

end

xi=ksi;
m3 = (mb/(pi*muzstar))*(1+dm) + psil*w*l + psik*rk*k/(muzstar*upsil);
m1=(mb/(pi*muzstar))* (1+psil*pi*muzstar*w*l/mb + psik*pi*rk*k/(mb*upsil));%this is M1, scaled by Pz*
currdep=m/(1-m+dm+ psil*pi*muzstar*w*l/mb + psik*pi*rk*k/(upsil*mb));

params(15)=l;
params(30)=R;
params(36)=psiL;
params(37)=ksi;
params(38)=xb;
params(41)=rk;
params(42)=sigma;
params(43)=phi;
params(44)=y;
params(45)=her;
s=1/lambdaf;
u=1;
q=1;
lamz=lambdaz;
kbar=k;

if entr == -1; 
    nn=16;
elseif entr == 1; 
    nn=28; %benchmark model
elseif entr == 0; 
    nn=25;
end

params(48)=nn;
xp=params(40);

if entr == 1
    [Gamma,Gammap,Gammadp,Gammas,Gammaps,G,Gp,Gdp,Gs,Gps,lambda] = const(omegabar,sigma,mu);
else
    Gamma=0; Gammap=0; Gammadp=0; Gammas=0; Gammaps=0; G=0; Gp=0; Gdp=0; Gs=0; Gps=0; lambda=0;
end

